#ifndef BIRD_CREATE_BACKGROUND_H_
#define BIRD_CREATE_BACKGROUND_H_

#include <gtkmm.h>

#include "basestage.h"
#include "createbase.h"

#define CREATE_BACKGROUND_WIDTH_MAX 10000
#define CREATE_BACKGROUND_HEIGHT_MAX 10000

#define CREATE_BACKGROUND_PX1 400
#define CREATE_BACKGROUND_PY1 210
#define CREATE_BACKGROUND_MX1 0
#define CREATE_BACKGROUND_MY1 0
#define CREATE_BACKGROUND_SX1 300
#define CREATE_BACKGROUND_SY1 160
#define CREATE_BACKGROUND_SF1 15
#define CREATE_BACKGROUND_LF1 FONT_LINE_CENTER
#define CREATE_BACKGROUND_TF1 FONT_SERIF
#define CREATE_BACKGROUND_FF1 FONT_FACE_BOLD

#define CREATE_BACKGROUND_DW1 5
#define CREATE_BACKGROUND_DH1 5

#define CREATE_BACKGROUND_PX2 820
#define CREATE_BACKGROUND_PY2 100
#define CREATE_BACKGROUND_MX2 200
#define CREATE_BACKGROUND_MY2 150
#define CREATE_BACKGROUND_SX2 80
#define CREATE_BACKGROUND_SY2 50
#define CREATE_BACKGROUND_SF2 15
#define CREATE_BACKGROUND_LF2 FONT_LINE_CENTER
#define CREATE_BACKGROUND_TF2 FONT_SERIF
#define CREATE_BACKGROUND_FF2 FONT_FACE_BOLD

#define CREATE_BACKGROUND_DW2 5
#define CREATE_BACKGROUND_DH2 5

#define CREATE_BACKGROUND_PX3 400
#define CREATE_BACKGROUND_PY3 520
#define CREATE_BACKGROUND_MX3 0
#define CREATE_BACKGROUND_MY3 0
#define CREATE_BACKGROUND_SX3 300
#define CREATE_BACKGROUND_SY3 110
#define CREATE_BACKGROUND_SF3 15

#define CREATE_BACKGROUND_DW3 5
#define CREATE_BACKGROUND_DH3 5

#define CREATE_BACKGROUND_PX4 400
#define CREATE_BACKGROUND_PY4 810
#define CREATE_BACKGROUND_MX4 0
#define CREATE_BACKGROUND_MY4 0
#define CREATE_BACKGROUND_SX4 300
#define CREATE_BACKGROUND_SY4 140
#define CREATE_BACKGROUND_SF4 15
#define CREATE_BACKGROUND_LF4 FONT_LINE_CENTER
#define CREATE_BACKGROUND_TF4 FONT_SERIF
#define CREATE_BACKGROUND_FF4 FONT_FACE_BOLD

#define CREATE_BACKGROUND_DW4 5
#define CREATE_BACKGROUND_DH4 5

#define CREATE_BACKGROUND_STRUCT 0
#define CREATE_BACKGROUND_MENU 1
#define CREATE_BACKGROUND_NUM 2

#define CREATE_BACKGROUND_MENU_LOAD 0
#define CREATE_BACKGROUND_MENU_TOP 1
#define CREATE_BACKGROUND_MENU_NUM 2 

#define CREATE_BACKGROUND_STRUCT_SIZE 0
#define CREATE_BACKGROUND_STRUCT_INTERVAL 1
#define CREATE_BACKGROUND_STRUCT_DISTANCE 2
#define CREATE_BACKGROUND_STRUCT_NUM 2

#define CREATE_BGSIZE_PX1 150
#define CREATE_BGSIZE_PY1 160
#define CREATE_BGSIZE_MX1 0
#define CREATE_BGSIZE_MY1 50
#define CREATE_BGSIZE_SX1 0
#define CREATE_BGSIZE_SY1 0
#define CREATE_BGSIZE_SF1 12
#define CREATE_BGSIZE_LF1 FONT_LINE_LEFT
#define CREATE_BGSIZE_TF1 FONT_SERIF
#define CREATE_BGSIZE_FF1 FONT_FACE_BOLD

#define CREATE_BGSIZE_PX2 260
#define CREATE_BGSIZE_PY2 160
#define CREATE_BGSIZE_MX2 0
#define CREATE_BGSIZE_MY2 50
#define CREATE_BGSIZE_SX2 0
#define CREATE_BGSIZE_SY2 0
#define CREATE_BGSIZE_SF2 12
#define CREATE_BGSIZE_LF2 CREATE_BGSIZE_LF1
#define CREATE_BGSIZE_TF2 CREATE_BGSIZE_TF1
#define CREATE_BGSIZE_FF2 CREATE_BGSIZE_FF1

#define CREATE_BGSIZE_PX3 450
#define CREATE_BGSIZE_PY3 160
#define CREATE_BGSIZE_MX3 0
#define CREATE_BGSIZE_MY3 50
#define CREATE_BGSIZE_SX3 0
#define CREATE_BGSIZE_SY3 0
#define CREATE_BGSIZE_SF3 12
#define CREATE_BGSIZE_LF3 CREATE_BGSIZE_LF1
#define CREATE_BGSIZE_TF3 CREATE_BGSIZE_TF1
#define CREATE_BGSIZE_FF3 CREATE_BGSIZE_FF1

#define CREATE_BGSIZE_WIDTH 0
#define CREATE_BGSIZE_HEIGHT 1
#define CREATE_BGSIZE_ROTATE 2
#define CREATE_BGSIZE_FLIP 3
#define CREATE_BGSIZE_NUM 4

#define CREATE_BGINTERVAL_PX1 150
#define CREATE_BGINTERVAL_PY1 520
#define CREATE_BGINTERVAL_MX1 0
#define CREATE_BGINTERVAL_MY1 50
#define CREATE_BGINTERVAL_SX1 0
#define CREATE_BGINTERVAL_SY1 0
#define CREATE_BGINTERVAL_SF1 12
#define CREATE_BGINTERVAL_LF1 FONT_LINE_LEFT
#define CREATE_BGINTERVAL_TF1 FONT_SERIF
#define CREATE_BGINTERVAL_FF1 FONT_FACE_BOLD

#define CREATE_BGINTERVAL_PX2 280
#define CREATE_BGINTERVAL_PY2 520
#define CREATE_BGINTERVAL_MX2 0
#define CREATE_BGINTERVAL_MY2 50
#define CREATE_BGINTERVAL_SX2 0
#define CREATE_BGINTERVAL_SY2 0
#define CREATE_BGINTERVAL_SF2 12
#define CREATE_BGINTERVAL_LF2 CREATE_BGINTERVAL_LF1
#define CREATE_BGINTERVAL_TF2 CREATE_BGINTERVAL_TF1
#define CREATE_BGINTERVAL_FF2 CREATE_BGINTERVAL_FF1

#define CREATE_BGINTERVAL_XINTERVAL 0
#define CREATE_BGINTERVAL_YINTERVAL 1
#define CREATE_BGINTERVAL_NUM 2

#define CREATE_BGDISTANCE_PX1 150
#define CREATE_BGDISTANCE_PY1 780
#define CREATE_BGDISTANCE_MX1 250
#define CREATE_BGDISTANCE_MY1 50
#define CREATE_BGDISTANCE_SX1 0
#define CREATE_BGDISTANCE_SY1 0
#define CREATE_BGDISTANCE_SF1 12
#define CREATE_BGDISTANCE_LF1 FONT_LINE_LEFT
#define CREATE_BGDISTANCE_TF1 FONT_SERIF
#define CREATE_BGDISTANCE_FF1 FONT_FACE_BOLD

#define CREATE_BGDISTANCE_PX2 260
#define CREATE_BGDISTANCE_PY2 780
#define CREATE_BGDISTANCE_MX2 250
#define CREATE_BGDISTANCE_MY2 50
#define CREATE_BGDISTANCE_SX2 0
#define CREATE_BGDISTANCE_SY2 0
#define CREATE_BGDISTANCE_SF2 CREATE_BGDISTANCE_SF1
#define CREATE_BGDISTANCE_LF2 CREATE_BGDISTANCE_LF1
#define CREATE_BGDISTANCE_TF2 CREATE_BGDISTANCE_TF1
#define CREATE_BGDISTANCE_FF2 CREATE_BGDISTANCE_FF1

#define CREATE_BGDISTANCE_HX 0
#define CREATE_BGDISTANCE_HY 1
#define CREATE_BGDISTANCE_HNUM 2

#define CREATE_BGDISTANCE_VSTART 0
#define CREATE_BGDISTANCE_VMAX 1
#define CREATE_BGDISTANCE_VMOV 2
#define CREATE_BGDISTANCE_VNUM 3

#define CREATE_BACKGROUND_SHIFT_MENU 0
#define CREATE_BACKGROUND_SHIFT_SIZE 1
#define CREATE_BACKGROUND_SHIFT_INTERVAL 2
#define CREATE_BACKGROUND_SHIFT_DISTANCE 3 
#define CREATE_BACKGROUND_SHIFT_NUM 4 

class CreateBackGround : public CreateBase{
 private:
  std::string rotateName[STAGE_BG_ROTATE_NUM];
  std::string flipName[STAGE_BG_FLIP_NUM];
  public:
  int maxInterX;
  int maxInterY;
  int rotateFlag;
  CreateBackGround();
  ~CreateBackGround();
  void Create();

  void LoadSelect();
  void TopSelect();

  static void(CreateBackGround::*CREATE_BACKGROUND_MENU_SELECT
	      [CREATE_BACKGROUND_MENU_NUM])();

  void MenuSelect();
  void SizeSelect();
  void IntervalSelect();

  static void(CreateBackGround::*CREATE_BACKGROUND_STRUCT_SELECT
	      [CREATE_BACKGROUND_STRUCT_NUM])();

  void StructSelect();

  static void(CreateBackGround::*CREATE_BACKGROUND_SELECT
	      [CREATE_BACKGROUND_NUM])();
    
  void ShiftMenu();

  void ShiftRotate0();
  void ShiftRotate90();
  void ShiftRotate180();
  void ShiftRotate270();

  static void(CreateBackGround::*CREATE_BGSIZE_ROTATE_SELECT
	      [STAGE_BG_ROTATE_NUM])();

  void ShiftSize();
  void ShiftInterval();

  static void (CreateBackGround::*CREATE_BACKGROUND_SHIFT_SELECT
	       [CREATE_BACKGROUND_SHIFT_NUM])();

  void Rotate0View(int *width,int *height);
  void Rotate90View(int *width,int *height);
  void Rotate180View(int *width,int *height);
  void Rotate270View(int *width,int *height);

  static void(CreateBackGround::*CREATE_BG_ROTATE_VIEW
	[STAGE_BG_ROTATE_NUM])(int *width,int *height);

  void BGDistanceText(int px1,int py1,int px2,int py2,Gdk::Color *color0,
		      std::string name,std::string value);
  void BGSizeText(int px1,int py1,int px2,int py2,Gdk::Color *color0,
		      std::string name,std::string value);
  void BGIntervalText(int px1,int py1,int px2,int py2,Gdk::Color *color0,
		      std::string name,std::string value);

  void Menu();

  int CalcMaxXInterval();
  int CalcMaxYInterval();
};


#endif
