#include"createmodal.h"

CreateModal::CreateModal(){

  StructPY[CREATE_MODALST_SPEEDX]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*0;
  StructPY[CREATE_MODALST_SPEEDY]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*1;
  StructPY[CREATE_MODALST_MINW]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*2;
  StructPY[CREATE_MODALST_MAXW]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*3;
  StructPY[CREATE_MODALST_MINH]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*4;
  StructPY[CREATE_MODALST_MAXH]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*5;
  StructPY[CREATE_MODALST_CRFREQ]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*6;
  StructPY[CREATE_MODALST_NLAND]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*7;
  StructPY[CREATE_MODALST_INDEXLAND]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*9;
  StructPY[CREATE_MODALST_INDEXCR]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*11;
  StructPY[CREATE_MODALST_ALLCROWD]
    =CREATE_MODALST_PY1+CREATE_MODALST_MY1*12;
}

CreateModal::~CreateModal(){

}

void CreateModal::Create(){

}

void CreateModal::ModalTimeLineSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_TIMELINE;  
}
void CreateModal::ModalLandSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_LAND;
}
void CreateModal::ModalCrowdSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_CROWD;
}
void CreateModal::ModalTopSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_TOP;
}
void CreateModal::ModalCopySelect(){
  Map->valueX[CREATE_VX_MODAL_SHIFTTYPE]=CREATE_MODAL_SHIFT_COPY;
  Map->valueX[CREATE_VX_STATE_MODAL]=CREATE_VY_MODAL_LPLACE;
}

void CreateModal::ModalLoadSelect(){
  Glib::ustring path,path0;
  Glib::ustring file;
  Glib::ustring name;
  Glib::ustring folder;
  int position;
  int crowdFlag;
  int landFlag;
  int modalFlag;
  int stageFlag;

  Gtk::FileChooserDialog diag
    ("LOAD MODAL",Gtk::FILE_CHOOSER_ACTION_OPEN);
  diag.add_button(Gtk::Stock::OPEN,Gtk::RESPONSE_OK);
  diag.add_button(Gtk::Stock::CANCEL,Gtk::RESPONSE_CANCEL);
  diag.set_icon(mIcon);
  
  Gtk::FileFilter filt;
  filt.set_name("modal");
  filt.add_pattern("*.modal");
  diag.add_filter(filt);

  path0=diag.get_current_folder();

  path=path0+"/stage";

  if(diag.set_current_folder(path)){
    std::cout<<"FIND FOLDER:"<<path<<std::endl;
  }
  else{
    std::cout<<"FALSE FOLDER:"<<diag.get_current_folder()<<std::endl;
  }

  switch( diag.run() ){

  case Gtk::RESPONSE_OK:
    file=diag.get_filename();
    folder=diag.get_current_folder();
    name=file;
    name.erase(name.find(folder,0),folder.size()+1);
    name.erase(name.find(".modal",0),6);

    if(folder.find(path0,0)!=std::string::npos){
      folder.erase(folder.find(path0,0),path0.size()+1);
    }

    std::cout<<"FILE:"<<file<<std::endl;
    std::cout<<"FOLDER:"<<folder<<std::endl;
    std::cout<<"NAME:"<<name<<std::endl;

    modalFlag=baseStage->LoadModal
      (Glib::locale_from_utf8(folder),Glib::locale_from_utf8(name));
    if(modalFlag!=0){
      std::cout<<"ERROR LOAD MODAL"<<std::endl;
    }
    break;
    
  case Gtk::RESPONSE_CANCEL:
    break;
  }
 
  diag.show();
  diag.resize(200,100);
}
void (CreateModal::*CREATE_MODAL_RIGHT_SELECT[CREATE_MODAL_RNUM])()={
  &CreateModal::ModalTimeLineSelect,
  &CreateModal::ModalLandSelect,
  &CreateModal::ModalCrowdSelect,
  &CreateModal::ModalTopSelect,
  &CreateModal::ModalCopySelect,
  &CreateModal::ModalLoadSelect
};

void CreateModal::ModalLeftSelect(){
  StageModal *modal;
  
  modal=&(baseStage->mModal[Map->valueY[CREATE_VY_MODAL_LPLACE]]);

  Map->state=CREATE_STATE_MODALST;
  Map->valueY[CREATE_VY_STATE_MODALST]=CREATE_VX_MODALST_SPEEDX;
  
  Map->valueX[CREATE_VX_MODALST_SPEEDX]=modal->speedX*-1;
  Map->valueX[CREATE_VX_MODALST_SPEEDY]=modal->speedY;
  Map->valueX[CREATE_VX_MODALST_MINW]=modal->minW;
  Map->valueX[CREATE_VX_MODALST_MAXW]=modal->maxW;
  Map->valueX[CREATE_VX_MODALST_MINH]=modal->minH;
  Map->valueX[CREATE_VX_MODALST_MAXH]=modal->maxH;
  Map->valueX[CREATE_VX_MODALST_CRFREQ]=modal->crowdFreq;
  Map->valueX[CREATE_VX_MODALST_NLAND]=modal->nLand;
  
  Map->valueX[CREATE_VX_MODALST_INDEXCR]=0;
  Map->valueX[CREATE_VX_MODALST_ALLCROWD]=0;
  Map->valueX[CREATE_VX_MODALST_INDEXLAND]=0;
}
void CreateModal::ModalRightSelect(){
  (this->*CREATE_MODAL_RIGHT_SELECT
   [Map->valueY[CREATE_VY_MODAL_RPLACE]])();
}

void (CreateModal::*CREATE_MODAL_PLACE_SELECT[CREATE_MODAL_NPLACE])()={
  &CreateModal::ModalLeftSelect,
  &CreateModal::ModalRightSelect
};

void CreateModal::ShiftModalSelect(){
  baseStage->VariableSelectAction
    (&Map->valueX[CREATE_VX_STATE_MODAL],
     &Map->valueY[Map->valueX[CREATE_VX_STATE_MODAL]],
     SELECTKEY_VARIABLE100);
  
  if(Map->valueX[CREATE_VX_STATE_MODAL]<CREATE_VY_MODAL_LPLACE){
    Map->valueX[CREATE_VX_STATE_MODAL]=CREATE_VY_MODAL_RPLACE;
  }
  else if(Map->valueX[CREATE_VX_STATE_MODAL]>CREATE_VY_MODAL_RPLACE){
    Map->valueX[CREATE_VX_STATE_MODAL]=CREATE_VY_MODAL_LPLACE;
  }

  if(Map->valueX[CREATE_VX_STATE_MODAL]==CREATE_VY_MODAL_LPLACE){
    if(Map->valueY[CREATE_VY_MODAL_LPLACE]<1){
      Map->valueY[CREATE_VY_MODAL_LPLACE]=CREATE_MODAL_WAITMAP-1;
      Map->keyCount=1;
    }
    else if(Map->valueY[CREATE_VY_MODAL_LPLACE]>=CREATE_MODAL_WAITMAP){
      Map->valueY[CREATE_VY_MODAL_LPLACE]=1;
      Map->keyCount=1;
    }
  }
  else if(Map->valueX[CREATE_VX_STATE_MODAL]==CREATE_VY_MODAL_RPLACE){
    if(Map->valueY[CREATE_VY_MODAL_RPLACE]<0){
      Map->valueY[CREATE_VY_MODAL_RPLACE]=CREATE_MODAL_RNUM-1;
    }
    else if(Map->valueY[CREATE_VY_MODAL_RPLACE]>=CREATE_MODAL_RNUM){
      Map->valueY[CREATE_VY_MODAL_RPLACE]=0;
    }
  }

  if(control->okValue){
    control->okValue=0;
    (this->*CREATE_MODAL_PLACE_SELECT
     [Map->valueX[CREATE_VX_STATE_MODAL]-CREATE_VY_MODAL_LPLACE])();
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=Map->state0;
  }
  if(Map->state==Map->state0){
    Map->state0=CREATE_STATE_TOP;
  }
}

void CreateModal::ShiftModalCopy(){
  int px0,py0;
  std::stringstream ss;
  std::string str;
  StageModal *modal1;
  StageModal *modal2;
  int i;

  if(Map->valueY[CREATE_VY_MODAL_COPY]!=0){
    ss<<"COPY : "<<Map->valueY[CREATE_VY_MODAL_COPY];
    px0=WIDTH*(1000)/MAP_XMAX;
    py0=HEIGHT*(1000)/MAP_YMAX;
    str=ss.str(); 
    text->DrawString
      (str,(color->white),px0,py0,
       FONT_LINE_DOWNRIGHT,15,
       FONT_SERIF,FONT_FACE_BOLD);
    ss.str("");
    ss.clear(std::stringstream::goodbit);
  }

  baseStage->VariableSelectAction
    ( &Map->valueX[CREATE_VX_STATE_MODAL],
      &Map->valueY[CREATE_VY_MODAL_LPLACE],
      SELECTKEY_VARIABLE10);
  
  if(Map->valueX[CREATE_VX_STATE_MODAL]!=CREATE_VY_MODAL_LPLACE){
    Map->valueX[CREATE_VX_STATE_MODAL]=CREATE_VY_MODAL_LPLACE;
  }

  if(Map->valueX[CREATE_VX_STATE_MODAL]==CREATE_VY_MODAL_LPLACE){
    if(Map->valueY[CREATE_VY_MODAL_LPLACE]<1){
      Map->valueY[CREATE_VY_MODAL_LPLACE]=STAGE_MODAL_MAX-1;
      Map->keyCount=1;
    }
    else if(Map->valueY[CREATE_VY_MODAL_LPLACE]>=STAGE_MODAL_MAX){
      Map->valueY[CREATE_VY_MODAL_LPLACE]=1;
      Map->keyCount=1;
    }
  }

  if(control->okValue){
    control->okValue=0;
    if(Map->valueY[CREATE_VY_MODAL_COPY]==0){
      Map->valueY[CREATE_VY_MODAL_COPY]
	=Map->valueY[CREATE_VY_MODAL_LPLACE];
    }
    else{
      modal1=&(baseStage->mModal[Map->valueY[CREATE_VY_MODAL_LPLACE]]);
      modal2=&(baseStage->mModal[Map->valueY[CREATE_VY_MODAL_COPY]]);

      modal1->speedX=modal2->speedX;
      modal1->speedY=modal2->speedY;
      modal1->minW=modal2->minW;
      modal1->maxW=modal2->maxW;
      modal1->minH=modal2->minH;
      modal1->maxH=modal2->maxH;
      modal1->crowdFreq=modal2->crowdFreq;
      modal1->nLand=modal2->nLand;
      
      i=0;
      while(i<MODAL_CROWD_MAX){
	modal1->indexCrowd[i]=modal2->indexCrowd[i];
	i++;
      }
      i=0;
      while(i<MODAL_LAND_MAX){
	modal1->indexLand[i]=modal2->indexLand[i];
	i++;
      }
      Map->valueX[CREATE_VX_MODAL_SHIFTTYPE]=CREATE_MODAL_SHIFT_EDIT;
      Map->valueY[CREATE_VY_MODAL_COPY]=0;
    }
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->valueX[CREATE_VX_MODAL_SHIFTTYPE]=CREATE_MODAL_SHIFT_EDIT;
    Map->valueY[CREATE_VY_MODAL_COPY]=0;

  }
}

void CreateModal::StructReturnSelect(){
  Map->state=CREATE_STATE_MODAL;
}
void CreateModal::StructIndexCrowdSelect(){
  Map->state=CREATE_STATE_CROWDINDEX;
}
void CreateModal::StructIndexLandSelect(){
  Map->state=CREATE_STATE_LANDINDEX;
}

void (CreateModal::*CREATE_MODALST_SELECT[CREATE_MODALST_NUM])()={
  &CreateModal::StructReturnSelect,
  &CreateModal::StructReturnSelect,
  &CreateModal::StructReturnSelect,
  &CreateModal::StructReturnSelect,
  &CreateModal::StructReturnSelect,
  &CreateModal::StructReturnSelect,
  &CreateModal::StructReturnSelect,
  &CreateModal::StructReturnSelect,
  &CreateModal::StructIndexLandSelect,
  &CreateModal::StructIndexCrowdSelect,
  &CreateModal::StructIndexCrowdSelect

};

void CreateModal::ModalStructSpeedXRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_SPEEDX]<-32){
    Map->valueX[CREATE_VX_MODALST_SPEEDX]=-32;
  }
  else if(Map->valueX[CREATE_VX_MODALST_SPEEDX]>32){
    Map->valueX[CREATE_VX_MODALST_SPEEDX]=32;
  }
  modal->speedX=Map->valueX[CREATE_VX_MODALST_SPEEDX]*-1;
}
void CreateModal::ModalStructSpeedYRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_SPEEDY]<-16){
    Map->valueX[CREATE_VX_MODALST_SPEEDY]=-16;
  }
  else if(Map->valueX[CREATE_VX_MODALST_SPEEDY]>16){
    Map->valueX[CREATE_VX_MODALST_SPEEDY]=16;
  }
  modal->speedY=Map->valueX[CREATE_VX_MODALST_SPEEDY];
}
void CreateModal::ModalStructMinWRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_MINW]<-1000){
    Map->valueX[CREATE_VX_MODALST_MINW]=-1000;
  }
  else if(Map->valueX[CREATE_VX_MODALST_MINW]>=
	  Map->valueX[CREATE_VX_MODALST_MAXW]){
    Map->valueX[CREATE_VX_MODALST_MINW]
      =Map->valueX[CREATE_VX_MODALST_MAXW]-1;
  }
  modal->minW=Map->valueX[CREATE_VX_MODALST_MINW];
}
void CreateModal::ModalStructMaxWRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_MAXW]<=
     Map->valueX[CREATE_VX_MODALST_MINW]){
    Map->valueX[CREATE_VX_MODALST_MAXW]
      =Map->valueX[CREATE_VX_MODALST_MINW]+1;
  }
  else if(Map->valueX[CREATE_VX_MODALST_MAXW]>2000){
    Map->valueX[CREATE_VX_MODALST_MAXW]=2000;
  }
  modal->maxW=Map->valueX[CREATE_VX_MODALST_MAXW];
}
void CreateModal::ModalStructMinHRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_MINH]<-1000){
    Map->valueX[CREATE_VX_MODALST_MINH]=-1000;
  }
  else if(Map->valueX[CREATE_VX_MODALST_MINH]>=
	  Map->valueX[CREATE_VX_MODALST_MAXH]){
    Map->valueX[CREATE_VX_MODALST_MINH]
      =Map->valueX[CREATE_VX_MODALST_MAXH]-1;
  }
  modal->minH=Map->valueX[CREATE_VX_MODALST_MINH];
}
void CreateModal::ModalStructMaxHRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_MAXH]<=
     Map->valueX[CREATE_VX_MODALST_MINH]){
    Map->valueX[CREATE_VX_MODALST_MAXH]
      =Map->valueX[CREATE_VX_MODALST_MINH]+1;
  }
  else if(Map->valueX[CREATE_VX_MODALST_MAXH]>2000){
    Map->valueX[CREATE_VX_MODALST_MAXH]=2000;
  }
  modal->maxH=Map->valueX[CREATE_VX_MODALST_MAXH];
}
void CreateModal::ModalStructCrowdFreqRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_CRFREQ]<0){
    Map->valueX[CREATE_VX_MODALST_CRFREQ]=0;
  }
  else if(Map->valueX[CREATE_VX_MODALST_CRFREQ]>1000){
    Map->valueX[CREATE_VX_MODALST_CRFREQ]=1000;
  }
  modal->crowdFreq=Map->valueX[CREATE_VX_MODALST_CRFREQ];
}
void CreateModal::ModalStructNLandRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_NLAND]<0){
    Map->valueX[CREATE_VX_MODALST_NLAND]=0;
  }
  else if(Map->valueX[CREATE_VX_MODALST_NLAND]>MODAL_LAND_MAX){
    Map->valueX[CREATE_VX_MODALST_NLAND]=MODAL_LAND_MAX;
  }
  modal->nLand=Map->valueX[CREATE_VX_MODALST_NLAND];
}
void CreateModal::ModalStructIndexLandRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_INDEXLAND]<0){
    Map->valueX[CREATE_VX_MODALST_INDEXLAND]=0;
  }
  else if(Map->valueX[CREATE_VX_MODALST_INDEXLAND]>=
	  Map->valueX[CREATE_VX_MODALST_NLAND]){
    Map->valueX[CREATE_VX_MODALST_INDEXLAND]
      =Map->valueX[CREATE_VX_MODALST_NLAND]-1;
  }
}
void CreateModal::ModalStructIndexCrowdRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_INDEXCR]<0){
    Map->valueX[CREATE_VX_MODALST_INDEXCR]=0;
  }
  else if(Map->valueX[CREATE_VX_MODALST_INDEXCR]>=MODAL_CROWD_MAX){
    Map->valueX[CREATE_VX_MODALST_INDEXCR]=MODAL_CROWD_MAX-1;
  }
}
void CreateModal::ModalStructALLCrowdRange(StageModal *modal){
  if(Map->valueX[CREATE_VX_MODALST_ALLCROWD]!=0){
    Map->valueX[CREATE_VX_MODALST_ALLCROWD]=0;
  }
}

void (CreateModal::*CREATE_MODALST_RANGE[CREATE_MODALST_NUM])
  (StageModal *modal)={
    &CreateModal::ModalStructSpeedXRange,
    &CreateModal::ModalStructSpeedYRange,
    &CreateModal::ModalStructMinWRange,
    &CreateModal::ModalStructMaxWRange,
    &CreateModal::ModalStructMinHRange,
    &CreateModal::ModalStructMaxHRange,
    &CreateModal::ModalStructCrowdFreqRange,
    &CreateModal::ModalStructNLandRange,
    &CreateModal::ModalStructIndexLandRange,
    &CreateModal::ModalStructIndexCrowdRange,
    &CreateModal::ModalStructALLCrowdRange
};

void CreateModal::ShiftModalStruct(){
  int px,py;

  baseStage->VariableSelectAction
    (&Map->valueX[Map->valueY[CREATE_VY_STATE_MODALST]],
     &Map->valueY[CREATE_VY_STATE_MODALST],
     SELECTKEY_VARIABLE10);

  if(Map->valueY[CREATE_VY_STATE_MODALST]<CREATE_VX_MODALST_SPEEDX){
    Map->valueY[CREATE_VY_STATE_MODALST]=CREATE_VX_MODALST_ALLCROWD;
  }
  else if(Map->valueY[CREATE_VY_STATE_MODALST]>
	  CREATE_VX_MODALST_ALLCROWD){
    Map->valueY[CREATE_VY_STATE_MODALST]=CREATE_VX_MODALST_SPEEDX;
  }
  
  (this->*CREATE_MODALST_RANGE
   [Map->valueY[CREATE_VY_STATE_MODALST]-CREATE_VX_MODALST_SPEEDX])
    (&(baseStage->mModal[Map->valueY[CREATE_VY_MODAL_LPLACE]]));
  
  px=WIDTH*(115)/MAP_XMAX;
  py=HEIGHT*
    (StructPY[Map->valueY[CREATE_VY_STATE_MODALST]
	      -CREATE_VX_MODALST_SPEEDX])/MAP_YMAX;

  enemyList->DrawSprite(EN_HOM_BIRD,EN_WAY_B,1,px,py);

  if(control->okValue){
    control->okValue=0;

    (this->*CREATE_MODALST_SELECT
     [Map->valueY[CREATE_VY_STATE_MODALST]-CREATE_VX_MODALST_SPEEDX])();
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=CREATE_STATE_MODAL;
    Map->valueY[CREATE_VY_STATE_MODALST]=CREATE_VX_MODALST_SPEEDX;
  }
}

void CreateModal::ShiftCrowdIndex(){
  int px,py,i;
  
  baseStage->VariableSelectAction
    (&Map->valueX[CREATE_VX_STATE_CROWDINDEX],
     &Map->valueY[CREATE_VY_STATE_CROWDINDEX],
     SELECTKEY_VARIABLE100);

  if(Map->valueY[CREATE_VY_STATE_CROWDINDEX]!=0){
    Map->valueY[CREATE_VY_STATE_CROWDINDEX]=0;
  }

  if(Map->valueX[CREATE_VX_STATE_CROWDINDEX]<0){
    Map->valueX[CREATE_VX_STATE_CROWDINDEX]=STAGE_CROWD_MAX-1;
    Map->keyCount=1;
  }
  else if(Map->valueX[CREATE_VX_STATE_CROWDINDEX]>=STAGE_CROWD_MAX){
    Map->valueX[CREATE_VX_STATE_CROWDINDEX]=0;
    Map->keyCount=1;
  }

  CrowdIndexMap(0,WIDTH,HEIGHT*4/5,HEIGHT);
  
  if(control->okValue){
    control->okValue=0;
    if(Map->valueY[CREATE_VY_STATE_MODALST]==
       CREATE_VX_MODALST_INDEXCR){
      (baseStage->mModal[Map->valueY[CREATE_VY_MODAL_LPLACE]]).
	indexCrowd[Map->valueX[CREATE_VX_MODALST_INDEXCR]]
	=Map->valueX[CREATE_VX_STATE_CROWDINDEX];
    }
    if(Map->valueY[CREATE_VY_STATE_MODALST]==
       CREATE_VX_MODALST_ALLCROWD){
      i=0;
      while(i<MODAL_CROWD_MAX){
	(baseStage->mModal[Map->valueY[CREATE_VY_MODAL_LPLACE]]).
	  indexCrowd[i]
	  =Map->valueX[CREATE_VX_STATE_CROWDINDEX];
	i++;
      }
    }
    Map->state=CREATE_STATE_MODALST;
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=CREATE_STATE_MODALST;
  }
}

void CreateModal::ShiftLandIndex(){
  int px,py;
  
  baseStage->VariableSelectAction
    (&Map->valueX[CREATE_VX_STATE_LANDINDEX],
     &Map->valueY[CREATE_VY_STATE_LANDINDEX],
     SELECTKEY_VARIABLE100);

  if(Map->valueY[CREATE_VY_STATE_LANDINDEX]!=0){
    Map->valueY[CREATE_VY_STATE_LANDINDEX]=0;
  }

  if(Map->valueX[CREATE_VX_STATE_LANDINDEX]<0){
    Map->valueX[CREATE_VX_STATE_LANDINDEX]=STAGE_LAND_MAX-1;
    Map->keyCount=1;
  }
  else if(Map->valueX[CREATE_VX_STATE_LANDINDEX]>=STAGE_LAND_MAX){
    Map->valueX[CREATE_VX_STATE_LANDINDEX]=0;
    Map->keyCount=1;
  }

  LandIndexMap(0,WIDTH,HEIGHT*4/5,HEIGHT);
  
  if(control->okValue){
    control->okValue=0;
    
    (baseStage->mModal[Map->valueY[CREATE_VY_MODAL_LPLACE]]).
      indexLand[Map->valueX[CREATE_VX_MODALST_INDEXLAND]]
      =Map->valueX[CREATE_VX_STATE_LANDINDEX];

    Map->state=CREATE_STATE_MODALST;
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=CREATE_STATE_MODALST;
  }
}

void CreateModal::IndexCrowdView(int num,int index){
  std::stringstream ss;
  std::string str;
  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  ss<<num+1;
  str=ss.str(); 
  text->DrawDownCenter
    (str,*(color->white),
     WIDTH*(CREATE_MODALST_PX3+CREATE_MODALST_MX3*num)/MAP_XMAX,
     HEIGHT*(CREATE_MODALST_PY3)/MAP_YMAX-CREATE_MODALST_SY3,
     10,FONT_TIMES);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  cursorB[0]=Map->valueX[CREATE_VX_MODALST_INDEXCR];
  cursorB0[0]=num;
  cursorB[1]=Map->valueY[CREATE_VY_STATE_MODALST];
  cursorB0[1]=CREATE_VX_MODALST_INDEXCR;
  
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_RED,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_YELLOW,
	      CREATE_GC_SKY),
     true,
     WIDTH*(CREATE_MODALST_PX3+CREATE_MODALST_MX3*num)/MAP_XMAX
     -CREATE_MODALST_SX3,
     HEIGHT*(CREATE_MODALST_PY3)/MAP_YMAX
     -CREATE_MODALST_SY3,
     CREATE_MODALST_SX3*2,
     CREATE_MODALST_SY3*2);
  
  ScaleCrowd(WIDTH*(CREATE_MODALST_PX3
		    +CREATE_MODALST_MX3*num)/MAP_XMAX,
	     HEIGHT*(CREATE_MODALST_PY3)/MAP_YMAX,
	     (baseStage->mCrowd[index]).type/CROWD_WAY_NUM,
	     (baseStage->mCrowd[index]).type%CROWD_WAY_NUM,
	     CREATE_MODALST_SX3*2,CREATE_MODALST_SY3*2);

  ss<<index;
  str=ss.str(); 
  text->DrawCenter
    (str,*(color->white),
     WIDTH*(CREATE_MODALST_PX3+CREATE_MODALST_MX3*num)/MAP_XMAX,
     HEIGHT*(CREATE_MODALST_PY3)/MAP_YMAX,
     10,FONT_TIMES);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
}

void CreateModal::IndexLandView(int num,int index){
  std::stringstream ss;
  std::string str;  
  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  ss<<num+1;
  str=ss.str(); 
  text->DrawDownCenter
    (str,*(color->white),
     WIDTH*(CREATE_MODALST_PX4+CREATE_MODALST_MX4*num)/MAP_XMAX,
     HEIGHT*(CREATE_MODALST_PY4)/MAP_YMAX-CREATE_MODALST_SY4,
     10,FONT_TIMES);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  cursorB[0]=Map->valueX[CREATE_VX_MODALST_INDEXLAND];
  cursorB0[0]=num;
  cursorB[1]=Map->valueY[CREATE_VY_STATE_MODALST];
  cursorB0[1]=CREATE_VX_MODALST_INDEXLAND;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_RED,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_YELLOW,
	      CREATE_GC_SKY),
     true,
     WIDTH*(CREATE_MODALST_PX4+CREATE_MODALST_MX4*num)/MAP_XMAX
     -CREATE_MODALST_SX4,
     HEIGHT*(CREATE_MODALST_PY4)/MAP_YMAX
     -CREATE_MODALST_SY4,
     CREATE_MODALST_SX4*2,
     CREATE_MODALST_SY4*2);
 


  DrawLandView
    ((baseStage->mLand[index]).type,(baseStage->mLand[index]).color,
     WIDTH*(CREATE_MODALST_PX4+CREATE_MODALST_MX4*num)/MAP_XMAX,
     HEIGHT*(CREATE_MODALST_PY4)/MAP_YMAX,
     CREATE_MODALST_SX4*2,CREATE_MODALST_SY4*2);

  ss<<index;
  str=ss.str(); 
  text->DrawCenter
    (str,*(color->white),
     WIDTH*(CREATE_MODALST_PX4+CREATE_MODALST_MX4*num)/MAP_XMAX,
     HEIGHT*(CREATE_MODALST_PY4)/MAP_YMAX,
     10,FONT_TIMES);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

}

void CreateModal::ModalStructText(int px1,int py1,int px2,int py2,
				 Gdk::Color *color0,
				 std::string name,std::string value){
  int px0,py0;

  px0=px1;
  py0=py1;
  text->DrawString
    (name,color0,px0,py0,
     CREATE_MODALST_LF1,CREATE_MODALST_SF1,
     CREATE_MODALST_TF1,CREATE_MODALST_FF1);
  px0=px2;
  py0=py1;
  text->DrawString
    (value,color0,px0,py0,
     CREATE_MODALST_LF1,CREATE_MODALST_SF1+1,
     CREATE_MODALST_TF1,CREATE_MODALST_FF1);
}

void CreateModal::ModalMenu(){
  int px0,py0,sx0,sy0;
  int px1,py1,px2,py2;
  std::stringstream ss;
  std::string str;  
  Gdk::Color *color0;
  StageModal *modal;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  RunWoodBG(0,0,WIDTH,HEIGHT);

  cursorA[0]=CREATE_MODAL_TLINE;
  cursorA0[0]=CREATE_MODAL_COPY;
  cursorA[1]=Map->valueX[CREATE_VX_MODAL_SHIFTTYPE];
  cursorA0[1]=CREATE_MODAL_SHIFT_COPY;

  cursorB[0]=Map->valueY[CREATE_VY_MODAL_RPLACE];
  cursorB0[0]=CREATE_MODAL_TLINE;
  cursorB[1]=Map->valueX[CREATE_VX_STATE_MODAL];
  cursorB0[1]=CREATE_VY_MODAL_RPLACE;

  px0=WIDTH*(CREATE_MODAL_PX2-CREATE_MODAL_SX2)/MAP_XMAX;
  py0=HEIGHT*(CREATE_MODAL_PY2-CREATE_MODAL_SY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_TLINE)/MAP_YMAX;
  sx0=WIDTH*(CREATE_MODAL_SX2*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_MODAL_SY2*2)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_MODAL_DW2,py0+CREATE_MODAL_DH2,
	    sx0-CREATE_MODAL_DW2*2,sy0-CREATE_MODAL_DH2*2);

  cursorA[0]=CREATE_MODAL_LAND;
  cursorB0[0]=CREATE_MODAL_LAND;
  py0=HEIGHT*(CREATE_MODAL_PY2-CREATE_MODAL_SY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_LAND)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_MODAL_DW2,py0+CREATE_MODAL_DH2,
	    sx0-CREATE_MODAL_DW2*2,sy0-CREATE_MODAL_DH2*2);

  cursorA[0]=CREATE_MODAL_CROWD;
  cursorB0[0]=CREATE_MODAL_CROWD;
  py0=HEIGHT*(CREATE_MODAL_PY2-CREATE_MODAL_SY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_CROWD)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_MODAL_DW2,py0+CREATE_MODAL_DH2,
	    sx0-CREATE_MODAL_DW2*2,sy0-CREATE_MODAL_DH2*2);

  cursorA[0]=CREATE_MODAL_TOP;
  cursorB0[0]=CREATE_MODAL_TOP;
  py0=HEIGHT*(CREATE_MODAL_PY2-CREATE_MODAL_SY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_TOP)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_MODAL_DW2,py0+CREATE_MODAL_DH2,
	    sx0-CREATE_MODAL_DW2*2,sy0-CREATE_MODAL_DH2*2);
  
  cursorA[0]=CREATE_MODAL_COPY;
  cursorB0[0]=CREATE_MODAL_COPY;
  py0=HEIGHT*(CREATE_MODAL_PY2-CREATE_MODAL_SY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_COPY)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_MODAL_DW2,py0+CREATE_MODAL_DH2,
	    sx0-CREATE_MODAL_DW2*2,sy0-CREATE_MODAL_DH2*2);

  cursorA[0]=CREATE_MODAL_LOAD;
  cursorB0[0]=CREATE_MODAL_LOAD;
  py0=HEIGHT*(CREATE_MODAL_PY2-CREATE_MODAL_SY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_LOAD)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_MODAL_DW2,py0+CREATE_MODAL_DH2,
	    sx0-CREATE_MODAL_DW2*2,sy0-CREATE_MODAL_DH2*2);
  
  px1=WIDTH*(CREATE_MODAL_PX2)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(CREATE_MODAL_PY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_TLINE)/MAP_YMAX;
  text->DrawString
    ("TIMELINE",(color->black),px0,py0,
     CREATE_MODAL_LF2,CREATE_MODAL_SF2,
     CREATE_MODAL_TF2,CREATE_MODAL_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_MODAL_PY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_LAND)/MAP_YMAX;
  text->DrawString
    ("LAND",(color->black),px0,py0,
     CREATE_MODAL_LF2,CREATE_MODAL_SF2,
     CREATE_MODAL_TF2,CREATE_MODAL_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_MODAL_PY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_CROWD)/MAP_YMAX;
  text->DrawString
    ("CROWD",(color->black),px0,py0,
     CREATE_MODAL_LF2,CREATE_MODAL_SF2,
     CREATE_MODAL_TF2,CREATE_MODAL_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_MODAL_PY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_TOP)/MAP_YMAX;
  text->DrawString
    ("TOP",(color->black),px0,py0,
     CREATE_MODAL_LF2,CREATE_MODAL_SF2,
     CREATE_MODAL_TF2,CREATE_MODAL_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_MODAL_PY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_COPY)/MAP_YMAX;
  text->DrawString
    ("COPY",(color->black),px0,py0,
     CREATE_MODAL_LF2,CREATE_MODAL_SF2,
     CREATE_MODAL_TF2,CREATE_MODAL_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_MODAL_PY2
	      +CREATE_MODAL_MY2*CREATE_MODAL_LOAD)/MAP_YMAX;
  text->DrawString
    ("LOAD",(color->black),px0,py0,
     CREATE_MODAL_LF2,CREATE_MODAL_SF2,
     CREATE_MODAL_TF2,CREATE_MODAL_FF2);

  px0=WIDTH*(CREATE_MODAL_PX2)/MAP_XMAX;
  py0=HEIGHT*(950)/MAP_YMAX;
  text->DrawString
    ("MODAL",(color->white),px0,py0,
     FONT_LINE_DOWNCENTER,25,
     FONT_SERIF,FONT_FACE_ITALIC);

  cursorA[0]=Map->valueY[CREATE_VY_MODAL_LPLACE];
  cursorA0[0]=Map->valueY[CREATE_VY_MODAL_COPY];
  cursorA[1]=Map->valueX[CREATE_VX_MODAL_SHIFTTYPE];
  cursorA0[1]=CREATE_MODAL_SHIFT_COPY;

  cursorB[0]=Map->valueX[CREATE_VX_STATE_MODAL];
  cursorB0[0]=CREATE_VY_MODAL_LPLACE;

  px0=WIDTH*(CREATE_MODAL_PX1-CREATE_MODAL_SX1)/MAP_XMAX;
  py0=HEIGHT*(CREATE_MODAL_PY1-CREATE_MODAL_SY1
	      +CREATE_MODAL_MY1*0)/MAP_YMAX;
  sx0=WIDTH*(CREATE_MODAL_SX1*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_MODAL_SY1*2)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],2,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],1,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_MODAL_DW1,py0+CREATE_MODAL_DH1,
	    sx0-CREATE_MODAL_DW1*2,sy0-CREATE_MODAL_DH1*2);

  px0=WIDTH*(CREATE_MODAL_PX1-CREATE_MODAL_SX1)/MAP_XMAX;
  py0=HEIGHT*(CREATE_MODAL_PY1)/MAP_YMAX;
  ss<<Map->valueY[CREATE_VY_MODAL_LPLACE]<<":";
  str=ss.str(); 
  text->DrawString
    (str,(color->white),px0,py0,
     CREATE_MODAL_LF1,CREATE_MODAL_SF1,
     CREATE_MODAL_TF1,CREATE_MODAL_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  modal=&(baseStage->mModal[Map->valueY[CREATE_VY_MODAL_LPLACE]]);

  cursorB[0]=Map->valueY[CREATE_VY_STATE_MODALST];
  cursorB0[0]=CREATE_VX_MODALST_SPEEDX;
  cursorB[1]=Map->state;
  cursorB0[1]=CREATE_STATE_MODALST;

  px1=WIDTH*(CREATE_MODALST_PX1)/MAP_XMAX;
  px2=WIDTH*(CREATE_MODALST_PX2)/MAP_XMAX;
  py1=HEIGHT*(StructPY[CREATE_MODALST_SPEEDX])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  ss<<": "<<modal->speedX*-1;
  str=ss.str(); 
  ModalStructText(px1,py1,px2,0,color0,"Speed X",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_MODALST_SPEEDY;
  py1=HEIGHT*(StructPY[CREATE_MODALST_SPEEDY])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  ss<<": "<<modal->speedY;
  str=ss.str(); 
  ModalStructText(px1,py1,px2,0,color0,"Speed Y",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_MODALST_MINW;
  py1=HEIGHT*(StructPY[CREATE_MODALST_MINW])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  ss<<": "<<modal->minW/10<<"."<<abs(modal->minW%10)<<"%";
  str=ss.str(); 
  ModalStructText(px1,py1,px2,0,color0,"Min W",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_MODALST_MAXW;
  py1=HEIGHT*(StructPY[CREATE_MODALST_MAXW])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  ss<<": "<<modal->maxW/10<<"."<<abs(modal->maxW%10)<<"%";
  str=ss.str(); 
  ModalStructText(px1,py1,px2,0,color0,"Max W",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_MODALST_MINH;
  py1=HEIGHT*(StructPY[CREATE_MODALST_MINH])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  ss<<": "<<modal->minH/10<<"."<<abs(modal->minH%10)<<"%";
  str=ss.str();
  ModalStructText(px1,py1,px2,0,color0,"Min H",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
    
  cursorB0[0]=CREATE_VX_MODALST_MAXH;
  py1=HEIGHT*(StructPY[CREATE_MODALST_MAXH])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  ss<<": "<<modal->maxH/10<<"."<<abs(modal->maxH%10)<<"%";
  str=ss.str(); 
  ModalStructText(px1,py1,px2,0,color0,"Max H",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_MODALST_CRFREQ;
  py1=HEIGHT*(StructPY[CREATE_MODALST_CRFREQ])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  ss<<": "<<modal->crowdFreq/10<<"."<<abs(modal->crowdFreq%10)<<"%";
  str=ss.str(); 
  ModalStructText(px1,py1,px2,0,color0,"CrowdFreq",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_MODALST_NLAND;
  py1=HEIGHT*(StructPY[CREATE_MODALST_NLAND])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  ss<<": "<<modal->nLand;
  str=ss.str(); 
  ModalStructText(px1,py1,px2,0,color0,"N LAND",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  cursorB0[0]=CREATE_VX_MODALST_INDEXLAND;
  py1=HEIGHT*(StructPY[CREATE_MODALST_INDEXLAND])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  px0=px1;
  py0=py1;
  text->DrawString("IndexLand",color0,px0,py0,
		   CREATE_MODALST_LF1,CREATE_MODALST_SF1,
		   CREATE_MODALST_TF1,CREATE_MODALST_FF1);

  cursorB0[0]=CREATE_VX_MODALST_INDEXCR;
  py1=HEIGHT*(StructPY[CREATE_MODALST_INDEXCR])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  px0=px1;
  py0=py1;
  text->DrawString("IndexCrowd",color0,px0,py0,
		   CREATE_MODALST_LF1,CREATE_MODALST_SF1,
		   CREATE_MODALST_TF1,CREATE_MODALST_FF1);

  cursorB0[0]=CREATE_VX_MODALST_ALLCROWD;
  py1=HEIGHT*(StructPY[CREATE_MODALST_ALLCROWD])/MAP_YMAX;
  color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
		     &cursorB[0],&cursorB0[0],2,color->yellow,
		     color->white);
  px0=px1;
  py0=py1;
  text->DrawString("ALL Crowd",color0,px0,py0,
		   CREATE_MODALST_LF1,CREATE_MODALST_SF1,
		   CREATE_MODALST_TF1,CREATE_MODALST_FF1);

  int i;
  i=0;
  while(i<10){
    IndexCrowdView(i,modal->indexCrowd[i]);
    i++;
  }
  i=0;
  while(i<modal->nLand){
    IndexLandView(i,modal->indexLand[i]);
    i++;
  }

  frame->draw_rectangle
    (blackGC,true,
     WIDTH*(480)/MAP_XMAX,
     HEIGHT*(200)/MAP_YMAX,
     WIDTH*(100)/MAP_XMAX,
     HEIGHT*(100)/MAP_YMAX);

  frame->draw_rectangle
    (yellowGC,false,
     WIDTH*(380+(modal->minW+1000)/10)/MAP_XMAX,
     HEIGHT*(100+(modal->minH+1000)/10)/MAP_YMAX,
     WIDTH*((modal->maxW-modal->minW)/10)/MAP_XMAX,
     HEIGHT*((modal->maxH-modal->minH)/10)/MAP_YMAX);

  if(Map->state==CREATE_STATE_MODAL){
    if(Map->valueX[CREATE_VX_MODAL_SHIFTTYPE]==CREATE_MODAL_SHIFT_EDIT){
      ShiftModalSelect();
    }
    else if(Map->valueX[CREATE_VX_MODAL_SHIFTTYPE]==
	    CREATE_MODAL_SHIFT_COPY){
      ShiftModalCopy();
    }
  }
  else if(Map->state==CREATE_STATE_MODALST){
    ShiftModalStruct();
  }
  else if(Map->state==CREATE_STATE_CROWDINDEX){
    ShiftCrowdIndex();
  }
  else if(Map->state==CREATE_STATE_LANDINDEX){
    ShiftLandIndex();
  }
  

  mWindow->invalidate_rect(rect,false);
}


