#include "rhoumbus.h"

RhoumList::RhoumList(){
  listSize=0;
  first=NULL;
  end=NULL;
}

RhoumList::~RhoumList(){
  ALLDelete();
}

void RhoumList::Append(BirdRhoum *node){
  if(end==NULL){
    std::cout<<"APPEND FIRST"<<std::endl;
    first=node;
    end=node;
    node->next=NULL;
    node->prev=NULL;
  }
  else{
    //   std::cout<<"APPEND NORMAL"<<std::endl;
    if(end->next==NULL){
      end->next=node;
      node->prev=end;
      node->next=NULL;
      end=node;
    }
    else{
      //     std::cout<<"APPEND ERROR"<<std::endl;
    }
  }
  listSize++;
}

void RhoumList::Prepend(BirdRhoum *node){
  if(first==NULL){
    first=node;
    end=node;
    node->prev=NULL;
    node->next=NULL;
  }
  else{
    node->next=first;
    node->prev=NULL;
    first->prev=node;
    first=node;
  }
  listSize++;
}

void RhoumList::Insert(BirdRhoum *node,BirdRhoum *target){
  if(target->prev==NULL){
    node->next=target;
    node->prev=NULL;
    target->prev=node;
    first=node;
  }
  else{
    node->next=target;
    node->prev=target->prev;
    (target->prev)->next=node;
    target->prev=node;
  }
  listSize++;
}

void RhoumList::Reject(BirdRhoum *node){
  if(node->next==NULL){
      if(node->prev==NULL){
	//	std::cout<<"ALL REJECT"<<std::endl;
	first=NULL;
	end=NULL;
      }
      else{
	//	std::cout<<"END REJECT"<<std::endl;
	(node->prev)->next=NULL;
	end=node->prev;
      }
  }
  else{
    if(node->prev==NULL){
      /*
      std::cout<<"REJECT FIRST"<<std::endl;
      std::cout<<"NODE_NEXT :"<<(node->next)->num<<std::endl;
      */
      (node->next)->prev=NULL;
      first=node->next;
    }
    else{
      /*
	std::cout<<"REJECT NORMAL"<<std::endl;
      std::cout<<"NODE_NEXT :"<<(node->next)->num<<std::endl;
      std::cout<<"NODE_PREV :"<<(node->prev)->num<<std::endl;
      */
      (node->next)->prev=node->prev;
      (node->prev)->next=node->next;
    }
  }
  listSize--;
}

void RhoumList::ALLDelete(){
  BirdRhoum *node;
  BirdRhoum *tmp;

  node=first;
  while(node){
    tmp=node->next;
    RhoumList::Reject(node);
    delete node;
    node=tmp;
  }
  if(listSize==0){
    std::cout<<"RHOUM ALL DELETE!"<<std::endl;  
  }
  else{
       std::cout<<"RHOUM ERROR NO ALL DELETE"<<std::endl;
  }
}
