#include "color.h"

BirdColor::BirdColor(){
  
  mColor=Gdk::rgb_get_colormap();

  white= new Gdk::Color("white");
  black= new Gdk::Color("black");
  red= new Gdk::Color("red");
  green= new Gdk::Color("green");
  blue= new Gdk::Color("blue");
  yellow= new Gdk::Color("yellow");
  cyan= new Gdk::Color("cyan");
  magenta= new Gdk::Color("magenta");
  brown= new Gdk::Color("brown");
  orange= new Gdk::Color("orange");
  sky= new Gdk::Color();
  sky->set_rgb(0x0000,0xaaaa,0xFFFF);
  forest= new Gdk::Color();
  forest->set_rgb(0x0000,0x7000,0x0000);
  gray= new Gdk::Color();
  gray->set_rgb(0x8888,0x8888,0x8888);
  darkgray= new Gdk::Color();
  darkgray->set_rgb(0x5555,0x5555,0x5555);
  mountain= new Gdk::Color();
  mountain->set_rgb(0x8888,0x0000,0x0000);
  cobalt= new Gdk::Color();
  cobalt->set_rgb(0x0000,0x6666,0x8888);
  darkblue= new Gdk::Color();
  darkblue->set_rgb(0x0000,0x0000,0x8888);

  mColor->alloc_color(*white,false,true);
  mColor->alloc_color(*black,false,true);
  mColor->alloc_color(*red,false,true);
  mColor->alloc_color(*green,false,true);
  mColor->alloc_color(*blue,false,true);
  mColor->alloc_color(*yellow,false,true);
  mColor->alloc_color(*cyan,false,true);
  mColor->alloc_color(*magenta,false,true);
  mColor->alloc_color(*brown,false,true);
  mColor->alloc_color(*orange,false,true);
  mColor->alloc_color(*sky,false,true);
  mColor->alloc_color(*forest,false,true);
  mColor->alloc_color(*gray,false,true);
  mColor->alloc_color(*darkgray,false,true);
  mColor->alloc_color(*mountain,false,true);
  mColor->alloc_color(*cobalt,false,true);
  mColor->alloc_color(*darkblue,false,true);
}

BirdColor::~BirdColor(){
  delete white;
  delete black;
  delete red;
  delete green;
  delete blue;
  delete yellow;
  delete cyan;
  delete magenta;
  delete brown;
  delete orange;
  delete sky;
  delete forest;
  delete gray;
  delete darkgray;
  delete mountain;
  delete cobalt;
  delete darkblue;
}

void BirdColor::Create(){
  
}
