#include"createtime.h"

CreateTimeLine::CreateTimeLine(){
  int i;
  copyFlag=0;
  copyStart=-1;
  copyEnd=-1;
  copyNum=0;
  i=0;
  while(i<STAGE_TIMELINE_MAX){
    copyLine[i]=0;
    i++;
  }

  shiftPow[CREATE_TIMELINE_LINETYPE_20MS]=1;
  shiftPow[CREATE_TIMELINE_LINETYPE_100MS]=5;
  shiftPow[CREATE_TIMELINE_LINETYPE_1S]=50;
  shiftPow[CREATE_TIMELINE_LINETYPE_10S]=500;

  shiftMAX[CREATE_TIMELINE_LINETYPE_20MS]
    =STAGE_TIMELINE_MAX/shiftPow[CREATE_TIMELINE_LINETYPE_20MS];
  shiftMAX[CREATE_TIMELINE_LINETYPE_100MS]
    =STAGE_TIMELINE_MAX/shiftPow[CREATE_TIMELINE_LINETYPE_100MS];
  shiftMAX[CREATE_TIMELINE_LINETYPE_1S]
    =STAGE_TIMELINE_MAX/shiftPow[CREATE_TIMELINE_LINETYPE_1S];
  shiftMAX[CREATE_TIMELINE_LINETYPE_10S]
    =STAGE_TIMELINE_MAX/shiftPow[CREATE_TIMELINE_LINETYPE_10S];
}

CreateTimeLine::~CreateTimeLine(){
  
}

void CreateTimeLine::Create(){
  
}

void CreateTimeLine::ModalMenuSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_MODAL;
}
void CreateTimeLine::LandMenuSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_LAND;
}
void CreateTimeLine::CrowdMenuSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_CROWD;
}
void CreateTimeLine::TopMenuSelect(){
  Map->state0=Map->state;
  Map->state=CREATE_STATE_TOP;
}
void CreateTimeLine::TopCopySelect(){
  copyFlag=CREATE_TIMELINE_COPY_START;
}
void (CreateTimeLine::*CreateTimeLine::CREATE_TIMELINE_MENU_SELECT
      [CREATE_TIMELINE_MENU_NUM])()={
  &CreateTimeLine::ModalMenuSelect,
  &CreateTimeLine::LandMenuSelect,
  &CreateTimeLine::CrowdMenuSelect,
  &CreateTimeLine::TopMenuSelect,
  &CreateTimeLine::TopCopySelect
};

void CreateTimeLine::MenuSelect(){
  (this->*CREATE_TIMELINE_MENU_SELECT
   [Map->valueX[CREATE_VX_TIMELINE_MENU]])();
}
void CreateTimeLine::LineSelect(){
  Map->state=CREATE_STATE_MODALINDEX;
}

void CreateTimeLine::ShiftSelect(){
  int tmp1,tmp2;

  tmp1=shiftMAX[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]];
  if(Map->valueX[CREATE_VX_TIMELINE_SHIFT]==CREATE_TIMELINE_DETAIL){
    Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]-=1;
    if(Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]<0){
      Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]=0;
    }
  }
  else if(Map->valueX[CREATE_VX_TIMELINE_SHIFT]==CREATE_TIMELINE_ROUGH){
    Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]+=1;
    if(Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]>=
       CREATE_TIMELINE_LINETYPE_NUM){
      Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]
	=CREATE_TIMELINE_LINETYPE_NUM-1;
    }
  }
  tmp2=shiftMAX[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]];

  Map->valueX[CREATE_VX_TIMELINE_LINE]
    =Map->valueX[CREATE_VX_TIMELINE_LINE]*tmp2/tmp1;
  
  Map->valueX[CREATE_VX_TIMELINE_LINEPOS]
    =Map->valueX[CREATE_VX_TIMELINE_LINE]-CREATE_TIMELINE_LINE_NUM/2;
  
  if(Map->valueX[CREATE_VX_TIMELINE_LINEPOS]
     +CREATE_TIMELINE_LINE_NUM>
     shiftMAX[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]]){
    Map->valueX[CREATE_VX_TIMELINE_LINEPOS]
      =shiftMAX[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]]
      -CREATE_TIMELINE_LINE_NUM;
  }
  if(Map->valueX[CREATE_VX_TIMELINE_LINEPOS]<0){
    Map->valueX[CREATE_VX_TIMELINE_LINEPOS]=0;
  }
}
void (CreateTimeLine::*CreateTimeLine::CREATE_TIMELINE_PLACE_SELECT
      [CREATE_TIMELINE_PLACE_NUM])()={
	&CreateTimeLine::ShiftSelect,
	&CreateTimeLine::LineSelect,
	&CreateTimeLine::MenuSelect
};

void CreateTimeLine::CopyLineSelect(){
  int i;
  int copyEXE;
  if(copyFlag==CREATE_TIMELINE_COPY_START){
    copyStart=Map->valueX[CREATE_VX_TIMELINE_LINE]
      *shiftPow[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]];
    copyFlag=CREATE_TIMELINE_COPY_END;
  }
  else if(copyFlag==CREATE_TIMELINE_COPY_END){
    copyEnd=Map->valueX[CREATE_VX_TIMELINE_LINE]
      *shiftPow[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]];
    copyNum=copyEnd-copyStart;
    i=0;
    while(i<copyNum){
      copyLine[i]=baseStage->timeLine[copyStart+i];
      i++;
    }
    copyFlag=CREATE_TIMELINE_COPY_EXE;    
  }
  else if(copyFlag==CREATE_TIMELINE_COPY_EXE){
    copyEXE=Map->valueX[CREATE_VX_TIMELINE_LINE]
      *shiftPow[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]];

    i=0;
    while(i<copyNum){
      if((copyEXE+i)>=STAGE_TIMELINE_MAX){
	break;
      }
      baseStage->timeLine[copyEXE+i]=copyLine[i];
      i++;
    }
    copyStart=0;
    copyEnd=0;
    copyNum=0;
    copyFlag=CREATE_TIMELINE_COPY_NO;
  }
}
void (CreateTimeLine::*CreateTimeLine::
      CREATE_TIMELINE_COPYPLACE_SELECT[CREATE_TIMELINE_PLACE_NUM])()={
	&CreateTimeLine::ShiftSelect,
	&CreateTimeLine::CopyLineSelect,
	&CreateTimeLine::MenuSelect
};

void CreateTimeLine::ShiftCopyLineSelect(){
  std::stringstream ss;
  int px0,py0;
  int valueLine;

  baseStage->VariableSelectAction
    (&Map->valueX[Map->valueY[CREATE_VY_STATE_TIMELINE]],
     &Map->valueY[CREATE_VY_STATE_TIMELINE],
     SELECTKEY_VARIABLE100);
  /*
  if(Map->valueY[CREATE_VY_STATE_TIMELINE]!=CREATE_VX_TIMELINE_LINE){
    Map->valueY[CREATE_VY_STATE_TIMELINE]=CREATE_VX_TIMELINE_LINE;
  }
  */
  
  if(Map->valueY[CREATE_VY_STATE_TIMELINE]<CREATE_VX_TIMELINE_SHIFT){
    Map->valueY[CREATE_VY_STATE_TIMELINE]=CREATE_VX_TIMELINE_LINE;
  }
  else if(Map->valueY[CREATE_VY_STATE_TIMELINE]>
	  CREATE_VX_TIMELINE_LINE){
    Map->valueY[CREATE_VY_STATE_TIMELINE]=CREATE_VX_TIMELINE_SHIFT;
  }

  if(Map->valueY[CREATE_VY_STATE_TIMELINE]==CREATE_VX_TIMELINE_SHIFT){
    if(Map->valueX[CREATE_VX_TIMELINE_SHIFT]<0){
      Map->valueX[CREATE_VX_TIMELINE_SHIFT]=CREATE_TIMELINE_SHIFT_NUM-1;
    }
    else if(Map->valueX[CREATE_VX_TIMELINE_SHIFT]>=
	    CREATE_TIMELINE_SHIFT_NUM){
      Map->valueX[CREATE_VX_TIMELINE_SHIFT]=0;
    }
  }
  else if(Map->valueY[CREATE_VY_STATE_TIMELINE]==
	  CREATE_VX_TIMELINE_LINE){
    if(copyFlag==CREATE_TIMELINE_COPY_END){
      if(Map->valueX[CREATE_VX_TIMELINE_LINE]<=
	 copyStart/shiftPow[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]]){
	Map->valueX[CREATE_VX_TIMELINE_LINE]=copyStart
	  /shiftPow[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]]+1;
	Map->keyCount=1;
      }
      else if(Map->valueX[CREATE_VX_TIMELINE_LINE]>=
	      shiftMAX[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]]){
	Map->valueX[CREATE_VX_TIMELINE_LINE]
	  =shiftMAX[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]]-1;
	Map->keyCount=1;
      }
    }
    else{
      if(Map->valueX[CREATE_VX_TIMELINE_LINE]<0){
	Map->valueX[CREATE_VX_TIMELINE_LINE]
	  =shiftMAX[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]]-1;
	Map->keyCount=1;
      }
      else if(Map->valueX[CREATE_VX_TIMELINE_LINE]>=
	      shiftMAX[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]]){
	Map->valueX[CREATE_VX_TIMELINE_LINE]=0;
	Map->keyCount=1;
      }
    }
  }
  
  if(Map->valueX[CREATE_VX_TIMELINE_LINE]<
     Map->valueX[CREATE_VX_TIMELINE_LINEPOS]){
    Map->valueX[CREATE_VX_TIMELINE_LINEPOS]
      =Map->valueX[CREATE_VX_TIMELINE_LINE];
  }
  else if(Map->valueX[CREATE_VX_TIMELINE_LINE]>=
	  Map->valueX[CREATE_VX_TIMELINE_LINEPOS]
	  +CREATE_TIMELINE_LINE_NUM){
    Map->valueX[CREATE_VX_TIMELINE_LINEPOS]
      =Map->valueX[CREATE_VX_TIMELINE_LINE]-CREATE_TIMELINE_LINE_NUM+1;
  }

  valueLine=Map->valueX[CREATE_VX_TIMELINE_LINE]
    *shiftPow[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]];
  
  ss.str("");
  if(copyFlag==CREATE_TIMELINE_COPY_START){
    ss<<"COPY:"<<(valueLine/50)<<"."<<(valueLine/5)%10<<"sec ~";
  }
  if(copyFlag==CREATE_TIMELINE_COPY_END){
    ss<<"COPY:"<<(copyStart/50)<<"."<<(copyStart/5)%10<<"sec ~"
      <<(valueLine/50)<<"."<<(valueLine/5)%10<<"sec";
  }
  if(copyFlag==CREATE_TIMELINE_COPY_EXE){
    ss<<"COPY:"<<(copyStart/50)<<"."<<(copyStart/5)%10<<"sec ~"
      <<(copyEnd/50)<<"."<<(copyEnd/5)%10<<"sec";
    ss<<" PAST:"<<(valueLine/50)<<"."<<(valueLine/5)%10<<"sec";
  }
  px0=WIDTH*(1000)/MAP_XMAX;
  py0=HEIGHT*(1000)/MAP_YMAX;
  text->DrawString
    (ss.str(),(color->white),px0,py0,
     FONT_LINE_DOWNRIGHT,15,
     FONT_SERIF,FONT_FACE_BOLD);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  if(control->okValue){
    control->okValue=0;
    
    (this->*CREATE_TIMELINE_COPYPLACE_SELECT
     [Map->valueY[CREATE_VY_STATE_TIMELINE]
      -CREATE_VX_TIMELINE_SHIFT])();
    
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    copyStart=0;
    copyEnd=0;
    copyNum=0;
    copyFlag=0;
  }
}

void CreateTimeLine::ShiftTimeLineSelect(){

  baseStage->VariableSelectAction
    (&Map->valueX[Map->valueY[CREATE_VY_STATE_TIMELINE]],
     &Map->valueY[CREATE_VY_STATE_TIMELINE],
     SELECTKEY_VARIABLE100);
  
  if(Map->valueY[CREATE_VY_STATE_TIMELINE]<CREATE_VX_TIMELINE_SHIFT){
    Map->valueY[CREATE_VY_STATE_TIMELINE]=CREATE_VX_TIMELINE_MENU;
  }
  else if(Map->valueY[CREATE_VY_STATE_TIMELINE]>
	  CREATE_VX_TIMELINE_MENU){
    Map->valueY[CREATE_VY_STATE_TIMELINE]=CREATE_VX_TIMELINE_SHIFT;
  }

  if(Map->valueY[CREATE_VY_STATE_TIMELINE]==CREATE_VX_TIMELINE_SHIFT){
    if(Map->valueX[CREATE_VX_TIMELINE_SHIFT]<0){
      Map->valueX[CREATE_VX_TIMELINE_SHIFT]=CREATE_TIMELINE_SHIFT_NUM-1;
    }
    else if(Map->valueX[CREATE_VX_TIMELINE_SHIFT]>=
	    CREATE_TIMELINE_SHIFT_NUM){
      Map->valueX[CREATE_VX_TIMELINE_SHIFT]=0;
    }
  }
  else if(Map->valueY[CREATE_VY_STATE_TIMELINE]==
	  CREATE_VX_TIMELINE_LINE){
    if(Map->valueX[CREATE_VX_TIMELINE_LINE]<0){
      Map->valueX[CREATE_VX_TIMELINE_LINE]
	=shiftMAX[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]]-1;
      Map->keyCount=1;
    }
    else if(Map->valueX[CREATE_VX_TIMELINE_LINE]>=
	    shiftMAX[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]]){
      Map->valueX[CREATE_VX_TIMELINE_LINE]=0;
      Map->keyCount=1;
    }
  }
  else if(Map->valueY[CREATE_VY_STATE_TIMELINE]==
	  CREATE_VX_TIMELINE_MENU){
    if(Map->valueX[CREATE_VX_TIMELINE_MENU]<0){
      Map->valueX[CREATE_VX_TIMELINE_MENU]=CREATE_TIMELINE_MENU_NUM-1;
    }
    else if(Map->valueX[CREATE_VX_TIMELINE_MENU]>=
	    CREATE_TIMELINE_MENU_NUM){
      Map->valueX[CREATE_VX_TIMELINE_MENU]=0;
    }
  }
  
  if(Map->valueX[CREATE_VX_TIMELINE_LINE]<
     Map->valueX[CREATE_VX_TIMELINE_LINEPOS]){
    Map->valueX[CREATE_VX_TIMELINE_LINEPOS]
      =Map->valueX[CREATE_VX_TIMELINE_LINE];
  }
  else if(Map->valueX[CREATE_VX_TIMELINE_LINE]>=
	  Map->valueX[CREATE_VX_TIMELINE_LINEPOS]
	  +CREATE_TIMELINE_LINE_NUM){
    Map->valueX[CREATE_VX_TIMELINE_LINEPOS]
      =Map->valueX[CREATE_VX_TIMELINE_LINE]-CREATE_TIMELINE_LINE_NUM+1;
  }

  if(control->okValue){
    control->okValue=0;
    (this->*CREATE_TIMELINE_PLACE_SELECT
      [Map->valueY[CREATE_VY_STATE_TIMELINE]
       -CREATE_VX_TIMELINE_SHIFT])();
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=Map->state0;
  }
  if(Map->state==Map->state0){
    Map->state0=CREATE_STATE_TOP;
  }  
}

void CreateTimeLine::Line20mModalSelect(){
  baseStage->timeLine[Map->valueX[CREATE_VX_TIMELINE_LINE]]
    =Map->valueX[CREATE_VX_STATE_MODALINDEX];
  Map->state=CREATE_STATE_TIMELINE;
}
void CreateTimeLine::Line100mModalSelect(){
  int begin,i;
  begin=Map->valueX[CREATE_VX_TIMELINE_LINE]*5;
  
  i=0;
  while(i<5){
    baseStage->timeLine[begin+i]=Map->valueX[CREATE_VX_STATE_MODALINDEX];
    i++;
  }
  Map->state=CREATE_STATE_TIMELINE;
}
void CreateTimeLine::Line1SecModalSelect(){
  int begin,i;
  begin=Map->valueX[CREATE_VX_TIMELINE_LINE]*50;
  
  i=0;
  while(i<50){
    baseStage->timeLine[begin+i]=Map->valueX[CREATE_VX_STATE_MODALINDEX];
    i++;
  }
  Map->state=CREATE_STATE_TIMELINE;
}
void CreateTimeLine::Line10SecModalSelect(){
  int begin,i;
  begin=Map->valueX[CREATE_VX_TIMELINE_LINE]*500;
  
  i=0;
  while(i<500){
    baseStage->timeLine[begin+i]=Map->valueX[CREATE_VX_STATE_MODALINDEX];
    i++;
  }
  Map->state=CREATE_STATE_TIMELINE;
}

void (CreateTimeLine::*CROWD_MODALINDEX_SELECT
      [CREATE_TIMELINE_LINETYPE_NUM])()={
  &CreateTimeLine::Line20mModalSelect,
  &CreateTimeLine::Line100mModalSelect,
  &CreateTimeLine::Line1SecModalSelect,
  &CreateTimeLine::Line10SecModalSelect
};

void CreateTimeLine::ShiftModalIndex(){

  baseStage->VariableSelectAction
    (&Map->valueX[CREATE_VX_STATE_MODALINDEX],
     &Map->valueY[CREATE_VY_STATE_MODALINDEX],
     SELECTKEY_VARIABLE10);

  if(Map->valueY[CREATE_VY_STATE_MODALINDEX]!=0){
    Map->valueY[CREATE_VY_STATE_MODALINDEX]=0;
  }

  ModalIndexMap(0,WIDTH,0,HEIGHT/5);

  if(control->okValue){
    control->okValue=0;
    (this->*CROWD_MODALINDEX_SELECT
     [Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]])();
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=CREATE_STATE_TIMELINE;
  }  
}

void CreateTimeLine::ModalView(int num,int index,int scale){
  int px0,py0;
  int px1,py1;
  std::stringstream ss;
  std::string str;
  StageModal *modal;

  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  modal=&(baseStage->mModal[baseStage->timeLine[(num+index)*scale]]);

  int yellowFlag=0;
  int yellowStart,yellowEnd;
  if(copyFlag==CREATE_TIMELINE_COPY_NO){
    yellowFlag=0;
  }
  else if(copyFlag==CREATE_TIMELINE_COPY_START){
    yellowFlag=0;
  }
  else if(copyFlag==CREATE_TIMELINE_COPY_END){
    yellowStart=copyStart
      /shiftPow[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]];
    if(yellowStart==(num+index)){
      yellowFlag=1;
    }
  }
  else if(copyFlag==CREATE_TIMELINE_COPY_EXE){
    yellowStart=copyStart
      /shiftPow[Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]];
    if(yellowStart<=(num+index)){
      if(copyEnd>(num+index)*scale){
	yellowFlag=1;
      }
    }
  }

  cursorA[0]=yellowFlag;
  cursorA0[0]=1;
  
  cursorB[0]=Map->valueX[CREATE_VX_TIMELINE_LINE];
  cursorB0[0]=num+index;

  frame->draw_rectangle
    (CursorGC(&cursorB[0],&cursorB0[0],1,CREATE_GC_RED,
	      &cursorA[0],&cursorA0[0],1,CREATE_GC_YELLOW,
	      CREATE_GC_BLACK),
       true,
       WIDTH*(CREATE_TIMELINE_PX2-CREATE_TIMELINE_SX2
	      +CREATE_TIMELINE_MX2*index)/MAP_XMAX,
       HEIGHT*(CREATE_TIMELINE_PY2-CREATE_TIMELINE_SY2)/MAP_YMAX,
       WIDTH*(CREATE_TIMELINE_SX2*2)/MAP_XMAX,
       HEIGHT*(CREATE_TIMELINE_SY2*2)/MAP_YMAX);
    
    frame->draw_rectangle
      (skyGC,true,
       WIDTH*(CREATE_TIMELINE_PX2+CREATE_TIMELINE_SX2/2
	      +CREATE_TIMELINE_MX2*index)/MAP_XMAX-20,
       HEIGHT*(CREATE_TIMELINE_PY2)/MAP_YMAX-20,
       40,40);

    px0=WIDTH*(CREATE_TIMELINE_PX2+CREATE_TIMELINE_SX2/2
	       +CREATE_TIMELINE_MX2*index)/MAP_XMAX;
    py0=HEIGHT*(CREATE_TIMELINE_PY2)/MAP_XMAX-20;
    ss<<baseStage->timeLine[(num+index)*scale];
    str=ss.str();
    text->DrawString
      (str,(color->white),px0,py0,
       FONT_LINE_DOWNCENTER,10,
       FONT_SERIF,FONT_FACE_REGULAR);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    DrawModalView(modal,
		  WIDTH*(CREATE_TIMELINE_PX2+CREATE_TIMELINE_SX2/2
			 +CREATE_TIMELINE_MX2*index)/MAP_XMAX,
		  HEIGHT*(CREATE_TIMELINE_PY2)/MAP_YMAX,
		  40,40);
}

void CreateTimeLine::SecValueView(std::string str,int index0){
  int px0,py0;

  px0=WIDTH*(CREATE_TIMELINE_PX2-CREATE_TIMELINE_SX2
	     +CREATE_TIMELINE_MX2*index0)/MAP_XMAX;
  py0=HEIGHT*(CREATE_TIMELINE_PY2-CREATE_TIMELINE_SY2)/MAP_XMAX;
  
  text->DrawString
    (str,(color->white),px0,py0,
     FONT_LINE_DOWNCENTER,10,
     FONT_SERIF,FONT_FACE_BOLD);
  
}
void CreateTimeLine::SecNameView(std::string str,int index0){
  int px0,py0;

  px0=WIDTH*(600)/MAP_XMAX;
  py0=HEIGHT*(CREATE_TIMELINE_PY1)/MAP_YMAX;
  
  text->DrawString
    (str,(color->white),px0,py0,
     FONT_LINE_CENTER,25,
     FONT_SERIF,FONT_FACE_ITALIC);
  
}
void CreateTimeLine::StateNameView(int num,int index,
				   int pow,int space,int length){
  int px0,py0;
  int tmp,flag,j;
  tmp=baseStage->timeLine[(num+index)*pow];
  flag=0;
  j=1;    
  while(j<length){
    if(baseStage->timeLine[(index+num)*pow+j*space]!=tmp){
      flag=1;
      break;
    }
    j++;
  }
  
  px0=WIDTH*(CREATE_TIMELINE_PX2+CREATE_TIMELINE_MX2*index)/MAP_XMAX;
  py0=HEIGHT*(CREATE_TIMELINE_PY2)/MAP_YMAX;
  
  if(flag==0){
    text->DrawString
      ("ALL :",(color->white),px0,py0,
       CREATE_TIMELINE_LF2,CREATE_TIMELINE_SF2,
       CREATE_TIMELINE_TF2,CREATE_TIMELINE_FF2);
  }
  else{
    text->DrawString
      ("FIRST :",(color->white),px0,py0,
       CREATE_TIMELINE_LF2,CREATE_TIMELINE_SF2,
       CREATE_TIMELINE_TF2,CREATE_TIMELINE_FF2);
  }
}

void CreateTimeLine::Line20mSec(){
  int px0,py0;
  std::stringstream ss;
  std::string str;
  StageModal *modal;
  int px,py,mx,my,item;
  int num0,num1;
  int tmp;

  SecNameView("20msec",0);

  num0=Map->valueX[CREATE_VX_TIMELINE_LINEPOS];
  num1=Map->valueX[CREATE_VX_TIMELINE_LINE];
  
  int i;
  i=0;
  while(i<CREATE_TIMELINE_LINE_NUM){
    tmp=(num0+i)*20;
    ss<<(num0+i)*20<<"msec";
    str=ss.str();
    SecValueView(str,i);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    ModalView(num0,i,1);

    StateNameView(num0,i,1,1,1);

    i++;
  }
  ss<<(num0+i)*20<<"ms";
  str=ss.str(); 
  SecValueView(str,i);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
}

void CreateTimeLine::Line100mSec(){
  std::stringstream ss;
  std::string str;
  StageModal *modal;
  int px,py,mx,my,item;
  int num0,num1;
  int i;

  num0=Map->valueX[CREATE_VX_TIMELINE_LINEPOS];
  num1=Map->valueX[CREATE_VX_TIMELINE_LINE];
    
  SecNameView("0.1sec",0);

  i=0;
  while(i<CREATE_TIMELINE_LINE_NUM){
    ss<<(num0+i)/10<<"."<<abs((num0+i)%10)<<"sec";
    str=ss.str(); 
    SecValueView(str,i);
    ss.str("");
    ss.clear(std::stringstream::goodbit);
    
    ModalView(num0,i,5);

    StateNameView(num0,i,5,1,5);
    i++;
  }

  ss<<(num0+i)/10<<"."<<abs((num0+i)%10)<<"sec";
  str=ss.str(); 
  SecValueView(str,i);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
}

void CreateTimeLine::Line1Sec(){
  std::stringstream ss;
  std::string str;
  StageModal *modal;
  int px,py,mx,my,item;
  int num0,num1;
  int i;
  
  num0=Map->valueX[CREATE_VX_TIMELINE_LINEPOS];
  num1=Map->valueX[CREATE_VX_TIMELINE_LINE];
  
  SecNameView("1sec",0);

  i=0;
  while(i<CREATE_TIMELINE_LINE_NUM){
    ss<<(num0+i)<<"sec";
    str=ss.str();
    SecValueView(str,i);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    ModalView(num0,i,50);
    StateNameView(num0,i,50,5,10);

    i++;
  }
  ss<<(num0+i)<<"sec";
  str=ss.str(); 
  SecValueView(str,i);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
}

void CreateTimeLine::Line10Sec(){
  std::stringstream ss;
  std::string str;
  StageModal *modal;
  int px,py,mx,my,item;
  int num0,num1;
  int i;
  
  num0=Map->valueX[CREATE_VX_TIMELINE_LINEPOS];
  num1=Map->valueX[CREATE_VX_TIMELINE_LINE];

  SecNameView("10sec",0);  

  i=0;
  while(i<CREATE_TIMELINE_LINE_NUM){
    ss<<(num0+i)*10<<"sec";
    str=ss.str();
    SecValueView(str,i);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    ModalView(num0,i,500);

    StateNameView(num0,i,500,50,10);

    i++;
  }
  ss<<(num0+i)*10<<"sec";
  str=ss.str(); 
  SecValueView(str,i);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
}

void (CreateTimeLine::*CREATE_TIMELINE_LINE_SELECT
      [CREATE_TIMELINE_LINETYPE_NUM])()={
  &CreateTimeLine::Line20mSec,
  &CreateTimeLine::Line100mSec,
  &CreateTimeLine::Line1Sec,
  &CreateTimeLine::Line10Sec
};

void CreateTimeLine::Menu(){
  int px0,py0,sx0,sy0;
  int px1,py1,px2,py2;
  std::stringstream ss;
  std::string str;  
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];
  StageModal *modal;

  RunWoodBG(0,0,WIDTH,HEIGHT);

  cursorB[0]=Map->valueX[CREATE_VX_TIMELINE_MENU];
  cursorB0[0]=CREATE_TIMELINE_MODAL;
  cursorB[1]=Map->valueY[CREATE_VY_STATE_TIMELINE];
  cursorB0[1]=CREATE_VX_TIMELINE_MENU;

  px0=WIDTH*(CREATE_TIMELINE_PX3-CREATE_TIMELINE_SX3
	     +CREATE_TIMELINE_MX3*CREATE_TIMELINE_MODAL)/MAP_XMAX;
  py0=HEIGHT*(CREATE_TIMELINE_PY3-CREATE_TIMELINE_SY3)/MAP_YMAX;
  sx0=WIDTH*(CREATE_TIMELINE_SX3*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_TIMELINE_SY3*2)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TIMELINE_DW3,py0+CREATE_TIMELINE_DH3,
	    sx0-CREATE_TIMELINE_DW3*2,sy0-CREATE_TIMELINE_DH3*2);

  cursorB0[0]=CREATE_TIMELINE_LAND;
  px0=WIDTH*(CREATE_TIMELINE_PX3-CREATE_TIMELINE_SX3
	     +CREATE_TIMELINE_MX3*CREATE_TIMELINE_LAND)/MAP_XMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TIMELINE_DW3,py0+CREATE_TIMELINE_DH3,
	    sx0-CREATE_TIMELINE_DW3*2,sy0-CREATE_TIMELINE_DH3*2);

  cursorB0[0]=CREATE_TIMELINE_CROWD;
  px0=WIDTH*(CREATE_TIMELINE_PX3-CREATE_TIMELINE_SX3
	     +CREATE_TIMELINE_MX3*CREATE_TIMELINE_CROWD)/MAP_XMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TIMELINE_DW3,py0+CREATE_TIMELINE_DH3,
	    sx0-CREATE_TIMELINE_DW3*2,sy0-CREATE_TIMELINE_DH3*2);

  cursorB0[0]=CREATE_TIMELINE_TOP;
  px0=WIDTH*(CREATE_TIMELINE_PX3-CREATE_TIMELINE_SX3
	     +CREATE_TIMELINE_MX3*CREATE_TIMELINE_TOP)/MAP_XMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TIMELINE_DW3,py0+CREATE_TIMELINE_DH3,
	    sx0-CREATE_TIMELINE_DW3*2,sy0-CREATE_TIMELINE_DH3*2);

  int yellowFlag;
  
  if(copyFlag){
    yellowFlag=1;
  }
  else{
    yellowFlag=0;
  }
  cursorA[0]=yellowFlag;
  cursorA0[0]=1;
  
  cursorB0[0]=CREATE_TIMELINE_COPY;

  px0=WIDTH*(CREATE_TIMELINE_PX3-CREATE_TIMELINE_SX3
	     +CREATE_TIMELINE_MX3*CREATE_TIMELINE_COPY)/MAP_XMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],1,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TIMELINE_DW3,py0+CREATE_TIMELINE_DH3,
	    sx0-CREATE_TIMELINE_DW3*2,sy0-CREATE_TIMELINE_DH3*2);

  py1=HEIGHT*(CREATE_TIMELINE_PY3)/MAP_YMAX;
  px0=WIDTH*(CREATE_TIMELINE_PX3
	     +CREATE_TIMELINE_MX3*CREATE_TIMELINE_MODAL)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("MODAL",(color->black),px0,py0,
     CREATE_TIMELINE_LF3,CREATE_TIMELINE_SF3,
     CREATE_TIMELINE_TF3,CREATE_TIMELINE_FF3);

  px0=WIDTH*(CREATE_TIMELINE_PX3
	     +CREATE_TIMELINE_MX3*CREATE_TIMELINE_LAND)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("LAND",(color->black),px0,py0,
     CREATE_TIMELINE_LF3,CREATE_TIMELINE_SF3,
     CREATE_TIMELINE_TF3,CREATE_TIMELINE_FF3);

  px0=WIDTH*(CREATE_TIMELINE_PX3
	     +CREATE_TIMELINE_MX3*CREATE_TIMELINE_CROWD)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("CROWD",(color->black),px0,py0,
     CREATE_TIMELINE_LF3,CREATE_TIMELINE_SF3,
     CREATE_TIMELINE_TF3,CREATE_TIMELINE_FF3);

  px0=WIDTH*(CREATE_TIMELINE_PX3
	     +CREATE_TIMELINE_MX3*CREATE_TIMELINE_TOP)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("TOP",(color->black),px0,py0,
     CREATE_TIMELINE_LF3,CREATE_TIMELINE_SF3,
     CREATE_TIMELINE_TF3,CREATE_TIMELINE_FF3);
  
  px0=WIDTH*(CREATE_TIMELINE_PX3
	     +CREATE_TIMELINE_MX3*CREATE_TIMELINE_COPY)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("COPY",(color->black),px0,py0,
     CREATE_TIMELINE_LF3,CREATE_TIMELINE_SF3,
     CREATE_TIMELINE_TF3,CREATE_TIMELINE_FF3);

  cursorB[0]=Map->valueX[CREATE_VX_TIMELINE_SHIFT];
  cursorB0[0]=CREATE_TIMELINE_DETAIL;
  cursorB[1]=Map->valueY[CREATE_VY_STATE_TIMELINE];
  cursorB0[1]=CREATE_VX_TIMELINE_SHIFT;

  px0=WIDTH*(CREATE_TIMELINE_PX1-CREATE_TIMELINE_SX1
	     +CREATE_TIMELINE_MX1*CREATE_TIMELINE_DETAIL)/MAP_XMAX;
  py0=HEIGHT*(CREATE_TIMELINE_PY1-CREATE_TIMELINE_SY1)/MAP_YMAX;
  sx0=WIDTH*(CREATE_TIMELINE_SX1*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_TIMELINE_SY1*2)/MAP_YMAX;
  
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TIMELINE_DW1,py0+CREATE_TIMELINE_DH1,
	    sx0-CREATE_TIMELINE_DW1*2,sy0-CREATE_TIMELINE_DH1*2);

  cursorB0[0]=CREATE_TIMELINE_ROUGH;
  px0=WIDTH*(CREATE_TIMELINE_PX1-CREATE_TIMELINE_SX1
	     +CREATE_TIMELINE_MX1*CREATE_TIMELINE_ROUGH)/MAP_XMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TIMELINE_DW1,py0+CREATE_TIMELINE_DH1,
	    sx0-CREATE_TIMELINE_DW1*2,sy0-CREATE_TIMELINE_DH1*2);

  py1=HEIGHT*(CREATE_TIMELINE_PY1)/MAP_YMAX;
  px0=WIDTH*(CREATE_TIMELINE_PX1
	     +CREATE_TIMELINE_MX1*CREATE_TIMELINE_DETAIL)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("DETAIL",(color->black),px0,py0,
     CREATE_TIMELINE_LF1,CREATE_TIMELINE_SF1,
     CREATE_TIMELINE_TF1,CREATE_TIMELINE_FF1);
  
  px0=WIDTH*(CREATE_TIMELINE_PX1
	     +CREATE_TIMELINE_MX1*CREATE_TIMELINE_ROUGH)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("ROUGH",(color->black),px0,py0,
     CREATE_TIMELINE_LF1,CREATE_TIMELINE_SF1,
     CREATE_TIMELINE_TF1,CREATE_TIMELINE_FF1);

  cursorB[0]=Map->valueY[CREATE_VY_STATE_TIMELINE];
  cursorB0[0]=CREATE_VX_TIMELINE_LINE;
  
  px0=WIDTH*(0)/MAP_XMAX;
  py0=HEIGHT*(400)/MAP_YMAX;
  sx0=WIDTH*(1000)/MAP_XMAX;
  sy0=HEIGHT*(400)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],1,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TIMELINE_DW2,py0+CREATE_TIMELINE_DH2,
	    sx0-CREATE_TIMELINE_DW2*2,sy0-CREATE_TIMELINE_DH2*2);

  if(Map->state==CREATE_STATE_TIMELINE){
    if(copyFlag){
      ShiftCopyLineSelect();
    }
    else{
      ShiftTimeLineSelect();
    }
  }
  else if(Map->state==CREATE_STATE_MODALINDEX){
    ShiftModalIndex();
  }

  (this->*CREATE_TIMELINE_LINE_SELECT
   [Map->valueY[CREATE_VY_TIMELINE_SHIFTTYPE]])();

  mWindow->invalidate_rect(rect,false);  
}
