#ifndef BIRD_DRAW_H_
#define BIRD_DRAW_H_

#include <gtkmm.h>
#include <iostream>
#include <sstream>
#include "selectview.h"

class DrawArea :public Gtk::DrawingArea{
 public:
  sigc::connection mTimer;
  int timerFlag;
  Glib::RefPtr<Gdk::Pixmap> frame;
  Glib::RefPtr<Gdk::GC> mGC;
  Glib::RefPtr<Gdk::Window> mWindow;
  SelectView *selectView;
  DrawArea(Gtk::Window *window0);
  ~DrawArea();
  void Create();
 protected:
  bool TimeProcess();
  virtual bool on_configure_event(GdkEventConfigure *event);
  virtual bool on_expose_event(GdkEventExpose *event);
};

#endif
