#ifndef BIRD_MAP_H_
#define BIRD_MAP_H_

#define SELECT_MAP_SLIDE 0
#define SELECT_MAP_TITLE 1
#define SELECT_MAP_STREAMSTAGE 2
#define SELECT_MAP_BOSSPRACTICE 3
#define SELECT_MAP_PLAYCREATE 4
#define SELECT_MAP_SCORE 5
#define SELECT_MAP_CREATESTAGE 6
#define SELECT_MAP_KEYCONFIG 7
#define SELECT_MAP_NUM 8

#define MAP_XMAX 1000
#define MAP_YMAX 1000

#define MAP_CHANGE_VALUE 10

class BirdMap{
 public:
  int type;
  int type0;
  int sec;
  int state;
  int state0;
  int mode;
  int valueX[100];
  int valueY[100];
  int minW;
  int maxW;
  int minH;
  int maxH;
  int speedX;
  int speedY;
  int px;
  int py;
  int keyCount;
  BirdMap(){
    sec=0;
    state=0;
    state0=0;
    type=0;
    type0=0;
    mode=0;

    InitValue();

    minW=0;
    maxW=0;
    minH=0;
    maxH=0;
    speedX=0;
    speedY=0;
    px=0;
    py=0;
    keyCount=0;
  }
  ~BirdMap(){
    
  }
  void InitValue(){
    int i;
    i=0;
    while(i<100){
      valueX[i]=0;
      valueY[i]=0;
      i++;
    }
  }
  void ChangeType(int nextType){
    type0=type;
    type=nextType*MAP_CHANGE_VALUE;
  }
};

#endif
