#ifndef BIRD_RHOUMBUS_H_
#define BIRD_RHOUMBUS_H_

#include <gtkmm.h>
#include <iostream>

class BirdRhoum{
 public:
  int px;
  int py;
  int up;
  int right;
  int left;
  int down;
  int type;
  int color;
  BirdRhoum *next;
  BirdRhoum *prev;
};

class RhoumList{
 public:
  int listSize;
  BirdRhoum *first;
  BirdRhoum *end;
  RhoumList();
  ~RhoumList();
  void Append(BirdRhoum *node);
  void Prepend(BirdRhoum *node);
  void Insert(BirdRhoum *node,BirdRhoum *target);
  void Reject(BirdRhoum *node);
  void ALLDelete();
};

#endif
