#include "text.h"

BirdText::BirdText(Gtk::Widget *widget){
  std::list< FFAM > families;
  std::list< FFACE > faces;
  std::list< FFAM >::iterator it;
  std::list< FFACE >::iterator it2;

  std::cout <<"PANGO FAMILY"<<std::endl;
  /*
  families=widget->get_pango_context()->list_families();
  
  for(it=families.begin();it!=families.end();++it){

    std::cout<<"family name = "<<(*it)->get_name()<< "\nfaces = ";
    faces = (*it)->list_faces();
    for( it2 = faces.begin(); it2 != faces.end(); ++it2 ){
      std::cout<<(*it2)->get_name()<< ", ";
    }    
    std::cout <<"\n\n";
  }
  */
  std::cout <<"PANGO FAMILY END"<<std::endl;

  fontName[FONT_CLEAN]="Clean";
  fontName[FONT_TERMINAL]="Terminal";
  fontName[FONT_TIMES]="Times";
  fontName[FONT_FIXED]="Fixed";
  fontName[FONT_NEWSPAPER]="Newspaper";
  fontName[FONT_SANS]="Sans";
  fontName[FONT_SERIF]="Serif";
  fontName[FONT_MONOSPACE]="Monospace";

  fontFace[FONT_FACE_REGULAR]="";
  fontFace[FONT_FACE_BOLD]="BOLD";
  fontFace[FONT_FACE_ITALIC]="ITALIC";

  mLayout=widget->create_pango_layout("");
}

BirdText::~BirdText(){

}
void BirdText::Create(Glib::RefPtr<Gdk::Window> window0,
		      Glib::RefPtr<Gdk::Pixmap> frame0){
  GC=Gdk::GC::create(window0);
  frame=frame0;
}

void BirdText::DrawLeft(Glib::ustring text,Gdk::Color color,
			  int px,int py,int size,int type){
  int width,height;
  std::stringstream ss;
  Glib::ustring family;
  ss<<fontName[type]<<" "<<size;

  family=ss.str();

  //  std::cout<<"family="<<family<<std::endl;

  Pango::FontDescription font(family);
  // family="Serif "+size;
  //  font->set_family("Times Bold");
  //  ff.set_absolute_size(1000);
  mLayout->set_font_description(font);
  mLayout->set_text(text);
  GC->set_foreground(color);

  mLayout->get_size(width,height);
  width=width/1024;
  height=height/1024;

  py=py-height/2;

  frame->draw_layout(GC,px,py,mLayout);
}

void BirdText::DrawCenter(Glib::ustring text,Gdk::Color color,
			  int px,int py,int size,int type){
  int width,height;
  std::stringstream ss;
  Glib::ustring family;
  ss<<fontName[type]<<" "<<size;

  family=ss.str();
  Pango::FontDescription font(family);

  mLayout->set_font_description(font);
  mLayout->set_text(text);
  GC->set_foreground(color);
 
  mLayout->get_size(width,height);
  width=width/1024;
  height=height/1024;
  /*
  std::cout<<"(x,y)="<<x<<","<<y<<std::endl;
  */
  px=px-width/2;
  py=py-height/2;
  
  // mLayout->set_ellipsize(Pango::ELLIPSIZE_MIDDLE);
  // mLayout->set_alignment(Pango::ALIGN_CENTER);
    /*
  int width;

  width=mLayout->get_width();

  std::cout<<"(x,y)="<<x<<","<<y<<std::endl;

    px=px-mLayout->get_width()*10;
    */
  frame->draw_layout(GC,px,py,mLayout);
}

void BirdText::DrawRight(Glib::ustring text,Gdk::Color color,
			  int px,int py,int size,int type){
  int width,height;
  std::stringstream ss;
  Glib::ustring family;
  ss<<fontName[type]<<" "<<size;

  family=ss.str();

  Pango::FontDescription font(family);

  mLayout->set_font_description(font);
  mLayout->set_text(text);
  GC->set_foreground(color);
 
  mLayout->get_size(width,height);
  width=width/1024;
  height=height/1024;

  px=px-width;
  py=py-height/2;
  
  frame->draw_layout(GC,px,py,mLayout);
}

void BirdText::DrawUpLeft(Glib::ustring text,Gdk::Color color,
			  int px,int py,int size,int type){
  int width,height;
  std::stringstream ss;
  Glib::ustring family;
  ss<<fontName[type]<<" "<<size;

  family=ss.str();

  Pango::FontDescription font(family);

  mLayout->set_font_description(font);
  mLayout->set_text(text);
  GC->set_foreground(color);
 
  mLayout->get_size(width,height);
  width=width/1024;
  height=height/1024;
  
  frame->draw_layout(GC,px,py,mLayout);
}

void BirdText::DrawUpCenter(Glib::ustring text,Gdk::Color color,
			  int px,int py,int size,int type){
  int width,height;
  std::stringstream ss;
  Glib::ustring family;
  ss<<fontName[type]<<" "<<size;

  family=ss.str();

  Pango::FontDescription font(family);

  mLayout->set_font_description(font);
  mLayout->set_text(text);
  GC->set_foreground(color);
 
  mLayout->get_size(width,height);
  width=width/1024;
  height=height/1024;

  px=px-width/2;
  
  frame->draw_layout(GC,px,py,mLayout);
}

void BirdText::DrawUpRight(Glib::ustring text,Gdk::Color color,
			  int px,int py,int size,int type){
  int width,height;
  std::stringstream ss;
  Glib::ustring family;
  ss<<fontName[type]<<" "<<size;

  family=ss.str();

  Pango::FontDescription font(family);

  mLayout->set_font_description(font);
  mLayout->set_text(text);
  GC->set_foreground(color);
 
  mLayout->get_size(width,height);
  width=width/1024;
  height=height/1024;

  px=px-width;
  
  frame->draw_layout(GC,px,py,mLayout);
}

void BirdText::DrawDownLeft(Glib::ustring text,Gdk::Color color,
			  int px,int py,int size,int type){
  int width,height;
  std::stringstream ss;
  Glib::ustring family;
  ss<<fontName[type]<<" "<<size;

  family=ss.str();

  Pango::FontDescription font(family);

  mLayout->set_font_description(font);
  mLayout->set_text(text);
  GC->set_foreground(color);
 
  mLayout->get_size(width,height);
  width=width/1024;
  height=height/1024;

  py=py-height;
  
  frame->draw_layout(GC,px,py,mLayout);
}

void BirdText::DrawDownCenter(Glib::ustring text,Gdk::Color color,
			  int px,int py,int size,int type){
  int width,height;
  std::stringstream ss;
  Glib::ustring family;
  ss<<fontName[type]<<" "<<size;

  family=ss.str();

  Pango::FontDescription font(family);

  mLayout->set_font_description(font);
  mLayout->set_text(text);
  GC->set_foreground(color);
 
  mLayout->get_size(width,height);
  width=width/1024;
  height=height/1024;

  px=px-width/2;
  py=py-height;

  
  frame->draw_layout(GC,px,py,mLayout);
}

void BirdText::DrawDownRight(Glib::ustring text,Gdk::Color color,
			  int px,int py,int size,int type){
  int width,height;
  std::stringstream ss;
  Glib::ustring family;
  ss<<fontName[type]<<" "<<size;

  family=ss.str();

  Pango::FontDescription font(family);

  mLayout->set_font_description(font);
  mLayout->set_text(text);
  GC->set_foreground(color);
 
  mLayout->get_size(width,height);
  width=width/1024;
  height=height/1024;

  px=px-width;
  py=py-height;
  
  frame->draw_layout(GC,px,py,mLayout);
}

void BirdText::UpLeftLineSet(int *px,int *py,int width0,int height0){
  
}
void BirdText::UpCenterLineSet(int *px,int *py,int width0,int height0){
  width0=width0/FONT_POW_WIDTH;
  *px=*px-width0/2;
}
void BirdText::UpRightLineSet(int *px,int *py,int width0,int height0){
  width0=width0/FONT_POW_WIDTH;
  *px=*px-width0;
}
void BirdText::LeftLineSet(int *px,int *py,int width0,int height0){
  height0=height0/FONT_POW_HEIGHT;

  *py=*py-height0/2;
}
void BirdText::CenterLineSet(int *px,int *py,int width0,int height0){
  width0=width0/FONT_POW_WIDTH;
  height0=height0/FONT_POW_HEIGHT;

  *px=*px-width0/2;
  *py=*py-height0/2;
}
void BirdText::RightLineSet(int *px,int *py,int width0,int height0){
  width0=width0/FONT_POW_WIDTH;
  height0=height0/FONT_POW_HEIGHT;

  *px=*px-width0;
  *py=*py-height0/2;
}
void BirdText::DownLeftLineSet(int *px,int *py,int width0,int height0){
  height0=height0/FONT_POW_HEIGHT;

  *py=*py-height0;
}
void BirdText::DownCenterLineSet(int *px,int *py,int width0,int height0){
  width0=width0/FONT_POW_WIDTH;
  height0=height0/FONT_POW_HEIGHT;

  *px=*px-width0/2;
  *py=*py-height0;
}
void BirdText::DownRightLineSet(int *px,int *py,int width0,int height0){
  width0=width0/FONT_POW_WIDTH;
  height0=height0/FONT_POW_HEIGHT;

  *px=*px-width0;
  *py=*py-height0;
}
void (BirdText::*BirdText::FONT_LINE_SELECT[FONT_LINE_NUM])
  (int *px,int *py,int width0,int height0)={
    &BirdText::UpLeftLineSet,
    &BirdText::UpCenterLineSet,
    &BirdText::UpRightLineSet,
    &BirdText::LeftLineSet,
    &BirdText::CenterLineSet,
    &BirdText::RightLineSet,
    &BirdText::DownLeftLineSet,
    &BirdText::DownCenterLineSet,
    &BirdText::DownRightLineSet
  };
void BirdText::DrawString(Glib::ustring text,Gdk::Color *color,
			  int &px,int &py,int line,int size,
			  int type,int face){
  int width,height;
  std::stringstream ss;
  Glib::ustring family;
  ss<<fontName[type]<<" "<<fontFace[face]<<" "<<size;

  family=ss.str();

  Pango::FontDescription font(family);

  mLayout->set_font_description(font);
  mLayout->set_text(text);
  GC->set_foreground(*(color));
 
  mLayout->get_size(width,height);
  
  (this->*FONT_LINE_SELECT[line])
    (&px,&py,width,height);
  
  frame->draw_layout(GC,px,py,mLayout); 

  px+=width;
  py+=height;
}
