#include "window.h"
#include "xpm/bird.h"

BirdWindow::BirdWindow()
  :Gtk::Window(Gtk::WINDOW_TOPLEVEL){

  mIcon=Gdk::Pixbuf::create_from_xpm_data((char **)bird_b2_xpm);
  
  drawArea= new DrawArea(this);
  add(*drawArea);
  drawArea->show();
  GdkGeometry ghints;
  ghints.min_width=WIDTH;
  ghints.min_height=HEIGHT;
  ghints.max_width=WIDTH;
  ghints.max_height=HEIGHT;
  ghints.base_width=WIDTH;
  ghints.base_height=HEIGHT;
  ghints.width_inc=0;
  ghints.height_inc=0;
  set_geometry_hints(*this,ghints,
		     Gdk::HINT_MIN_SIZE|Gdk::HINT_MAX_SIZE|
		     Gdk::HINT_BASE_SIZE|Gdk::HINT_RESIZE_INC);
  set_icon(mIcon);
}

BirdWindow::~BirdWindow(){
  
}

void BirdWindow::Create(){
  drawArea->Create();
}
