#include"createbackground.h"

CreateBackGround::CreateBackGround(){
  maxInterX=0;
  maxInterY=0;
  rotateName[STAGE_BG_ROTATE0]="0";
  rotateName[STAGE_BG_ROTATE90]="90";
  rotateName[STAGE_BG_ROTATE180]="180";
  rotateName[STAGE_BG_ROTATE270]="270";

  flipName[STAGE_BG_NOFLIP]="NO";
  flipName[STAGE_BG_HFLIP]="HFLIP";
  flipName[STAGE_BG_VFLIP]="VFLIP";
}

CreateBackGround::~CreateBackGround(){

}

void CreateBackGround::Create(){

}

void CreateBackGround::LoadSelect(){
  Glib::ustring path,path0;
  Glib::ustring file;

  Gtk::FileChooserDialog diag
    ("SELECT BACKGROUND",Gtk::FILE_CHOOSER_ACTION_OPEN);
  diag.add_button(Gtk::Stock::OPEN, Gtk::RESPONSE_OK);
  diag.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
  diag.set_icon(mIcon);

  Gtk::FileFilter filt;
  filt.set_name("image");
  filt.add_pattern("*.bmp");
  filt.add_pattern("*.jpg");
  filt.add_pattern("*.jpeg");
  filt.add_pattern("*.png");
  filt.add_pattern("*.xpm");
  diag.add_filter(filt);
  
  path0=diag.get_current_folder();

  path=path0+"/image";

  if(diag.set_current_folder(path)){
    std::cout<<"FIND FOLDER:"<<path<<std::endl;
  }
  else{
    std::cout<<"FALSE FOLDER:"<<diag.get_current_folder()<<std::endl;
  }
  

  switch( diag.run() ){

  case Gtk::RESPONSE_OK:
    file=diag.get_filename();
    
    /*
    folder=diag.get_current_folder();    
    name=file;
    name.erase(name.find(folder,0),folder.size()+1);
    */
    if(file.find(path0,0)!=std::string::npos){
      file.erase(file.find(path0,0),path0.size()+1);
    }

    std::cout<<"FILE:"<<file<<std::endl;

    if(baseStage->LoadBackGround(Glib::locale_from_utf8(file))==0){
      std::cout<<"LOAD BACKGROUND"<<std::endl;
      baseStage->bgPath=Glib::locale_from_utf8(file);
      baseStage->bgInterX=0;
      baseStage->bgInterY=0;
    }
    else{
      std::cout<<"CAN'T LOAD BACKGROUND"<<std::endl;
    }
    
    

    if(baseStage->CalcBackGroundMove
       (STAGE_BG_MOV_MAXW,STAGE_BG_MOV_MAXH)!=0){
      std::cout<<"BACKGROUND MOV ERROR"<<std::endl;
    }
    else{
      std::cout<<"BACKGROUND MOV OK"<<std::endl;
    }

    break;
  case Gtk::RESPONSE_CANCEL:
    break;
  }
 
  diag.show();
  diag.resize(200,100);  
}
void CreateBackGround::TopSelect(){
  Map->state0=CREATE_STATE_TOP;
  Map->state=CREATE_STATE_TOP;
}
void (CreateBackGround::*CreateBackGround::CREATE_BACKGROUND_MENU_SELECT
      [CREATE_BACKGROUND_MENU_NUM])()={
	&CreateBackGround::LoadSelect,
	&CreateBackGround::TopSelect
};

void CreateBackGround::MenuSelect(){
  (this->*CREATE_BACKGROUND_MENU_SELECT
   [Map->valueY[CREATE_VY_BACKGROUND_MENU]])();
}

void CreateBackGround::SizeSelect(){
  Map->valueX[CREATE_VX_BACKGROUND_SHIFT]
    =CREATE_BACKGROUND_SHIFT_SIZE;

  Map->valueY[CREATE_VY_SHIFT_BGSIZE]=CREATE_VX_BGSIZE_WIDTH;

  Map->valueX[CREATE_VX_BGSIZE_WIDTH]=baseStage->bgWidth;
  Map->valueX[CREATE_VX_BGSIZE_HEIGHT]=baseStage->bgHeight;
  Map->valueX[CREATE_VX_BGSIZE_ROTATE]=baseStage->bgRotate;
  Map->valueX[CREATE_VX_BGSIZE_FLIP]=baseStage->bgFlip;
  rotateFlag=baseStage->bgRotate;
}
void CreateBackGround::IntervalSelect(){
  Map->valueX[CREATE_VX_BACKGROUND_SHIFT]
    =CREATE_BACKGROUND_SHIFT_INTERVAL;

  Map->valueY[CREATE_VY_SHIFT_BGINTERVAL]=CREATE_VX_BGINTERVAL_XINTERVAL;

  Map->valueX[CREATE_VX_BGINTERVAL_XINTERVAL]=baseStage->bgInterX;
  Map->valueX[CREATE_VX_BGINTERVAL_YINTERVAL]=baseStage->bgInterY;
}

void (CreateBackGround::*CreateBackGround::
      CREATE_BACKGROUND_STRUCT_SELECT
      [CREATE_BACKGROUND_STRUCT_NUM])()={
	&CreateBackGround::SizeSelect,
	&CreateBackGround::IntervalSelect,
};


void CreateBackGround::StructSelect(){
  (this->*CREATE_BACKGROUND_STRUCT_SELECT
   [Map->valueY[CREATE_VY_BACKGROUND_STRUCT]])();
}

void (CreateBackGround::*CreateBackGround::CREATE_BACKGROUND_SELECT
      [CREATE_BACKGROUND_NUM])()={
	&CreateBackGround::StructSelect,
	&CreateBackGround::MenuSelect
};

void CreateBackGround::ShiftMenu(){
  baseStage->VariableSelectAction
    (&Map->valueX[CREATE_VX_STATE_BACKGROUND],
     &Map->valueY[Map->valueX[CREATE_VX_STATE_BACKGROUND]],
     SELECTKEY_VARIABLE1);
    
  if(Map->valueX[CREATE_VX_STATE_BACKGROUND]<
     CREATE_VY_BACKGROUND_STRUCT){
    Map->valueX[CREATE_VX_STATE_BACKGROUND]
      =CREATE_VY_BACKGROUND_MENU;
  }
  else if(Map->valueX[CREATE_VX_STATE_BACKGROUND]>
	  CREATE_VY_BACKGROUND_MENU){
    Map->valueX[CREATE_VX_STATE_BACKGROUND]
      =CREATE_VY_BACKGROUND_STRUCT;
  }
  
  if(Map->valueY[CREATE_VY_BACKGROUND_STRUCT]<0){
    Map->valueY[CREATE_VY_BACKGROUND_STRUCT]
      =CREATE_BACKGROUND_STRUCT_NUM-1;
  }
  else if(Map->valueY[CREATE_VY_BACKGROUND_STRUCT]>=
	  CREATE_BACKGROUND_STRUCT_NUM){
    Map->valueY[CREATE_VY_BACKGROUND_STRUCT]=0;
  }
  
  if(Map->valueY[CREATE_VY_BACKGROUND_MENU]<0){
    Map->valueY[CREATE_VY_BACKGROUND_MENU]
	=CREATE_BACKGROUND_MENU_NUM-1;
  }
  else if(Map->valueY[CREATE_VY_BACKGROUND_MENU]>=
	  CREATE_BACKGROUND_MENU_NUM){
    Map->valueY[CREATE_VY_BACKGROUND_MENU]=0;
  }
  
  if(control->okValue){
    control->okValue=0;
    (this->*CREATE_BACKGROUND_SELECT
     [Map->valueX[CREATE_VX_STATE_BACKGROUND]
      -CREATE_VY_BACKGROUND_STRUCT])();
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->state=Map->state0;
  }
}

void CreateBackGround::ShiftRotate0(){
  if(rotateFlag!=STAGE_BG_ROTATE0){
    Map->valueX[CREATE_VX_BGSIZE_WIDTH]=(baseStage->tBuf)->get_width();
    Map->valueX[CREATE_VX_BGSIZE_HEIGHT]=(baseStage->tBuf)->get_height();
    rotateFlag=STAGE_BG_ROTATE0;
  }
}
void CreateBackGround::ShiftRotate90(){
  if(rotateFlag!=STAGE_BG_ROTATE90){
    Map->valueX[CREATE_VX_BGSIZE_WIDTH]=(baseStage->tBuf)->get_height();
    Map->valueX[CREATE_VX_BGSIZE_HEIGHT]=(baseStage->tBuf)->get_width();
    rotateFlag=STAGE_BG_ROTATE90;
  }
}
void CreateBackGround::ShiftRotate180(){
  if(rotateFlag!=STAGE_BG_ROTATE180){
    Map->valueX[CREATE_VX_BGSIZE_WIDTH]=(baseStage->tBuf)->get_width();
    Map->valueX[CREATE_VX_BGSIZE_HEIGHT]=(baseStage->tBuf)->get_height();
    rotateFlag=STAGE_BG_ROTATE180;
  }
}
void CreateBackGround::ShiftRotate270(){
  if(rotateFlag!=STAGE_BG_ROTATE270){
    Map->valueX[CREATE_VX_BGSIZE_WIDTH]=(baseStage->tBuf)->get_height();
    Map->valueX[CREATE_VX_BGSIZE_HEIGHT]=(baseStage->tBuf)->get_width();
    rotateFlag=STAGE_BG_ROTATE270;
  }
}
void (CreateBackGround::*CreateBackGround::
      CREATE_BGSIZE_ROTATE_SELECT[STAGE_BG_ROTATE_NUM])()={
	&CreateBackGround::ShiftRotate0,
	&CreateBackGround::ShiftRotate90,
	&CreateBackGround::ShiftRotate180,
	&CreateBackGround::ShiftRotate270
};

void CreateBackGround::ShiftSize(){
  std::stringstream ss;
  std::string str; 
  int width0,width,height0,height;
  int px,py;
  int px0,py0,px1,py1;

  baseStage->VariableSelectAction
    (&Map->valueX[Map->valueY[CREATE_VY_SHIFT_BGSIZE]],
     &Map->valueY[CREATE_VY_SHIFT_BGSIZE],
     SELECTKEY_VARIABLE100);

  if(Map->valueY[CREATE_VY_SHIFT_BGSIZE]<CREATE_VX_BGSIZE_WIDTH){
    Map->valueY[CREATE_VY_SHIFT_BGSIZE]=CREATE_VX_BGSIZE_FLIP;
  }
  else if(Map->valueY[CREATE_VY_SHIFT_BGSIZE]>CREATE_VX_BGSIZE_FLIP){
    Map->valueY[CREATE_VY_SHIFT_BGSIZE]=CREATE_VX_BGSIZE_WIDTH;
  }
  
  if(Map->valueX[CREATE_VX_BGSIZE_ROTATE]<STAGE_BG_ROTATE0){
    Map->valueX[CREATE_VX_BGSIZE_ROTATE]=STAGE_BG_ROTATE0;
  }
  else if(Map->valueX[CREATE_VX_BGSIZE_ROTATE]>STAGE_BG_ROTATE270){
    Map->valueX[CREATE_VX_BGSIZE_ROTATE]=STAGE_BG_ROTATE270;
  }

  (this->*CREATE_BGSIZE_ROTATE_SELECT
   [Map->valueX[CREATE_VX_BGSIZE_ROTATE]])();

  if(Map->valueX[CREATE_VX_BGSIZE_WIDTH]<WIDTH){
    Map->valueX[CREATE_VX_BGSIZE_WIDTH]=WIDTH;
  }
  else if(Map->valueX[CREATE_VX_BGSIZE_WIDTH]>
	  CREATE_BACKGROUND_WIDTH_MAX){
    Map->valueX[CREATE_VX_BGSIZE_WIDTH]=CREATE_BACKGROUND_WIDTH_MAX;
  }

  if(Map->valueX[CREATE_VX_BGSIZE_HEIGHT]<HEIGHT){
    Map->valueX[CREATE_VX_BGSIZE_HEIGHT]=HEIGHT;
  }
  else if(Map->valueX[CREATE_VX_BGSIZE_HEIGHT]>
	  CREATE_BACKGROUND_HEIGHT_MAX){
    Map->valueX[CREATE_VX_BGSIZE_HEIGHT]=CREATE_BACKGROUND_HEIGHT_MAX;
  }
  
  if(Map->valueX[CREATE_VX_BGSIZE_FLIP]<STAGE_BG_NOFLIP){
    Map->valueX[CREATE_VX_BGSIZE_FLIP]=STAGE_BG_NOFLIP;
  }
  else if(Map->valueX[CREATE_VX_BGSIZE_FLIP]>STAGE_BG_VFLIP){
    Map->valueX[CREATE_VX_BGSIZE_FLIP]=STAGE_BG_VFLIP;
  }

  width=Map->valueX[CREATE_VX_BGSIZE_WIDTH];
  height=Map->valueX[CREATE_VX_BGSIZE_HEIGHT];
 
  width0=width;
  height0=height;
  
  (this->*CREATE_BG_ROTATE_VIEW
   [Map->valueX[CREATE_VX_BGSIZE_ROTATE]])(&width0,&height0);

  px1=WIDTH*(CREATE_BGSIZE_PX3)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(CREATE_BGSIZE_PY3
	      +CREATE_BGSIZE_MY3*CREATE_BGSIZE_WIDTH)/MAP_YMAX;
  ss<<"> "<<width<<"("<<width0<<"%)";
  str=ss.str(); 
  text->DrawString
    (str,color->white,px0,py0,
     CREATE_BGSIZE_LF3,CREATE_BGSIZE_SF3,
     CREATE_BGSIZE_TF3,CREATE_BGSIZE_FF3);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px0=px1;
  py0=HEIGHT*(CREATE_BGSIZE_PY3
	      +CREATE_BGSIZE_MY3*CREATE_BGSIZE_HEIGHT)/MAP_YMAX;
  ss<<"> "<<height<<"("<<height0<<"%)";
  str=ss.str(); 
  text->DrawString
    (str,color->white,px0,py0,
     CREATE_BGSIZE_LF3,CREATE_BGSIZE_SF3,
     CREATE_BGSIZE_TF3,CREATE_BGSIZE_FF3);
  ss.str("");
  ss.clear(std::stringstream::goodbit);
  
  px0=px1;
  py0=HEIGHT*(CREATE_BGSIZE_PY3
	      +CREATE_BGSIZE_MY3*CREATE_BGSIZE_ROTATE)/MAP_YMAX;
  ss<<"> "<<rotateName[Map->valueX[CREATE_VX_BGSIZE_ROTATE]];
  str=ss.str(); 
  text->DrawString
    (str,color->white,px0,py0,
     CREATE_BGSIZE_LF3,CREATE_BGSIZE_SF3,
     CREATE_BGSIZE_TF3,CREATE_BGSIZE_FF3);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px0=px1;
  py0=HEIGHT*(CREATE_BGSIZE_PY3
	      +CREATE_BGSIZE_MY3*CREATE_BGSIZE_FLIP)/MAP_YMAX;
  ss<<"> "<<flipName[Map->valueX[CREATE_VX_BGSIZE_FLIP]];
  str=ss.str(); 
  text->DrawString
    (str,color->white,px0,py0,
     CREATE_BGSIZE_LF3,CREATE_BGSIZE_SF3,
     CREATE_BGSIZE_TF3,CREATE_BGSIZE_FF3);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px=WIDTH*(135)/MAP_XMAX;
  py=HEIGHT*(CREATE_BGSIZE_PY1
	     +CREATE_BGSIZE_MY1*
	     (Map->valueY[CREATE_VY_SHIFT_BGSIZE]
	      -CREATE_VX_BGSIZE_WIDTH)
	     )/MAP_YMAX;
  enemyList->DrawSprite(EN_HOM_BIRD,EN_WAY_B,1,px,py);

  if(control->okValue){
    control->okValue=0;

    baseStage->FigureBackGround
      (width,height,
       Map->valueX[CREATE_VX_BGSIZE_ROTATE],
       Map->valueX[CREATE_VX_BGSIZE_FLIP]);

    std::cout<<"BACKGROUND SCALE"<<std::endl;
    baseStage->bgInterX=0;
    baseStage->bgInterY=0;
    if(baseStage->CalcBackGroundMove
       (STAGE_BG_MOV_MAXW,STAGE_BG_MOV_MAXH)!=0){
      std::cout<<"BACKGROUND MOV ERROR"<<std::endl;
    }
    else{
      std::cout<<"BACKGROUND MOV OK"<<std::endl;
    }

    Map->valueX[CREATE_VX_BACKGROUND_SHIFT]
      =CREATE_BACKGROUND_SHIFT_MENU;
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->valueX[CREATE_VX_BACKGROUND_SHIFT]
      =CREATE_BACKGROUND_SHIFT_MENU;
  }
}

void CreateBackGround::ShiftInterval(){
  int px,py;

  baseStage->VariableSelectAction
    (&Map->valueX[Map->valueY[CREATE_VY_SHIFT_BGINTERVAL]],
     &Map->valueY[CREATE_VY_SHIFT_BGINTERVAL],
     SELECTKEY_VARIABLE100); 

  if(Map->valueY[CREATE_VY_SHIFT_BGINTERVAL]<
     CREATE_VX_BGINTERVAL_XINTERVAL){
   Map->valueY[CREATE_VY_SHIFT_BGINTERVAL]=
     CREATE_VX_BGINTERVAL_YINTERVAL;
  }
  else if(Map->valueY[CREATE_VY_SHIFT_BGINTERVAL]>
     CREATE_VX_BGINTERVAL_YINTERVAL){
    Map->valueY[CREATE_VY_SHIFT_BGINTERVAL]=
      CREATE_VX_BGINTERVAL_XINTERVAL;
  }
  
  if(Map->valueX[CREATE_VX_BGINTERVAL_XINTERVAL]<0){
    Map->valueX[CREATE_VX_BGINTERVAL_XINTERVAL]=0;
  }
  else if(Map->valueX[CREATE_VX_BGINTERVAL_XINTERVAL]>maxInterX){
    Map->valueX[CREATE_VX_BGINTERVAL_XINTERVAL]=maxInterX;
  }
  
  baseStage->bgInterX=Map->valueX[CREATE_VX_BGINTERVAL_XINTERVAL];

  if(Map->valueX[CREATE_VX_BGINTERVAL_YINTERVAL]<0){
    Map->valueX[CREATE_VX_BGINTERVAL_YINTERVAL]=0;
  }
  else if(Map->valueX[CREATE_VX_BGINTERVAL_YINTERVAL]>maxInterY){
    Map->valueX[CREATE_VX_BGINTERVAL_YINTERVAL]=maxInterY;
  }
 
  baseStage->bgInterY=Map->valueX[CREATE_VX_BGINTERVAL_YINTERVAL];


  px=WIDTH*(135)/MAP_XMAX;
  py=HEIGHT*(CREATE_BGINTERVAL_PY1
	     +CREATE_BGINTERVAL_MY1*
	     (Map->valueY[CREATE_VY_SHIFT_BGINTERVAL]
	      -CREATE_VX_BGINTERVAL_XINTERVAL)
	     )/MAP_YMAX;


  enemyList->DrawSprite(EN_HOM_BIRD,EN_WAY_B,1,px,py);

  if(control->okValue){
    control->okValue=0;
    Map->valueX[CREATE_VX_BACKGROUND_SHIFT]
      =CREATE_BACKGROUND_SHIFT_MENU;
  }
  else if(control->cancelValue){
    control->cancelValue=0;
    Map->valueX[CREATE_VX_BACKGROUND_SHIFT]
      =CREATE_BACKGROUND_SHIFT_MENU;
  }
}

void (CreateBackGround::*CreateBackGround::
      CREATE_BACKGROUND_SHIFT_SELECT
      [CREATE_BACKGROUND_SHIFT_NUM])()={
	&CreateBackGround::ShiftMenu,
	&CreateBackGround::ShiftSize,
	&CreateBackGround::ShiftInterval,
};

void CreateBackGround::Rotate0View(int *width,int *height){
  *width=*width*100/(baseStage->tBuf)->get_width();  
  *height=*height*100/(baseStage->tBuf)->get_height();
}
void CreateBackGround::Rotate90View(int *width,int *height){
  *width=*width*100/(baseStage->tBuf)->get_height();  
  *height=*height*100/(baseStage->tBuf)->get_width();
}
void CreateBackGround::Rotate180View(int *width,int *height){
  *width=*width*100/(baseStage->tBuf)->get_width();  
  *height=*height*100/(baseStage->tBuf)->get_height();
}
void CreateBackGround::Rotate270View(int *width,int *height){
  *width=*width*100/(baseStage->tBuf)->get_height();  
  *height=*height*100/(baseStage->tBuf)->get_width();
}
void (CreateBackGround::*CreateBackGround::
      CREATE_BG_ROTATE_VIEW
      [STAGE_BG_ROTATE_NUM])(int *width,int *height)={
	&CreateBackGround::Rotate0View,
	&CreateBackGround::Rotate90View,
	&CreateBackGround::Rotate180View,
	&CreateBackGround::Rotate270View
      };

void CreateBackGround::BGDistanceText(int px1,int py1,int px2,int py2,
				 Gdk::Color *color0,
				 std::string name,std::string value){
  int px0,py0;

  px0=px1;
  py0=py1;
  text->DrawString
    (name,color0,px0,py0,
     CREATE_BGDISTANCE_LF1,CREATE_BGDISTANCE_SF1,
     CREATE_BGDISTANCE_TF1,CREATE_BGDISTANCE_FF1);
  px0=px2;
  py0=py1;
  text->DrawString
    (value,color0,px0,py0,
     CREATE_BGDISTANCE_LF1,CREATE_BGDISTANCE_SF1,
     CREATE_BGDISTANCE_TF1,CREATE_BGDISTANCE_FF1);
}

void CreateBackGround::BGSizeText(int px1,int py1,int px2,int py2,
				 Gdk::Color *color0,
				 std::string name,std::string value){
  int px0,py0;

  px0=px1;
  py0=py1;
  text->DrawString
    (name,color0,px0,py0,
     CREATE_BGSIZE_LF1,CREATE_BGSIZE_SF1,
     CREATE_BGSIZE_TF1,CREATE_BGSIZE_FF1);
  px0=px2;
  py0=py1;
  text->DrawString
    (value,color0,px0,py0,
     CREATE_BGSIZE_LF1,CREATE_BGSIZE_SF1,
     CREATE_BGSIZE_TF1,CREATE_BGSIZE_FF1);
}

void CreateBackGround::BGIntervalText(int px1,int py1,int px2,int py2,
				      Gdk::Color *color0,
				      std::string name,
				      std::string value){
  int px0,py0;

  px0=px1;
  py0=py1;
  text->DrawString
    (name,color0,px0,py0,
     CREATE_BGINTERVAL_LF1,CREATE_BGINTERVAL_SF1,
     CREATE_BGINTERVAL_TF1,CREATE_BGINTERVAL_FF1);
  px0=px2;
  py0=py1;
  text->DrawString
    (value,color0,px0,py0,
     CREATE_BGINTERVAL_LF1,CREATE_BGINTERVAL_SF1,
     CREATE_BGINTERVAL_TF1,CREATE_BGINTERVAL_FF1);
}

void CreateBackGround::Menu(){
  int px0,py0,sx0,sy0;
  int px1,py1,px2,py2;
  Gdk::Color *color0;
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  std::stringstream ss;
  std::string str; 

  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];

  if(baseStage->background){
    frame->draw_pixbuf
      ((baseStage->mGC),baseStage->background,
       baseStage->bgStartX*baseStage->bgMovW/STAGE_BG_MOV_POWX
        +baseStage->bgInterX,
       baseStage->bgStartY*baseStage->bgMovH/STAGE_BG_MOV_POWY
        +baseStage->bgInterY,
       0,0,WIDTH,HEIGHT,
       Gdk::RGB_DITHER_NONE,0,0);
  }
  else{
    RunWoodBG(0,0,WIDTH,HEIGHT);
  }
  
  cursorB[0]=Map->valueY[CREATE_VY_BACKGROUND_MENU];
  cursorB0[0]=CREATE_BACKGROUND_MENU_LOAD;
  cursorB[1]=Map->valueX[CREATE_VX_STATE_BACKGROUND];
  cursorB0[1]=CREATE_VY_BACKGROUND_MENU;

  px0=WIDTH*(CREATE_BACKGROUND_PX2-CREATE_BACKGROUND_SX2)/MAP_XMAX;
  py0=HEIGHT*(CREATE_BACKGROUND_PY2-CREATE_BACKGROUND_SY2
	      +CREATE_BACKGROUND_MY2
	      *CREATE_BACKGROUND_MENU_LOAD)/MAP_YMAX;
  sx0=WIDTH*(CREATE_BACKGROUND_SX2*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_BACKGROUND_SY2*2)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_BACKGROUND_DW2,py0+CREATE_BACKGROUND_DH2,
	    sx0-CREATE_BACKGROUND_DW2*2,sy0-CREATE_BACKGROUND_DH2*2);

  cursorB0[0]=CREATE_BACKGROUND_MENU_TOP;
  py0=HEIGHT*(CREATE_BACKGROUND_PY2-CREATE_BACKGROUND_SY2
	      +CREATE_BACKGROUND_MY2
	      *CREATE_BACKGROUND_MENU_TOP)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_BACKGROUND_DW2,py0+CREATE_BACKGROUND_DH2,
	    sx0-CREATE_BACKGROUND_DW2*2,sy0-CREATE_BACKGROUND_DH2*2);
  
  px1=WIDTH*(CREATE_BACKGROUND_PX2)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(CREATE_BACKGROUND_PY2+CREATE_BACKGROUND_MY2
	      *CREATE_BACKGROUND_MENU_LOAD)/MAP_YMAX;
  text->DrawString
    ("LOAD",color->black,px0,py0,
     CREATE_BACKGROUND_LF2,CREATE_BACKGROUND_SF2,
     CREATE_BACKGROUND_TF2,CREATE_BACKGROUND_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_BACKGROUND_PY2+CREATE_BACKGROUND_MY2
	      *CREATE_BACKGROUND_MENU_TOP)/MAP_YMAX;
  text->DrawString
    ("TOP",color->black,px0,py0,
     CREATE_BACKGROUND_LF2,CREATE_BACKGROUND_SF2,
     CREATE_BACKGROUND_TF2,CREATE_BACKGROUND_FF2);

  px0=WIDTH*(CREATE_BACKGROUND_PX4-CREATE_BACKGROUND_SX4)/MAP_XMAX;
  py0=HEIGHT*(CREATE_BACKGROUND_PY4-CREATE_BACKGROUND_SY4)/MAP_YMAX;
  sx0=WIDTH*(CREATE_BACKGROUND_SX4*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_BACKGROUND_SY4*2)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],0,CREATE_GC_BLACK,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_BACKGROUND_DW4,py0+CREATE_BACKGROUND_DH4,
	    sx0-CREATE_BACKGROUND_DW4*2,sy0-CREATE_BACKGROUND_DH4*2);

  px0=WIDTH*(CREATE_BACKGROUND_PX4)/MAP_XMAX;
  py0=HEIGHT*(700)/MAP_YMAX;
  text->DrawString
    ("STAGE DISTANCE",color->white,px0,py0,
     FONT_LINE_UPCENTER,15,
     FONT_SERIF,FONT_FACE_BOLD);
  
  px1=WIDTH*(CREATE_BGDISTANCE_PX1
	     +CREATE_BGDISTANCE_MX1*CREATE_BGDISTANCE_HX)/MAP_XMAX;
  px2=WIDTH*(CREATE_BGDISTANCE_PX2
	     +CREATE_BGDISTANCE_MX2*CREATE_BGDISTANCE_HX)/MAP_XMAX;
  py1=HEIGHT*(CREATE_BGDISTANCE_PY1
	      +CREATE_BGDISTANCE_MY1*CREATE_BGDISTANCE_VSTART)/MAP_YMAX;

  ss<<": "<<baseStage->bgStartX;
  str=ss.str();
  BGDistanceText(px1,py1,px2,0,color->white,"Start X",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  py1=HEIGHT*(CREATE_BGDISTANCE_PY1
	      +CREATE_BGDISTANCE_MY1*CREATE_BGDISTANCE_VMAX)/MAP_YMAX;
  ss<<": "<<baseStage->bgMaxX;
  str=ss.str();
  BGDistanceText(px1,py1,px2,0,color->white,"Max X",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  py1=HEIGHT*(CREATE_BGDISTANCE_PY1
	      +CREATE_BGDISTANCE_MY1*CREATE_BGDISTANCE_VMOV)/MAP_YMAX;
  ss<<": "<<baseStage->bgMovW;
  str=ss.str();
  BGDistanceText(px1,py1,px2,0,color->white,"Move W",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);  

  px1=WIDTH*(CREATE_BGDISTANCE_PX1
	     +CREATE_BGDISTANCE_MX1*CREATE_BGDISTANCE_HY)/MAP_XMAX;
  px2=WIDTH*(CREATE_BGDISTANCE_PX2
	     +CREATE_BGDISTANCE_MX2*CREATE_BGDISTANCE_HY)/MAP_XMAX;
  py1=HEIGHT*(CREATE_BGDISTANCE_PY1
	      +CREATE_BGDISTANCE_MY1*CREATE_BGDISTANCE_VSTART)/MAP_YMAX;

  ss<<": "<<baseStage->bgStartY;
  str=ss.str();
  BGDistanceText(px1,py1,px2,0,color->white,"Start Y",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);  

  py1=HEIGHT*(CREATE_BGDISTANCE_PY1
	      +CREATE_BGDISTANCE_MY1*CREATE_BGDISTANCE_VMAX)/MAP_YMAX;
  ss<<": "<<baseStage->bgMaxY;
  str=ss.str();
  BGDistanceText(px1,py1,px2,0,color->white,"Max Y",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);  

  py1=HEIGHT*(CREATE_BGDISTANCE_PY1
	      +CREATE_BGDISTANCE_MY1*CREATE_BGDISTANCE_VMOV)/MAP_YMAX;
  ss<<": "<<baseStage->bgMovH;
  str=ss.str();
  BGDistanceText(px1,py1,px2,0,color->white,"Move H",str);
  ss.str("");
  ss.clear(std::stringstream::goodbit);  

  if(baseStage->background){

    CalcMaxXInterval();
    CalcMaxYInterval();

    cursorB[0]=Map->valueY[CREATE_VY_BACKGROUND_STRUCT];
    cursorB0[0]=CREATE_BACKGROUND_STRUCT_SIZE;
    cursorB[1]=Map->valueX[CREATE_VX_STATE_BACKGROUND];
    cursorB0[1]=CREATE_VY_BACKGROUND_STRUCT;
    
    px0=WIDTH*(CREATE_BACKGROUND_PX1-CREATE_BACKGROUND_SX1)/MAP_XMAX;
    py0=HEIGHT*(CREATE_BACKGROUND_PY1-CREATE_BACKGROUND_SY1)/MAP_YMAX;
    sx0=WIDTH*(CREATE_BACKGROUND_SX1*2)/MAP_XMAX;
    sy0=HEIGHT*(CREATE_BACKGROUND_SY1*2)/MAP_YMAX;

    frame->draw_rectangle
      (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
		&cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
		CREATE_GC_BLACK),
       true,px0,py0,sx0,sy0);
    RunRockBG(px0+CREATE_BACKGROUND_DW1,py0+CREATE_BACKGROUND_DH1,
	      sx0-CREATE_BACKGROUND_DW1*2,sy0-CREATE_BACKGROUND_DH1*2);

    px0=WIDTH*(CREATE_BACKGROUND_PX1)/MAP_XMAX;
    py0=HEIGHT*(80)/MAP_YMAX;
    text->DrawString
      ("BACKGROUND SIZE",color->white,px0,py0,
       FONT_LINE_UPCENTER,15,
       FONT_SERIF,FONT_FACE_BOLD);

    int width0,width,height0,height;
    
    width=baseStage->bgWidth;
    height=baseStage->bgHeight;
    width0=width;
    height0=height;
    
    (this->*CREATE_BG_ROTATE_VIEW[baseStage->bgRotate])
      (&width0,&height0);
    
    cursorB[0]=Map->valueY[CREATE_VY_SHIFT_BGSIZE];
    cursorB0[0]=CREATE_VX_BGSIZE_WIDTH;
    cursorB[1]=Map->valueX[CREATE_VX_BACKGROUND_SHIFT];
    cursorB0[1]=CREATE_BACKGROUND_SHIFT_SIZE;
    
    px1=WIDTH*(CREATE_BGSIZE_PX1)/MAP_XMAX;
    px2=WIDTH*(CREATE_BGSIZE_PX2)/MAP_XMAX;
    py1=HEIGHT*(CREATE_BGSIZE_PY2
		+CREATE_BGSIZE_MY2*CREATE_BGSIZE_WIDTH)/MAP_YMAX;
    color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
			&cursorB[0],&cursorB0[0],2,color->yellow,
			color->white);

    ss<<": "<<width<<"("<<width0<<"%)";
    str=ss.str();
    BGSizeText(px1,py1,px2,0,color0,"WIDTH",str);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    cursorB0[0]=CREATE_VX_BGSIZE_HEIGHT;
    py1=HEIGHT*(CREATE_BGSIZE_PY2
		+CREATE_BGSIZE_MY2*CREATE_BGSIZE_HEIGHT)/MAP_YMAX;
    color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
			&cursorB[0],&cursorB0[0],2,color->yellow,
			color->white);
    ss<<": "<<height<<"("<<height0<<"%)";
    str=ss.str(); 
    BGSizeText(px1,py1,px2,0,color0,"HEIGHT",str);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    cursorB0[0]=CREATE_VX_BGSIZE_ROTATE;
    py1=HEIGHT*(CREATE_BGSIZE_PY2
		+CREATE_BGSIZE_MY2*CREATE_BGSIZE_ROTATE)/MAP_YMAX;
    color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
			&cursorB[0],&cursorB0[0],2,color->yellow,
			color->white);
    ss<<": "<<rotateName[baseStage->bgRotate];
    str=ss.str(); 
    BGSizeText(px1,py1,px2,0,color0,"ROTATE",str);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    cursorB0[0]=CREATE_VX_BGSIZE_FLIP;
    py1=HEIGHT*(CREATE_BGSIZE_PY2
		+CREATE_BGSIZE_MY2*CREATE_BGSIZE_FLIP)/MAP_YMAX;
    color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
			&cursorB[0],&cursorB0[0],2,color->yellow,
			color->white);
    ss<<": "<<flipName[baseStage->bgFlip];
    str=ss.str(); 
    BGSizeText(px1,py1,px2,0,color0,"FLIP",str);
    ss.str("");
    ss.clear(std::stringstream::goodbit);
    
    cursorB[0]=Map->valueY[CREATE_VY_BACKGROUND_STRUCT];
    cursorB0[0]=CREATE_BACKGROUND_STRUCT_INTERVAL;
    cursorB[1]=Map->valueX[CREATE_VX_STATE_BACKGROUND];
    cursorB0[1]=CREATE_VY_BACKGROUND_STRUCT;

    px0=WIDTH*(CREATE_BACKGROUND_PX3-CREATE_BACKGROUND_SX3)/MAP_XMAX;
    py0=HEIGHT*(CREATE_BACKGROUND_PY3-CREATE_BACKGROUND_SY3)/MAP_YMAX;
    sx0=WIDTH*(CREATE_BACKGROUND_SX3*2)/MAP_XMAX;
    sy0=HEIGHT*(CREATE_BACKGROUND_SY3*2)/MAP_YMAX;

    frame->draw_rectangle
      (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
		&cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
		CREATE_GC_BLACK),
       true,px0,py0,sx0,sy0);
    RunRockBG(px0+CREATE_BACKGROUND_DW3,py0+CREATE_BACKGROUND_DH3,
	      sx0-CREATE_BACKGROUND_DW3*2,sy0-CREATE_BACKGROUND_DH3*2);

    px0=WIDTH*(CREATE_BACKGROUND_PX3)/MAP_XMAX;
    py0=HEIGHT*(440)/MAP_YMAX;
    text->DrawString
      ("BACKGROUND INTERVAL",color->white,px0,py0,
       FONT_LINE_UPCENTER,15,
       FONT_SERIF,FONT_FACE_BOLD);

    cursorB[0]=Map->valueY[CREATE_VY_SHIFT_BGINTERVAL];
    cursorB0[0]=CREATE_VX_BGINTERVAL_XINTERVAL;
    cursorB[1]=Map->valueX[CREATE_VX_BACKGROUND_SHIFT];
    cursorB0[1]=CREATE_BACKGROUND_SHIFT_INTERVAL;

    px1=WIDTH*(CREATE_BGINTERVAL_PX1)/MAP_XMAX;
    px2=WIDTH*(CREATE_BGINTERVAL_PX2)/MAP_XMAX;
    py1=HEIGHT*(CREATE_BGINTERVAL_PY2+CREATE_BGINTERVAL_MY2
		*CREATE_BGINTERVAL_XINTERVAL)/MAP_YMAX;
    color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
			&cursorB[0],&cursorB0[0],2,color->yellow,
			color->white);
    ss<<": "<<baseStage->bgInterX
      <<" (<"<<maxInterX<<")";
    str=ss.str();
    BGIntervalText(px1,py1,px2,0,color0,"X Interval",str);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    cursorB0[0]=CREATE_VX_BGINTERVAL_YINTERVAL;
    py1=HEIGHT*(CREATE_BGINTERVAL_PY2+CREATE_BGINTERVAL_MY2
		*CREATE_BGINTERVAL_YINTERVAL)/MAP_YMAX;
    color0=ColorSelect0(&cursorA[0],&cursorA0[0],0,color->red,
			&cursorB[0],&cursorB0[0],2,color->yellow,
			color->white);
    ss<<": "<<baseStage->bgInterY
      <<" (<"<<maxInterY<<")";
    str=ss.str();
    BGIntervalText(px1,py1,px2,0,color0,"Y Interval",str);
    ss.str("");
    ss.clear(std::stringstream::goodbit);

    (this->*CREATE_BACKGROUND_SHIFT_SELECT
     [Map->valueX[CREATE_VX_BACKGROUND_SHIFT]])();

  }
  else{
    Map->valueX[CREATE_VX_BACKGROUND_SHIFT]=0;

    baseStage->VariableSelectAction
      (&Map->valueX[CREATE_VX_STATE_BACKGROUND],
       &Map->valueY[Map->valueX[CREATE_VX_STATE_BACKGROUND]],
       SELECTKEY_VARIABLE1);
    
    if(Map->valueX[CREATE_VX_STATE_BACKGROUND]!=
       CREATE_VY_BACKGROUND_MENU){
      Map->valueX[CREATE_VX_STATE_BACKGROUND]
	=CREATE_VY_BACKGROUND_MENU;
    }
        
    if(Map->valueY[CREATE_VY_BACKGROUND_MENU]<0){
      Map->valueY[CREATE_VY_BACKGROUND_MENU]
	=CREATE_BACKGROUND_MENU_NUM-1;
    }
    else if(Map->valueY[CREATE_VY_BACKGROUND_MENU]>=
	    CREATE_BACKGROUND_MENU_NUM){
      Map->valueY[CREATE_VY_BACKGROUND_MENU]=0;
    }
    
    if(control->okValue){
      control->okValue=0;
      
      (this->*CREATE_BACKGROUND_SELECT
       [Map->valueX[CREATE_VX_STATE_BACKGROUND]
	-CREATE_VY_BACKGROUND_STRUCT])();
    }
    else if(control->cancelValue){
      control->cancelValue=0;
      Map->state=Map->state0;
    }
  }

  mWindow->invalidate_rect(rect,false);
}

int CreateBackGround::CalcMaxXInterval(){
  int movW;
  int flag=0;

  if(baseStage->background){
    movW=baseStage->bgWidth-WIDTH;
    
    if(baseStage->bgMovW>0){
      maxInterX=movW
	-baseStage->bgMaxX*baseStage->bgMovW/STAGE_BG_MOV_POWX;
      if(maxInterX<0){
	flag=1;
	maxInterX=0;
	/*
	std::cout<<"MAX X INTERVAL ERROR"<<std::endl;
	*/
      }
      else{
	/*
	std::cout<<"MAX X INTERVAL OK"<<std::endl;
	*/
      }
    }
    else{
      /*
      std::cout<<"MAX X NO INTERVAL"<<std::endl;
      */
      baseStage->bgMovW=0;
      maxInterX=movW;
    }
  }
  else{
    baseStage->bgMovW=0;
    maxInterX=movW;
  }

  return flag;
}

int CreateBackGround::CalcMaxYInterval(){
  int movH;
  int flag=0;

  if(baseStage->background){
    movH=baseStage->bgHeight-HEIGHT;  
    
    if(baseStage->bgMovH>0){
      maxInterY=movH
	-baseStage->bgMaxY*baseStage->bgMovH/STAGE_BG_MOV_POWY;
      if(maxInterY<0){
	flag=1;
	maxInterY=0;
	/*
	std::cout<<"MAX Y INTERVAL ERROR"<<std::endl;
	*/
      }
      else{
	/*
	std::cout<<"MAX Y INTERVAL OK"<<std::endl;
	*/
      }
    }
    else{
      /*
      std::cout<<"MAX Y NO INTERVAL"<<std::endl;
      */
      baseStage->bgMovH=0;
      maxInterY=movH;
    }
  }
  else{
    baseStage->bgMovH=0;
    maxInterY=0;
  }

  return flag;
}
