#ifndef BIRD_PLAY_CREATESTAGE_H_
#define BIRD_PLAY_CREATESTAGE_H_

#include "basestage.h"
#include "namedialog.h"

#define PLAYCREATE_STATE_INIT 0
#define PLAYCREATE_STATE_GAMESTART 1
#define PLAYCREATE_STATE_GAME 2
#define PLAYCREATE_STATE_PAUSE 3
#define PLAYCREATE_STATE_GAMEEND 4
#define PLAYCREATE_STATE_GAMEOVER 5
#define PLAYCREATE_STATE_NUM 6

#define PLAYCREATE_VY_STATE_PAUSE 0

class PlayCreate :public BaseStage {
 private:
  int waitCount;
 public:
  std::string folderPath;
  std::string namePath;
  int stageID;
  PlayCreate();
  ~PlayCreate();
  void Create();

  void InitSlide();
  void StartSlide();
  void GameView();
  void PauseView();
  void EndSlide();
  void GameOver();
  static void(PlayCreate::*PLAYCREATE_STATE_SELECT
	      [PLAYCREATE_STATE_NUM])();

  void ViewMap();
};

#endif
