#include"createtop.h"

CreateTop::CreateTop(){
  
}

CreateTop::~CreateTop(){

}

void CreateTop::Create(){

}

void CreateTop::TopBackGroundSelect(){

  if(baseStage->CalcStageDistance()){
    std::cout<<"STAGE DISTANCE ERROR"<<std::endl;
  }
  else{
    std::cout<<"STAGE DISTANCE OK"<<std::endl;
  }

  if(baseStage->CalcBackGroundMove(2000,2000)!=0){
    std::cout<<"BACKGROUND MOV ERROR"<<std::endl;
  }
  else{
    std::cout<<"BACKGROUND MOV OK"<<std::endl;
  }
  
  Map->state0=CREATE_STATE_TOP;
  Map->state=CREATE_STATE_BACKGROUND;
}
void CreateTop::TopTimeLineSelect(){
  Map->state0=CREATE_STATE_TOP;
  Map->state=CREATE_STATE_TIMELINE;
}
void CreateTop::TopModalSelect(){
  Map->state0=CREATE_STATE_TOP;
  Map->state=CREATE_STATE_MODAL;
}
void CreateTop::TopLandSelect(){
  Map->state0=CREATE_STATE_TOP;
  Map->state=CREATE_STATE_LAND;
}
void CreateTop::TopCrowdSelect(){
  Map->state0=CREATE_STATE_TOP;
  Map->state=CREATE_STATE_CROWD;
}
void (CreateTop::*CreateTop::CREATE_TOP_LEFT_SELECT[CREATE_TOP_LNUM])()={
  &CreateTop::TopBackGroundSelect,
  &CreateTop::TopTimeLineSelect,
  &CreateTop::TopModalSelect,
  &CreateTop::TopLandSelect,
  &CreateTop::TopCrowdSelect
};

void CreateTop::TopSaveSelect(){
  Glib::ustring path,path0;
  Glib::ustring file;
  Glib::ustring folder;
  Glib::ustring name;

  Gtk::FileChooserDialog diag
    ("SAVE STAGE",Gtk::FILE_CHOOSER_ACTION_SAVE);
  diag.add_button(Gtk::Stock::SAVE, Gtk::RESPONSE_OK);
  diag.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
  diag.set_icon(mIcon);

  std::cout<<diag.get_current_folder()<<std::endl;

  path0=diag.get_current_folder();

  path=path0+"/stage";

  if(diag.set_current_folder(path)){
    std::cout<<"FIND FOLDER:"<<path<<std::endl;
  }
  else{
    std::cout<<"FALSE FOLDER:"<<diag.get_current_folder()<<std::endl;
  }

  switch( diag.run() ){

  case Gtk::RESPONSE_OK:
    
    file=diag.get_filename();
    folder=diag.get_current_folder();

    name=file;
    name.erase(name.find(folder,0),folder.size()+1);

    if(folder.find(path0,0)!=std::string::npos){
      folder.erase(folder.find(path0,0),path0.size()+1);
    }

    std::cout<<"SAVE FILE:"<<file<<std::endl;
    std::cout<<"SAVE NAME:"<<name<<std::endl;

    baseStage->SaveCrowd
      (Glib::locale_from_utf8(folder),Glib::locale_from_utf8(name));
    baseStage->SaveLand
      (Glib::locale_from_utf8(folder),Glib::locale_from_utf8(name));
    baseStage->SaveModal
      (Glib::locale_from_utf8(folder),Glib::locale_from_utf8(name));
    baseStage->SaveStage
      (Glib::locale_from_utf8(folder),Glib::locale_from_utf8(name));
    break;
    
  case Gtk::RESPONSE_CANCEL:
    
    break;
  }

  diag.show();
  diag.resize( 200, 100 );    
}
void CreateTop::TopLoadSelect(){
  Glib::ustring path0,path;
  Glib::ustring file;
  Glib::ustring name;
  Glib::ustring folder;
  int position;
  int crowdFlag;
  int landFlag;
  int modalFlag;
  int stageFlag;

  Gtk::FileChooserDialog diag
    ("LOAD STAGE",Gtk::FILE_CHOOSER_ACTION_OPEN);
  diag.add_button(Gtk::Stock::OPEN, Gtk::RESPONSE_OK);
  diag.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
  diag.set_icon(mIcon); 
 
  Gtk::FileFilter filt;
  filt.set_name("stage");
  filt.add_pattern("*.stage");
  diag.add_filter( filt );

  path0=diag.get_current_folder();

  path=path0+"/stage";

  if(diag.set_current_folder(path)){
    std::cout<<"FIND FOLDER:"<<path<<std::endl;
  }
  else{
    std::cout<<"FALSE FOLDER:"<<diag.get_current_folder()<<std::endl;
  }

  switch(diag.run()){

  case Gtk::RESPONSE_OK:
    file=diag.get_filename();
    folder=diag.get_current_folder();

    name=file;
    name.erase(name.find(folder,0),folder.size()+1);
    name.erase(name.find(".stage",0),6);

    if(folder.find(path0,0)!=std::string::npos){
      folder.erase(folder.find(path0,0),path0.size()+1);
    }

    std::cout<<"FILE:"<<file<<std::endl;
    std::cout<<"FOLDER:"<<folder<<std::endl;
    std::cout<<"NAME:"<<name<<std::endl;
    
    baseStage->LoadBirdWatch
    (Glib::locale_from_utf8(folder),Glib::locale_from_utf8(name));

    break;
    
  case Gtk::RESPONSE_CANCEL:
    break;
  }
 
  diag.show();
  diag.resize(200,100);
}
void CreateTop::TopPlaySelect(){
  if(baseStage->CalcStageDistance()){
    std::cout<<"STAGE DISTANCE ERROR"<<std::endl;
  }
  else{
    std::cout<<"STAGE DISTANCE OK"<<std::endl;
  }

  if(baseStage->CalcBackGroundMove(2000,2000)!=0){
    std::cout<<"BACKGROUND MOV ERROR"<<std::endl;
  }
  else{
    std::cout<<"BACKGROUND MOV OK"<<std::endl;
  }
  Map->state=CREATE_STATE_GAMESTART;
}
void CreateTop::TopStatusSelect(){
  Map->valueX[CREATE_VX_STATUS_LIFE]=baseStage->initLife;
  Map->valueX[CREATE_VX_STATUS_FIRE]=baseStage->initFire;
  Map->valueX[CREATE_VX_STATUS_FORM]=baseStage->initForm;
  Map->state0=CREATE_STATE_TOP;
  Map->state=CREATE_STATE_STATUS;
}
void CreateTop::TopExitSelect(){
  Map->state0=CREATE_STATE_TOP;
  Map->state=CREATE_STATE_EXIT;
}
void (CreateTop::*CreateTop::CREATE_TOP_RIGHT_SELECT[CREATE_TOP_RNUM])
  ()={
  &CreateTop::TopSaveSelect,
  &CreateTop::TopLoadSelect,
  &CreateTop::TopPlaySelect,
  &CreateTop::TopStatusSelect,
  &CreateTop::TopExitSelect
};

void CreateTop::TopLeftSelect(){
  (this->*CREATE_TOP_LEFT_SELECT
   [Map->valueY[CREATE_VY_TOP_LPLACE]])();
}
void CreateTop::TopRightSelect(){
  (this->*CREATE_TOP_RIGHT_SELECT
   [Map->valueY[CREATE_VY_TOP_RPLACE]])();
}

void (CreateTop::*CreateTop::CREATE_TOP_PLACE_SELECT[CREATE_TOP_NPLACE])
  ()={
    &CreateTop::TopLeftSelect,
    &CreateTop::TopRightSelect
};


void CreateTop::TopMenu(){
  int px0,py0,sx0,sy0;
  int px1,py1;
  int cursorA[10];
  int cursorA0[10];
  int cursorB[10];
  int cursorB0[10];
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  RunWoodBG(0,0,WIDTH,HEIGHT);

  cursorB[0]=Map->valueY[CREATE_VY_TOP_RPLACE];
  cursorB0[0]=CREATE_TOP_SAVE;
  cursorB[1]=Map->valueX[CREATE_VX_STATE_TOP];
  cursorB0[1]=CREATE_VY_TOP_RPLACE;
  px0=WIDTH*(CREATE_TOP_CX2-CREATE_TOP_SX2)/MAP_XMAX;
  py0=HEIGHT*(CREATE_TOP_CY2-CREATE_TOP_SY2
	      +CREATE_TOP_MY2*CREATE_TOP_SAVE)/MAP_YMAX;
  sx0=WIDTH*(CREATE_TOP_SX2*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_TOP_SY2*2)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TOP_DX2,py0+CREATE_TOP_DY2,
	    sx0-CREATE_TOP_DX2*2,sy0-CREATE_TOP_DY2*2);
 

  cursorB0[0]=CREATE_TOP_LOAD;
  py0=HEIGHT*(CREATE_TOP_CY2-CREATE_TOP_SY2
	      +CREATE_TOP_MY2*CREATE_TOP_LOAD)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
          true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TOP_DX2,py0+CREATE_TOP_DY2,
	    sx0-CREATE_TOP_DX2*2,sy0-CREATE_TOP_DY2*2);

  cursorB0[0]=CREATE_TOP_PLAY;
  py0=HEIGHT*(CREATE_TOP_CY2-CREATE_TOP_SY2
	      +CREATE_TOP_MY2*CREATE_TOP_PLAY)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TOP_DX2,py0+CREATE_TOP_DY2,
	    sx0-CREATE_TOP_DX2*2,sy0-CREATE_TOP_DY2*2);

  cursorB0[0]=CREATE_TOP_STATUS;
  py0=HEIGHT*(CREATE_TOP_CY2-CREATE_TOP_SY2
	      +CREATE_TOP_MY2*CREATE_TOP_STATUS)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TOP_DX2,py0+CREATE_TOP_DY2,
	    sx0-CREATE_TOP_DX2*2,sy0-CREATE_TOP_DY2*2);

  cursorB0[0]=CREATE_TOP_EXIT;
  py0=HEIGHT*(CREATE_TOP_CY2-CREATE_TOP_SY2
	      +CREATE_TOP_MY2*CREATE_TOP_EXIT)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TOP_DX2,py0+CREATE_TOP_DY2,
	    sx0-CREATE_TOP_DX2*2,sy0-CREATE_TOP_DY2*2);
  
  cursorB[0]=Map->valueY[CREATE_VY_TOP_LPLACE];
  cursorB0[0]=CREATE_TOP_BACKGROUND;
  cursorB[1]=Map->valueX[CREATE_VX_STATE_TOP];
  cursorB0[1]=CREATE_VY_TOP_LPLACE;
  px0=WIDTH*(CREATE_TOP_CX1-CREATE_TOP_SX1)/MAP_XMAX;
  py0=HEIGHT*(CREATE_TOP_CY1-CREATE_TOP_SY1
	      +CREATE_TOP_MY1*CREATE_TOP_BACKGROUND)/MAP_YMAX;
  sx0=WIDTH*(CREATE_TOP_SX1*2)/MAP_XMAX;
  sy0=HEIGHT*(CREATE_TOP_SY1*2)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TOP_DX1,py0+CREATE_TOP_DY1,
	    sx0-CREATE_TOP_DX1*2,sy0-CREATE_TOP_DY1*2);

  cursorB0[0]=CREATE_TOP_TLINE;
  py0=HEIGHT*(CREATE_TOP_CY1-CREATE_TOP_SY1
	      +CREATE_TOP_MY1*CREATE_TOP_TLINE)/MAP_YMAX;

  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TOP_DX1,py0+CREATE_TOP_DY1,
	    sx0-CREATE_TOP_DX1*2,sy0-CREATE_TOP_DY1*2);

  cursorB0[0]=CREATE_TOP_MODAL;
  py0=HEIGHT*(CREATE_TOP_CY1-CREATE_TOP_SY1
	      +CREATE_TOP_MY1*CREATE_TOP_MODAL)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TOP_DX1,py0+CREATE_TOP_DY1,
	    sx0-CREATE_TOP_DX1*2,sy0-CREATE_TOP_DY1*2);

  cursorB0[0]=CREATE_TOP_LAND;
  py0=HEIGHT*(CREATE_TOP_CY1-CREATE_TOP_SY1
	      +CREATE_TOP_MY1*CREATE_TOP_LAND)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TOP_DX1,py0+CREATE_TOP_DY1,
	    sx0-CREATE_TOP_DX1*2,sy0-CREATE_TOP_DY1*2);

  cursorB0[0]=CREATE_TOP_CROWD;
  py0=HEIGHT*(CREATE_TOP_CY1-CREATE_TOP_SY1
	      +CREATE_TOP_MY1*CREATE_TOP_CROWD)/MAP_YMAX;
  frame->draw_rectangle
    (CursorGC(&cursorA[0],&cursorA0[0],0,CREATE_GC_YELLOW,
	      &cursorB[0],&cursorB0[0],2,CREATE_GC_SKY,
	      CREATE_GC_BLACK),
     true,px0,py0,sx0,sy0);
  RunRockBG(px0+CREATE_TOP_DX1,py0+CREATE_TOP_DY1,
	    sx0-CREATE_TOP_DX1*2,sy0-CREATE_TOP_DY1*2);

  px1=WIDTH*(CREATE_TOP_CX2)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(CREATE_TOP_CY2+CREATE_TOP_MY2*CREATE_TOP_SAVE)/MAP_YMAX;
  text->DrawString
    ("SAVE",(color->black),px0,py0,
     CREATE_TOP_LF2,CREATE_TOP_SF2,
     CREATE_TOP_TF2,CREATE_TOP_FF2);
  
  px0=px1;
  py0=HEIGHT*(CREATE_TOP_CY2+CREATE_TOP_MY2*CREATE_TOP_LOAD)/MAP_YMAX;
  text->DrawString
    ("LOAD",(color->black),px0,py0,
     CREATE_TOP_LF2,CREATE_TOP_SF2,
     CREATE_TOP_TF2,CREATE_TOP_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_TOP_CY2+CREATE_TOP_MY2*CREATE_TOP_PLAY)/MAP_YMAX;
  text->DrawString
    ("PLAY",(color->black),px0,py0,
     CREATE_TOP_LF2,CREATE_TOP_SF2,
     CREATE_TOP_TF2,CREATE_TOP_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_TOP_CY2+CREATE_TOP_MY2*CREATE_TOP_STATUS)/MAP_YMAX;
  text->DrawString
    ("STATUS",(color->black),px0,py0,
     CREATE_TOP_LF2,CREATE_TOP_SF2,
     CREATE_TOP_TF2,CREATE_TOP_FF2);

  px0=px1;
  py0=HEIGHT*(CREATE_TOP_CY2+CREATE_TOP_MY2*CREATE_TOP_EXIT)/MAP_YMAX;
  text->DrawString
    ("EXIT",(color->black),px0,py0,
     CREATE_TOP_LF2,CREATE_TOP_SF2,
     CREATE_TOP_TF2,CREATE_TOP_FF2);

  px1=WIDTH*(CREATE_TOP_CX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(CREATE_TOP_CY1+CREATE_TOP_MY1
	      *CREATE_TOP_BACKGROUND)/MAP_YMAX;
  text->DrawString
    ("BACKGROUND",(color->black),px0,py0,
     CREATE_TOP_LF1,CREATE_TOP_SF1,
     CREATE_TOP_TF1,CREATE_TOP_FF1);

  px0=px1;
  py0=HEIGHT*(CREATE_TOP_CY1+CREATE_TOP_MY1*CREATE_TOP_TLINE)/MAP_YMAX;
  text->DrawString
    ("CREATE TIMELINE",(color->black),px0,py0,
     CREATE_TOP_LF1,CREATE_TOP_SF1,
     CREATE_TOP_TF1,CREATE_TOP_FF1);

  px0=px1;
  py0=HEIGHT*(CREATE_TOP_CY1+CREATE_TOP_MY1*CREATE_TOP_MODAL)/MAP_YMAX;
  text->DrawString
    ("CREATE MODAL",(color->black),px0,py0,
     CREATE_TOP_LF1,CREATE_TOP_SF1,
     CREATE_TOP_TF1,CREATE_TOP_FF1);

  px0=px1;
  py0=HEIGHT*(CREATE_TOP_CY1+CREATE_TOP_MY1*CREATE_TOP_LAND)/MAP_YMAX;
  text->DrawString
    ("CREATE LAND",(color->black),px0,py0,
     CREATE_TOP_LF1,CREATE_TOP_SF1,
     CREATE_TOP_TF1,CREATE_TOP_FF1);

  px0=px1;
  py0=HEIGHT*(CREATE_TOP_CY1+CREATE_TOP_MY1*CREATE_TOP_CROWD)/MAP_YMAX;
  text->DrawString
    ("CREATE CROWD",(color->black),px0,py0,
     CREATE_TOP_LF1,CREATE_TOP_SF1,
     CREATE_TOP_TF1,CREATE_TOP_FF1);

  baseStage->VariableSelectAction
    (&Map->valueX[CREATE_VX_STATE_TOP],
     &Map->valueY[Map->valueX[CREATE_VX_STATE_TOP]],
     SELECTKEY_VARIABLE1);
  
  if(Map->valueX[CREATE_VX_STATE_TOP]<CREATE_VY_TOP_LPLACE){
    Map->valueX[CREATE_VX_STATE_TOP]=CREATE_VY_TOP_RPLACE;
  }
  else if(Map->valueX[CREATE_VX_STATE_TOP]>CREATE_VY_TOP_RPLACE){
     Map->valueX[CREATE_VX_STATE_TOP]=CREATE_VY_TOP_LPLACE;
  }

  if(Map->valueX[CREATE_VX_STATE_TOP]==CREATE_VY_TOP_LPLACE){
    if(Map->valueY[CREATE_VY_TOP_LPLACE]<0){
      Map->valueY[CREATE_VY_TOP_LPLACE]=CREATE_TOP_LNUM-1;
    }
    else if(Map->valueY[CREATE_VY_TOP_LPLACE]>=CREATE_TOP_LNUM){
      Map->valueY[CREATE_VY_TOP_LPLACE]=0;
    }
  }
  else if(Map->valueX[CREATE_VX_STATE_TOP]==CREATE_VY_TOP_RPLACE){
    if(Map->valueY[CREATE_VY_TOP_RPLACE]<0){
      Map->valueY[CREATE_VY_TOP_RPLACE]=CREATE_TOP_RNUM-1;
    }
    else if(Map->valueY[CREATE_VY_TOP_RPLACE]>=CREATE_TOP_RNUM){
      Map->valueY[CREATE_VY_TOP_RPLACE]=0;
    }
  }

  if(control->okValue){
    control->okValue=0;
    (this->*CREATE_TOP_PLACE_SELECT[Map->valueX[CREATE_VX_STATE_TOP]])();
  }

  if(control->cancelValue){
    control->cancelValue=0;
    Map->state0=CREATE_STATE_TOP;
    Map->state=CREATE_STATE_EXIT;
  }
  
  mWindow->invalidate_rect(rect,false);
}
