#include "scoremap.h"

ScoreMap::ScoreMap(){
  mapNum=0;
  mapMax=0;
  scoreType=0;
  bossType=0;
  DeleteList();

  try{
    background=Gdk::Pixbuf::create_from_file("image/wood.png");
  }
  catch(...){
    background.clear();
  }
}

ScoreMap::~ScoreMap(){
  DeleteList();
}

void ScoreMap::Create(){
  backGC=Gdk::GC::create(mWindow);
  backGC->set_rgb_fg_color(*(color->brown));
  blackGC=Gdk::GC::create(mWindow);
  blackGC->set_rgb_fg_color(*(color->black));
  scoreFile->ReadFile();
}

void ScoreMap::ScoreMapSelectAction0(int *valueX,int *valueY,int force){
  //DUMMY
}
void ScoreMap::ScoreMapSelectAction1(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  mapNum--;
  Map->state=SCOREMAP_STATE_SCORESHIFT;
}
void ScoreMap::ScoreMapSelectAction2(int *valueX,int *valueY,int force){
  *valueY-=force;
}
void ScoreMap::ScoreMapSelectAction3(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
}
void ScoreMap::ScoreMapSelectAction4(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&4;
  mapNum++;
  Map->state=SCOREMAP_STATE_SCORESHIFT;
}
void ScoreMap::ScoreMapSelectAction5(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&4;  
}
void ScoreMap::ScoreMapSelectAction6(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&2;  
  control->selectValue-=control->selectValue&4;  
}
void ScoreMap::ScoreMapSelectAction7(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;  
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
}
void ScoreMap::ScoreMapSelectAction8(int *valueX,int *valueY,int force){
  *valueY+=force;
}
void ScoreMap::ScoreMapSelectAction9(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&8;
}
void ScoreMap::ScoreMapSelectAction10(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&8;
}
void ScoreMap::ScoreMapSelectAction11(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&8;
}
void ScoreMap::ScoreMapSelectAction12(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void ScoreMap::ScoreMapSelectAction13(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void ScoreMap::ScoreMapSelectAction14(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void ScoreMap::ScoreMapSelectAction15(int *valueX,int *valueY,int force){
  control->selectValue-=control->selectValue&1;
  control->selectValue-=control->selectValue&2;
  control->selectValue-=control->selectValue&4;
  control->selectValue-=control->selectValue&8;
}
void (ScoreMap::*ScoreMap::SCOREMAP_SELECT_ACTION[16])
  (int *valueX,int *valueY,int force)={
  &ScoreMap::ScoreMapSelectAction0,
  &ScoreMap::ScoreMapSelectAction1,
  &ScoreMap::ScoreMapSelectAction2,
  &ScoreMap::ScoreMapSelectAction3,
  &ScoreMap::ScoreMapSelectAction4,
  &ScoreMap::ScoreMapSelectAction5,
  &ScoreMap::ScoreMapSelectAction6,
  &ScoreMap::ScoreMapSelectAction7,
  &ScoreMap::ScoreMapSelectAction8,
  &ScoreMap::ScoreMapSelectAction9,
  &ScoreMap::ScoreMapSelectAction10,
  &ScoreMap::ScoreMapSelectAction11,
  &ScoreMap::ScoreMapSelectAction12,
  &ScoreMap::ScoreMapSelectAction13,
  &ScoreMap::ScoreMapSelectAction14,
  &ScoreMap::ScoreMapSelectAction15
};

void ScoreMap::ScoreMapSelectAction
(int selectValue,int *valueX,int *valueY,int force){
  (this->*SCOREMAP_SELECT_ACTION[selectValue])(valueX,valueY,force);
}

void ScoreMap::DeleteList(){
  int i;
  i=0;
  while(i<SCOREMAP_LIST_MAX){
    scoreList[i]=NULL;
    i++;
  }
  listIndex=0;
  listSize=0;
}

void ScoreMap::SetScoreElement(int *element,int *value,int length){
  BirdScore *node;
  BirdScore *tmp;
  int i,j;
  int flag=0;
  int matchFlag;
  int tElement,tValue;

  DeleteList();

  node=scoreFile->first;
  j=0;
  i=0;
  while(node){
    tmp=node->next;
    j=0;
    matchFlag=0;
    while(j<length){
      tElement=scoreFile->ValueSelect(node,*(element+j));
      if(tElement!=*(value+j)){
	matchFlag=1;
	break;
      }
      j++;
    }
    if(matchFlag){
      
    }
    else{
      scoreList[i]=node;
      i++;
    }

    if(i>=SCOREMAP_LIST_MAX){
      listSize=SCOREMAP_LIST_MAX;
      flag=1;
      break;
    }
    node=tmp;
  }
  
  if(flag){
    
  }
  else{
    listSize=i;
  }
}

void ScoreMap::SetScore(int *mode,int length){
  BirdScore *node;
  BirdScore *tmp;
  int i,j;
  int flag=0;

  DeleteList();

  node=scoreFile->first;
  j=0;
  i=0;
  while(node){
    tmp=node->next;
    j=0;
    while(j<length){
      if(node->mode==*(mode+j)){
	scoreList[i]=node;
	i++;
	break;
      }
      j++;
    }
    
    if(i>=SCOREMAP_LIST_MAX){
      listSize=SCOREMAP_LIST_MAX;
      flag=1;
      break;
    }
    node=tmp;
  }
  
  if(flag){
    
  }
  else{
    listSize=i;
  }
  
}

void ScoreMap::TypeStreamSelect(){
  scoreFile->SortList(SCORE_ELEMENT_SCORE,SCORE_FORM_ASCEND);
  scoreType=SCOREMAP_SCORETYPE_STREAM;
  Map->state0=Map->state;
  Map->state=SCOREMAP_STATE_SCORESHIFT;
  mapNum=0;
  mapMax=5;
  mapName[0]="Very Easy";
  mapID[0]=0;
  mapName[1]="Easy";
  mapID[1]=1;
  mapName[2]="Normal";
  mapID[2]=2;
  mapName[3]="Hard";
  mapID[3]=3;
  mapName[4]="Very Hard";
  mapID[4]=4;
}
void ScoreMap::TypeBossPracticeSelect(){
  scoreFile->SortList(SCORE_ELEMENT_SEC,SCORE_FORM_ASCEND);
  scoreFile->SortList(SCORE_ELEMENT_LIFE,SCORE_FORM_ASCEND);
  scoreType=SCOREMAP_SCORETYPE_BOSSPRACTICE;
  Map->state=SCOREMAP_STATE_BOSSTYPE;
}
void ScoreMap::TypeCreateStageSelect(){
  int element[10];
  int value[10];
  int mapFlag;
  int i,j;
  
  scoreFile->SortList(SCORE_ELEMENT_SCORE,SCORE_FORM_ASCEND);

  element[0]=SCORE_ELEMENT_MODE;
  value[0]=SCORE_MODE_CREATESTAGE;

  SetScoreElement(&element[0],&value[0],1);
  
  mapMax=0;
  i=0;
  while(i<listSize){
    j=0;
    mapFlag=0;
    while(j<mapMax){
      if(mapID[j]==scoreList[i]->stageID){
	mapFlag=1;
      }
      j++;
    }
    if(mapFlag){
      
    }
    else{
      mapID[mapMax]=scoreList[i]->stageID;
      mapName[mapMax]=CallName(scoreList[i]->stage);
      mapMax++;
    }
    if(mapMax>=SCOREMAP_MAP_MAX){
      mapMax=SCOREMAP_MAP_MAX;
      break;
    }
    i++;
  }

  if(mapMax>0){
    scoreType=SCOREMAP_SCORETYPE_CREATESTAGE;
    Map->state0=Map->state;
    Map->state=SCOREMAP_STATE_SCORESHIFT;
  }
  else{
    
  }
}
void (ScoreMap::*ScoreMap::SCOREMAP_SCORETYPE_SELECT
      [SCOREMAP_SCORETYPE_NUM])()={
	&ScoreMap::TypeStreamSelect,
	&ScoreMap::TypeBossPracticeSelect,
	&ScoreMap::TypeCreateStageSelect
      };

void ScoreMap::ScoreTypeSelect(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  std::stringstream ss;
  int px0,py0;
  int px1,py1;
  int tmpX;

  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(350)/MAP_YMAX;
  text->DrawString("SCORE SELECT",color->white,px0,py0,
		   FONT_LINE_CENTER,20,
		   FONT_SERIF,FONT_FACE_ITALIC);

  px1=WIDTH*(SCOREMAP_SCORETYPE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(SCOREMAP_SCORETYPE_PY1+SCOREMAP_SCORETYPE_MY1
	      *SCOREMAP_SCORETYPE_STREAM)/MAP_YMAX;
  text->DrawString
    ("STREAM",color->white,px0,py0,
     SCOREMAP_SCORETYPE_LF1,SCOREMAP_SCORETYPE_SF1,
     SCOREMAP_SCORETYPE_TF1,SCOREMAP_SCORETYPE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(SCOREMAP_SCORETYPE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(SCOREMAP_SCORETYPE_PY1+SCOREMAP_SCORETYPE_MY1
	      *SCOREMAP_SCORETYPE_BOSSPRACTICE)/MAP_YMAX;
  text->DrawString
    ("BOSS PRACTICE",color->white,px0,py0,
     SCOREMAP_SCORETYPE_LF1,SCOREMAP_SCORETYPE_SF1,
     SCOREMAP_SCORETYPE_TF1,SCOREMAP_SCORETYPE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(SCOREMAP_SCORETYPE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(SCOREMAP_SCORETYPE_PY1+SCOREMAP_SCORETYPE_MY1
	      *SCOREMAP_SCORETYPE_CREATESTAGE)/MAP_YMAX;
  text->DrawString
    ("CREATE STAGE",color->white,px0,py0,
     SCOREMAP_SCORETYPE_LF1,SCOREMAP_SCORETYPE_SF1,
     SCOREMAP_SCORETYPE_TF1,SCOREMAP_SCORETYPE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  StepSelectAction(&tmpX,&Map->valueY[SCOREMAP_VY_STATE_SCORETYPE]);

  if(Map->valueY[SCOREMAP_VY_STATE_SCORETYPE]<0){
    Map->valueY[SCOREMAP_VY_STATE_SCORETYPE]=
      SCOREMAP_SCORETYPE_NUM-1;
  }
  else if(Map->valueY[SCOREMAP_VY_STATE_SCORETYPE]>=
	  SCOREMAP_SCORETYPE_NUM){
    Map->valueY[SCOREMAP_VY_STATE_SCORETYPE]=0;
  }

  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,
     WIDTH*(400)/MAP_XMAX,
     HEIGHT*(SCOREMAP_SCORETYPE_PY1
	     +SCOREMAP_SCORETYPE_MY1
	     *Map->valueY[SCOREMAP_VY_STATE_SCORETYPE])/MAP_YMAX);

  mWindow->invalidate_rect(rect,false);
  
  if(control->okValue>0){
    control->okValue=0;
    (this->*SCOREMAP_SCORETYPE_SELECT
     [Map->valueY[SCOREMAP_VY_STATE_SCORETYPE]])();
  }
  else if(control->cancelValue>0){
    control->cancelValue=0;
    Map->ChangeType(SELECT_MAP_TITLE);
  }
}

void ScoreMap::BossTypeSilkHatSelect(){
  Map->state0=Map->state;
  Map->state=SCOREMAP_STATE_SCORESHIFT;
  mapNum=0;
  mapMax=5;
  mapName[0]="SilkHat VeryEasy";
  mapID[0]=0;
  mapName[1]="SilkHat Easy";
  mapID[1]=1;
  mapName[2]="SilkHat Normal";
  mapID[2]=2;
  mapName[3]="SilkHat Hard";
  mapID[3]=3;
  mapName[4]="SilkHat VeryHard";
  mapID[4]=4;
}
void ScoreMap::BossTypeCrowdSelect(){
  Map->state0=Map->state;
  Map->state=SCOREMAP_STATE_SCORESHIFT;
  mapNum=0;
  mapMax=5;
  mapName[0]="Crowd VeryEasy";
  mapID[0]=8;
  mapName[1]="Crowd Easy";
  mapID[1]=9;
  mapName[2]="Crowd Normal";
  mapID[2]=10;
  mapName[3]="Crowd Hard";
  mapID[3]=11;
  mapName[4]="Crowd VeryHard";
  mapID[4]=12;
}
void ScoreMap::BossTypeEagleSelect(){
  Map->state0=Map->state;
  Map->state=SCOREMAP_STATE_SCORESHIFT;
  mapNum=0;
  mapMax=5;
  mapName[0]="Eagle VeryEasy";
  mapID[0]=16;
  mapName[1]="Eagle Easy";
  mapID[1]=17;
  mapName[2]="Eagle Normal";
  mapID[2]=18;
  mapName[3]="Eagle Hard";
  mapID[3]=19;
  mapName[4]="Eagle VeryHard";
  mapID[4]=20;
}
void (ScoreMap::*ScoreMap::SCOREMAP_BOSSTYPE_SELECT
      [SCOREMAP_BOSSTYPE_NUM])()={
	&ScoreMap::BossTypeSilkHatSelect,
	&ScoreMap::BossTypeCrowdSelect,
	&ScoreMap::BossTypeEagleSelect
      };

void ScoreMap::BossTypeSelect(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);
  std::stringstream ss;
  int px0,py0;
  int px1,py1;
  int tmpX;

  frame->draw_rectangle(blackGC,true,0,0,WIDTH,HEIGHT);
  
  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(350)/MAP_YMAX;
  text->DrawString("BOSS SELECT",color->white,px0,py0,
		   FONT_LINE_CENTER,20,
		   FONT_SERIF,FONT_FACE_ITALIC);

  px1=WIDTH*(SCOREMAP_BOSSTYPE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(SCOREMAP_BOSSTYPE_PY1+SCOREMAP_BOSSTYPE_MY1
	      *SCOREMAP_BOSSTYPE_SILKHAT)/MAP_YMAX;
  text->DrawString
    ("SILKHAT",color->white,px0,py0,
     SCOREMAP_BOSSTYPE_LF1,SCOREMAP_BOSSTYPE_SF1,
     SCOREMAP_BOSSTYPE_TF1,SCOREMAP_BOSSTYPE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(SCOREMAP_BOSSTYPE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(SCOREMAP_BOSSTYPE_PY1+SCOREMAP_BOSSTYPE_MY1
	      *SCOREMAP_BOSSTYPE_CROWD)/MAP_YMAX;
  text->DrawString
    ("CROWD",color->white,px0,py0,
     SCOREMAP_BOSSTYPE_LF1,SCOREMAP_BOSSTYPE_SF1,
     SCOREMAP_BOSSTYPE_TF1,SCOREMAP_BOSSTYPE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  px1=WIDTH*(SCOREMAP_BOSSTYPE_PX1)/MAP_XMAX;
  px0=px1;
  py0=HEIGHT*(SCOREMAP_BOSSTYPE_PY1+SCOREMAP_BOSSTYPE_MY1
	      *SCOREMAP_BOSSTYPE_EAGLE)/MAP_YMAX;
  text->DrawString
    ("EAGLE",color->white,px0,py0,
     SCOREMAP_BOSSTYPE_LF1,SCOREMAP_BOSSTYPE_SF1,
     SCOREMAP_BOSSTYPE_TF1,SCOREMAP_BOSSTYPE_FF1);
  ss.str("");
  ss.clear(std::stringstream::goodbit);

  StepSelectAction(&tmpX,&Map->valueY[SCOREMAP_VY_STATE_BOSSTYPE]);

  if(Map->valueY[SCOREMAP_VY_STATE_BOSSTYPE]<0){
    Map->valueY[SCOREMAP_VY_STATE_BOSSTYPE]=
      SCOREMAP_BOSSTYPE_NUM-1;
  }
  else if(Map->valueY[SCOREMAP_VY_STATE_BOSSTYPE]>=
	  SCOREMAP_BOSSTYPE_NUM){
    Map->valueY[SCOREMAP_VY_STATE_BOSSTYPE]=0;
  }

  enemyList->DrawSprite
    (EN_REV_BIRD,EN_WAY_B,2,
     WIDTH*(400)/MAP_XMAX,
     HEIGHT*(SCOREMAP_BOSSTYPE_PY1
	     +SCOREMAP_BOSSTYPE_MY1
	     *Map->valueY[SCOREMAP_VY_STATE_BOSSTYPE])/MAP_YMAX);

  mWindow->invalidate_rect(rect,false);
  
  if(control->okValue>0){
    control->okValue=0;
    (this->*SCOREMAP_BOSSTYPE_SELECT
     [Map->valueY[SCOREMAP_VY_STATE_BOSSTYPE]])();
  }
  else if(control->cancelValue>0){
    control->cancelValue=0;
    Map->state=SCOREMAP_STATE_SCORETYPE;
  }
}

void ScoreMap::TypeStreamView(){
  StreamList(mapName[mapNum],&Map->valueY[SCOREMAP_VY_STATE_SCOREVIEW]);
}
void ScoreMap::TypeBossPracticeView(){
  BossPracticeList(mapName[mapNum],
		   &Map->valueY[SCOREMAP_VY_STATE_SCOREVIEW]);
}
void ScoreMap::TypeCreateStageView(){
  CreateStageList(mapName[mapNum],
		  &Map->valueY[SCOREMAP_VY_STATE_SCOREVIEW]);
}
void (ScoreMap::*ScoreMap::SCOREMAP_TYPEVIEW_SELECT
      [SCOREMAP_SCORETYPE_NUM])()={
	&ScoreMap::TypeStreamView,
	&ScoreMap::TypeBossPracticeView,
	&ScoreMap::TypeCreateStageView
};

void ScoreMap::ScoreView(){
  Gdk::Rectangle rect(0,0,WIDTH,HEIGHT);

  if(background){
    frame->draw_pixbuf
      (mGC,background,0,0,0,0,WIDTH,HEIGHT,
       Gdk::RGB_DITHER_NONE,0,0);
  }
  else{
    frame->draw_rectangle(backGC,true,0,0,WIDTH,HEIGHT);
  }

  (this->*SCOREMAP_TYPEVIEW_SELECT[scoreType])();

  if(control->cancelValue){
    control->cancelValue=0;
    Map->state=Map->state0;
  }
  
  mWindow->invalidate_rect(rect,false);  
}

void ScoreMap::TypeStreamShift(){
  int element[10];
  int value[10];

  element[0]=SCORE_ELEMENT_MODE;
  value[0]=SCORE_MODE_STREAM;
  element[1]=SCORE_ELEMENT_STAGEID;
  value[1]=mapID[mapNum];

  SetScoreElement(&element[0],&value[0],2);
}
void ScoreMap::TypeBossPracticeShift(){
  int element[10];
  int value[10];

  element[0]=SCORE_ELEMENT_MODE;
  value[0]=SCORE_MODE_BOSSPRACTICE;
  element[1]=SCORE_ELEMENT_STAGEID;
  value[1]=mapID[mapNum];

  SetScoreElement(&element[0],&value[0],2);
}
void ScoreMap::TypeCreateStageShift(){
  int element[10];
  int value[10];

  element[0]=SCORE_ELEMENT_MODE;
  value[0]=SCORE_MODE_CREATESTAGE;
  element[1]=SCORE_ELEMENT_STAGEID;
  value[1]=mapID[mapNum];

  SetScoreElement(&element[0],&value[0],2);
}
void (ScoreMap::*ScoreMap::SCOREMAP_TYPESHIFT_SELECT
      [SCOREMAP_SCORETYPE_NUM])()={
	&ScoreMap::TypeStreamShift,
	&ScoreMap::TypeBossPracticeShift,
	&ScoreMap::TypeCreateStageShift
};

void ScoreMap::ShiftScore(){
  if(mapNum<0){
    mapNum=mapMax-1;
  }
  else if(mapNum>=mapMax){
    mapNum=0;
  }

  (this->*SCOREMAP_TYPESHIFT_SELECT[scoreType])();
  Map->state=SCOREMAP_STATE_SCOREVIEW;
}

void (ScoreMap::*ScoreMap::SCOREMAP_STATE_SELECT[SCOREMAP_STATE_NUM])()={
  &ScoreMap::ScoreTypeSelect,
  &ScoreMap::BossTypeSelect,
  &ScoreMap::ScoreView,
  &ScoreMap::ShiftScore
};

void ScoreMap::ViewMap(){
  (this->*SCOREMAP_STATE_SELECT[Map->state])();
}

void ScoreMap::StreamList(std::string title,int *movY0){
  BirdScore *node;
  BirdScore *tmp;
  std::stringstream ss;
  std::string str;
  int px0,py0;
  int px1,py1;
  int selectTmp=0;
  int i;
  int Index0=0;
  int maxY,lenY,startY;
  int Dist;
  int tMY0,tMovY;

  
  tMY0=HEIGHT*(SCOREMAP_STREAM_MY2)/MAP_YMAX;
  startY=HEIGHT*(SCOREMAP_STREAM_PY2)/MAP_YMAX;
  lenY=HEIGHT-startY;
  maxY=tMY0*listSize;

  ScoreMapSelectAction
    (control->selectValue,
     &selectTmp,movY0,20);

  if(maxY<lenY){
    *movY0=0;
  }
  else{
    if(*movY0<0){
      *movY0=0;
    }
    else if(*movY0>maxY-lenY){
      *movY0=maxY-lenY;
    }
  }

  tMovY=*movY0;

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(120)/MAP_YMAX-tMovY;
  text->DrawString
    (title.c_str(),(color->white),px0,py0,FONT_LINE_CENTER,
     35,FONT_SERIF,FONT_FACE_ITALIC);

  px0=WIDTH*(SCOREMAP_STREAM_PX1+SCOREMAP_STREAM_MX1
	     *SCOREMAP_STREAM_RANK)/MAP_XMAX;
  py1=HEIGHT*(SCOREMAP_STREAM_PY1)/MAP_YMAX-tMovY;
  py0=py1;
  text->DrawString
    ("RANK",(color->white),px0,py0,
     SCOREMAP_STREAM_LF1,SCOREMAP_STREAM_SF1,
     SCOREMAP_STREAM_TF1,SCOREMAP_STREAM_FF1);
  
  px0=WIDTH*(SCOREMAP_STREAM_PX1+SCOREMAP_STREAM_MX1
	     *SCOREMAP_STREAM_SCORE)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("SCORE",(color->white),px0,py0,
     SCOREMAP_STREAM_LF1,SCOREMAP_STREAM_SF1,
     SCOREMAP_STREAM_TF1,SCOREMAP_STREAM_FF1);
  
  px0=WIDTH*(SCOREMAP_STREAM_PX1+SCOREMAP_STREAM_MX1
	     *SCOREMAP_STREAM_STAGE)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("STAGE",(color->white),px0,py0,
     SCOREMAP_STREAM_LF1,SCOREMAP_STREAM_SF1,
     SCOREMAP_STREAM_TF1,SCOREMAP_STREAM_FF1);

  px0=WIDTH*(SCOREMAP_STREAM_PX1+SCOREMAP_STREAM_MX1
	     *SCOREMAP_STREAM_NAME)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("NAME",(color->white),px0,py0,
     SCOREMAP_STREAM_LF1,SCOREMAP_STREAM_SF1,
     SCOREMAP_STREAM_TF1,SCOREMAP_STREAM_FF1);

  Dist=tMovY-startY;

  if(Dist>0){
    Index0=Dist/(tMY0);
    tMovY=tMovY-Index0*tMY0;
  }
  else{
    Index0=0;
  }

  i=Index0;
  while(i<(Index0+SCOREMAP_STREAM_MAX)){
    if(scoreList[i]==NULL){
      break;
    }
    else{
      px0=WIDTH*(SCOREMAP_STREAM_PX2+SCOREMAP_STREAM_MX2
		 *SCOREMAP_STREAM_RANK)/MAP_XMAX;
      py1=HEIGHT*(SCOREMAP_STREAM_PY2
		  +SCOREMAP_STREAM_MY2*(i-Index0))/MAP_YMAX-tMovY;
      if(py1>HEIGHT){
	break;
      }
      py0=py1;
      ss<<i+1;
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
       SCOREMAP_STREAM_LF2,SCOREMAP_STREAM_SF2,
       SCOREMAP_STREAM_TF2,SCOREMAP_STREAM_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

      px0=WIDTH*(SCOREMAP_STREAM_PX2+SCOREMAP_STREAM_MX2
		 *SCOREMAP_STREAM_SCORE)/MAP_XMAX;
      py0=py1;
      ss<<scoreList[i]->score;
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
	 SCOREMAP_STREAM_LF2,SCOREMAP_STREAM_SF2,
	 SCOREMAP_STREAM_TF2,SCOREMAP_STREAM_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

      px0=WIDTH*(SCOREMAP_STREAM_PX2+SCOREMAP_STREAM_MX2
		 *SCOREMAP_STREAM_STAGE)/MAP_XMAX;
      py0=py1;
      ss<<CallName(scoreList[i]->stage);
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
	 SCOREMAP_STREAM_LF2,SCOREMAP_STREAM_SF2,
	 SCOREMAP_STREAM_TF2,SCOREMAP_STREAM_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

      px0=WIDTH*(SCOREMAP_STREAM_PX2+SCOREMAP_STREAM_MX2
		 *SCOREMAP_STREAM_NAME)/MAP_XMAX;
      py0=py1;
      ss<<CallName(scoreList[i]->name);
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
	 SCOREMAP_STREAM_LF2,SCOREMAP_STREAM_SF2,
	 SCOREMAP_STREAM_TF2,SCOREMAP_STREAM_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

    }
    i++;
  }
}

void ScoreMap::BossPracticeList(std::string title,int *movY0){
  BirdScore *node;
  BirdScore *tmp;
  std::stringstream ss;
  std::string str;
  int px0,py0;
  int px1,py1;
  int selectTmp=0;
  int i;
  int Index0=0;
  int maxY,lenY,startY;
  int Dist;
  int tMY0,tMovY;

  
  tMY0=HEIGHT*(SCOREMAP_BOSSPRACTICE_MY2)/MAP_YMAX;
  startY=HEIGHT*(SCOREMAP_BOSSPRACTICE_PY2)/MAP_YMAX;
  lenY=HEIGHT-startY;
  maxY=tMY0*listSize;

  ScoreMapSelectAction
    (control->selectValue,
     &selectTmp,movY0,20);

  if(maxY<lenY){
    *movY0=0;
  }
  else{
    if(*movY0<0){
      *movY0=0;
    }
    else if(*movY0>maxY-lenY){
      *movY0=maxY-lenY;
    }
  }

  tMovY=*movY0;

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(120)/MAP_YMAX-tMovY;
  text->DrawString
    (title.c_str(),(color->white),px0,py0,FONT_LINE_CENTER,
     35,FONT_SERIF,FONT_FACE_ITALIC);

  px0=WIDTH*(SCOREMAP_BOSSPRACTICE_PX1+SCOREMAP_BOSSPRACTICE_MX1
	     *SCOREMAP_BOSSPRACTICE_RANK)/MAP_XMAX;
  py1=HEIGHT*(SCOREMAP_BOSSPRACTICE_PY1)/MAP_YMAX-tMovY;
  py0=py1;
  text->DrawString
    ("RANK",(color->white),px0,py0,
     SCOREMAP_BOSSPRACTICE_LF1,SCOREMAP_BOSSPRACTICE_SF1,
     SCOREMAP_BOSSPRACTICE_TF1,SCOREMAP_BOSSPRACTICE_FF1);
  
  px0=WIDTH*(SCOREMAP_BOSSPRACTICE_PX1+SCOREMAP_BOSSPRACTICE_MX1
	     *SCOREMAP_BOSSPRACTICE_SEC)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("SEC",(color->white),px0,py0,
     SCOREMAP_BOSSPRACTICE_LF1,SCOREMAP_BOSSPRACTICE_SF1,
     SCOREMAP_BOSSPRACTICE_TF1,SCOREMAP_BOSSPRACTICE_FF1);
  
  px0=WIDTH*(SCOREMAP_BOSSPRACTICE_PX1+SCOREMAP_BOSSPRACTICE_MX1
	     *SCOREMAP_BOSSPRACTICE_DEAD)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("DEAD",(color->white),px0,py0,
     SCOREMAP_BOSSPRACTICE_LF1,SCOREMAP_BOSSPRACTICE_SF1,
     SCOREMAP_BOSSPRACTICE_TF1,SCOREMAP_BOSSPRACTICE_FF1);
  
  px0=WIDTH*(SCOREMAP_BOSSPRACTICE_PX1+SCOREMAP_BOSSPRACTICE_MX1
	     *SCOREMAP_BOSSPRACTICE_NAME)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("NAME",(color->white),px0,py0,
     SCOREMAP_BOSSPRACTICE_LF1,SCOREMAP_BOSSPRACTICE_SF1,
     SCOREMAP_BOSSPRACTICE_TF1,SCOREMAP_BOSSPRACTICE_FF1);



  Dist=tMovY-startY;

  if(Dist>0){
    Index0=Dist/(tMY0);
    tMovY=tMovY-Index0*tMY0;
  }
  else{
    Index0=0;
  }

  i=Index0;
  while(i<(Index0+SCOREMAP_BOSSPRACTICE_MAX)){
    if(scoreList[i]==NULL){
      break;
    }
    else{
      px0=WIDTH*(SCOREMAP_BOSSPRACTICE_PX2+SCOREMAP_BOSSPRACTICE_MX2
		 *SCOREMAP_BOSSPRACTICE_RANK)/MAP_XMAX;
      py1=HEIGHT*(SCOREMAP_BOSSPRACTICE_PY2
		  +SCOREMAP_BOSSPRACTICE_MY2*(i-Index0))/MAP_YMAX-tMovY;
      if(py1>HEIGHT){
	break;
      }
      py0=py1;
      ss<<i+1;
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
       SCOREMAP_BOSSPRACTICE_LF2,SCOREMAP_BOSSPRACTICE_SF2,
       SCOREMAP_BOSSPRACTICE_TF2,SCOREMAP_BOSSPRACTICE_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

      px0=WIDTH*(SCOREMAP_BOSSPRACTICE_PX2+SCOREMAP_BOSSPRACTICE_MX2
		 *SCOREMAP_BOSSPRACTICE_SEC)/MAP_XMAX;
      py0=py1;
      ss<<(scoreList[i]->sec)/50<<".";
      ss<<(scoreList[i]->sec/5)%10;
      ss<<(scoreList[i]->sec*2)%10;
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
	 SCOREMAP_BOSSPRACTICE_LF2,SCOREMAP_BOSSPRACTICE_SF2,
	 SCOREMAP_BOSSPRACTICE_TF2,SCOREMAP_BOSSPRACTICE_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

      px0=WIDTH*(SCOREMAP_BOSSPRACTICE_PX2+SCOREMAP_BOSSPRACTICE_MX2
		 *SCOREMAP_BOSSPRACTICE_DEAD)/MAP_XMAX;
      py0=py1;
      ss<<scoreList[i]->life*-1;
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
	 SCOREMAP_BOSSPRACTICE_LF2,SCOREMAP_BOSSPRACTICE_SF2,
	 SCOREMAP_BOSSPRACTICE_TF2,SCOREMAP_BOSSPRACTICE_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

      px0=WIDTH*(SCOREMAP_BOSSPRACTICE_PX2+SCOREMAP_BOSSPRACTICE_MX2
		 *SCOREMAP_BOSSPRACTICE_NAME)/MAP_XMAX;
      py0=py1;
      ss<<CallName(scoreList[i]->name);
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
	 SCOREMAP_BOSSPRACTICE_LF2,SCOREMAP_BOSSPRACTICE_SF2,
	 SCOREMAP_BOSSPRACTICE_TF2,SCOREMAP_BOSSPRACTICE_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

    }
    i++;
  }
}

void ScoreMap::CreateStageList(std::string title,int *movY0){
  BirdScore *node;
  BirdScore *tmp;
  std::stringstream ss;
  std::string str;
  int px0,py0;
  int px1,py1;
  int selectTmp=0;
  int i;
  int Index0=0;
  int maxY,lenY,startY;
  int Dist;
  int tMY0,tMovY;

  
  tMY0=HEIGHT*(SCOREMAP_CREATESTAGE_MY2)/MAP_YMAX;
  startY=HEIGHT*(SCOREMAP_CREATESTAGE_PY2)/MAP_YMAX;
  lenY=HEIGHT-startY;
  maxY=tMY0*listSize;

  ScoreMapSelectAction
    (control->selectValue,
     &selectTmp,movY0,20);

  if(maxY<lenY){
    *movY0=0;
  }
  else{
    if(*movY0<0){
      *movY0=0;
    }
    else if(*movY0>maxY-lenY){
      *movY0=maxY-lenY;
    }
  }

  tMovY=*movY0;

  px0=WIDTH*(500)/MAP_XMAX;
  py0=HEIGHT*(120)/MAP_YMAX-tMovY;
  text->DrawString
    (title.c_str(),(color->white),px0,py0,FONT_LINE_CENTER,
     35,FONT_SERIF,FONT_FACE_ITALIC);

  px0=WIDTH*(SCOREMAP_CREATESTAGE_PX1+SCOREMAP_CREATESTAGE_MX1
	     *SCOREMAP_CREATESTAGE_RANK)/MAP_XMAX;
  py1=HEIGHT*(SCOREMAP_CREATESTAGE_PY1)/MAP_YMAX-tMovY;
  py0=py1;
  text->DrawString
    ("RANK",(color->white),px0,py0,
     SCOREMAP_CREATESTAGE_LF1,SCOREMAP_CREATESTAGE_SF1,
     SCOREMAP_CREATESTAGE_TF1,SCOREMAP_CREATESTAGE_FF1);
  
  px0=WIDTH*(SCOREMAP_CREATESTAGE_PX1+SCOREMAP_CREATESTAGE_MX1
	     *SCOREMAP_CREATESTAGE_SCORE)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("SCORE",(color->white),px0,py0,
     SCOREMAP_CREATESTAGE_LF1,SCOREMAP_CREATESTAGE_SF1,
     SCOREMAP_CREATESTAGE_TF1,SCOREMAP_CREATESTAGE_FF1);

  px0=WIDTH*(SCOREMAP_CREATESTAGE_PX1+SCOREMAP_CREATESTAGE_MX1
	     *SCOREMAP_CREATESTAGE_SEC)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("SEC",(color->white),px0,py0,
     SCOREMAP_CREATESTAGE_LF1,SCOREMAP_CREATESTAGE_SF1,
     SCOREMAP_CREATESTAGE_TF1,SCOREMAP_CREATESTAGE_FF1);
  
  px0=WIDTH*(SCOREMAP_CREATESTAGE_PX1+SCOREMAP_CREATESTAGE_MX1
	     *SCOREMAP_CREATESTAGE_NAME)/MAP_XMAX;
  py0=py1;
  text->DrawString
    ("NAME",(color->white),px0,py0,
     SCOREMAP_CREATESTAGE_LF1,SCOREMAP_CREATESTAGE_SF1,
     SCOREMAP_CREATESTAGE_TF1,SCOREMAP_CREATESTAGE_FF1);

  Dist=tMovY-startY;

  if(Dist>0){
    Index0=Dist/(tMY0);
    tMovY=tMovY-Index0*tMY0;
  }
  else{
    Index0=0;
  }

  i=Index0;
  while(i<(Index0+SCOREMAP_CREATESTAGE_MAX)){
    if(scoreList[i]==NULL){
      break;
    }
    else{
      px0=WIDTH*(SCOREMAP_CREATESTAGE_PX2+SCOREMAP_CREATESTAGE_MX2
		 *SCOREMAP_CREATESTAGE_RANK)/MAP_XMAX;
      py1=HEIGHT*(SCOREMAP_CREATESTAGE_PY2
		  +SCOREMAP_CREATESTAGE_MY2*(i-Index0))/MAP_YMAX-tMovY;
      if(py1>HEIGHT){
	break;
      }
      py0=py1;
      ss<<i+1;
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
       SCOREMAP_CREATESTAGE_LF2,SCOREMAP_CREATESTAGE_SF2,
       SCOREMAP_CREATESTAGE_TF2,SCOREMAP_CREATESTAGE_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

      px0=WIDTH*(SCOREMAP_CREATESTAGE_PX2+SCOREMAP_CREATESTAGE_MX2
		 *SCOREMAP_CREATESTAGE_SCORE)/MAP_XMAX;
      py0=py1;
      ss<<scoreList[i]->score;
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
	 SCOREMAP_CREATESTAGE_LF2,SCOREMAP_CREATESTAGE_SF2,
	 SCOREMAP_CREATESTAGE_TF2,SCOREMAP_CREATESTAGE_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

      px0=WIDTH*(SCOREMAP_CREATESTAGE_PX2+SCOREMAP_CREATESTAGE_MX2
		 *SCOREMAP_CREATESTAGE_SEC)/MAP_XMAX;
      py0=py1;
      if(scoreList[i]->life){
	ss<<"Clear";
      }
      else{
	ss<<(scoreList[i]->sec)/50<<".";
	ss<<(scoreList[i]->sec/5)%10;
	ss<<(scoreList[i]->sec*2)%10;
      }
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
	 SCOREMAP_CREATESTAGE_LF2,SCOREMAP_CREATESTAGE_SF2,
	 SCOREMAP_CREATESTAGE_TF2,SCOREMAP_CREATESTAGE_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

      px0=WIDTH*(SCOREMAP_CREATESTAGE_PX2+SCOREMAP_CREATESTAGE_MX2
		 *SCOREMAP_CREATESTAGE_NAME)/MAP_XMAX;
      py0=py1;
      ss<<CallName(scoreList[i]->name);
      str=ss.str();
      text->DrawString
	(str,(color->white),px0,py0,
	 SCOREMAP_CREATESTAGE_LF2,SCOREMAP_CREATESTAGE_SF2,
	 SCOREMAP_CREATESTAGE_TF2,SCOREMAP_CREATESTAGE_FF2);
      ss.str("");
      ss.clear(std::stringstream::goodbit);

    }
    i++;
  }
}
