#ifndef BIRD_SPRITE_H_
#define BIRD_SPRITE_H_

#include <gtkmm.h>

class BirdSprite{
 public:
  Glib::RefPtr<Gdk::Pixbuf> pixbuf;
  char **xpm;
  int width;
  int height;
};

class SpriteBox{
 public:
  BirdSprite *sprite;
  int nSeq;
  int nLength;
  SpriteBox(BirdSprite *sprite0,int nSeq0,int nLength0);
  ~SpriteBox();

  Glib::RefPtr<Gdk::Pixbuf> SpriteScale
    (char **xpm0,int width0,int height0);
  
  void SetSprite();
  void SetSprite(int width0,int height0);



  void DrawSprite(Glib::RefPtr<Gdk::Pixmap> frame,
		  Glib::RefPtr<Gdk::GC> gc,
		  int px,int py,int seq);
  void DrawScale(Glib::RefPtr<Gdk::Pixmap> frame,
		  Glib::RefPtr<Gdk::GC> gc,
		 int px,int py,int seq,
		 int width,int height);
};

#endif
